<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods Email AJax
 * @version 2.0.0
 * @author Dongjie Xu
 * @package simpods-mvc
 * @since 11/04/2018
 */
class Pods_Manage_Simpods_Email {
	private $page_size 		= 100;
	protected $magic_fields	= array();
	public function __construct() {
					
		// logged in users only, 
		add_action( 'wp_ajax_simpods_email', array( $this, 'simpods_email' ) );	

	}
	/**
	 * simpods email function
	 * @return null
	 */
	public function simpods_email() {
		global $current_user, $funs, $cross_admin, $simpods_email;
		if ( $_POST['action'] != 'simpods_email_ajax' && !is_numeric( $_POST['id'] ) ) {
			wp_send_json_error( __( 'Invalid Parameters', 'simpods-mvc' ), 400 );
		}
		if ( wp_verify_nonce( $_POST['nonce'], 'simpods-email-nonce' ) === false ) {
		 	wp_send_json_error( __( 'Nonce verification failed', 'simpods-mvc' ), 403 );
		}
		if ( !in_array('administrator',  $current_user->roles ) && ! $current_user->has_cap( 'simpods_button_field' ) ){
			wp_send_json_error( __( 'No allowed', 'simpods-mvc' ), 403 );
		}
		$is_emailed		= false;
		$try_count     	= 0;
		$send_count    	= 0;
		$not_sent_count = 0;
		//$fields  = array( 'id' => $_POST['id'] );
		//$attrs   = array( 'target_tb' => 'pods_simpods_email' );
		$to_addresses	= ''; 		
		$cc_addresses	= ''; 
		$bcc_addresses	= ''; 
		
		$now					= date("Y-m-d H:i:s"); 
		$admin_simpods_email	= new MVC_Admin_Simpods_Email( false );
			
		$destinations	= array( 'tos' => '', 'ccs' => '', 'bccs' => '' );
		$_POST['users']	= $admin_simpods_email->email_addresses( array(), trim( trim( $_POST['users'] ), ',' ) ); 
		if( empty( $_POST['group_id'] ) ){
			$_POST['group_id'] = time ();
		}
		if( ! empty( $_POST['test_only'] ) ){		
			
			switch ( $_POST['recipients_field'] ) {
				case 'to_email':
					$to_addresses 	= $_POST['users'];
					break;
				case 'cc':
					$cc_addresses 	= $_POST['users'];
					break;		
				case 'bcc':
					$bcc_addresses 	= $_POST['users'];
					break;									
				default:
					$to_addresses 	= $_POST['users'];
					break;
			}
		} else {
			$to_addresses	=	$admin_simpods_email->email_addresses( array(), trim( $_POST['to_email'], ',' ) ); 		
			$cc_addresses	=	$admin_simpods_email->email_addresses( array(), trim( $_POST['cc'], ',' ) ); 
			$bcc_addresses	=	$admin_simpods_email->email_addresses( array(), trim( $_POST['bcc'], ',' ) ); 
			$user_address	=	'';		
			if( !empty( $_POST['users'] ) ){
				$user_address .= ',' . $_POST['users']; 
			}
			$user_roles = array();
			if( ! empty( $_POST['user_role'] ) ){
				$user_roles = $_POST['user_role'];
			
				switch ( $_POST['recipients_field'] ) {
					case 'to_email':
						$to_addresses 	.= $user_address ;
						$to_addresses 	= $admin_simpods_email->email_addresses( $user_roles ) . $to_addresses;
						break;
					case 'cc':
						$cc_addresses 	.= $user_address ;
						$cc_addresses 	= $admin_simpods_email->email_addresses( $user_roles ) . $cc_addresses;
						break;		
					case 'bcc':
						$bcc_addresses 	.= $user_address ;
						$bcc_addresses 	= $admin_simpods_email->email_addresses( $user_roles ) . $bcc_addresses;
						break;									
					default:
						$to_addresses 	.= $user_address ;
						$to_addresses 	= $admin_simpods_email->email_addresses( $user_roles ) . $to_addresses;
						break;
				}
			}
			
		}
		
		if( !empty( $to_addresses ) || !empty( $cc_addresses ) || !empty( $bcc_addresses ) ){
			$destinations	=	array( 'tos' => $to_addresses, 'ccs' => $cc_addresses, 'bccs' => $bcc_addresses );
			$from_name 		= 	'';  // leave both empty to use admin email     
			$from_address 	= 	'';
			if( is_email( $_POST['from'] ) ){
				$from_address 	= 	$_POST['from'];  // has to be an email from the same domain for normal html email.						
			}
			$to_name 			= 	'';        
			   
			$subject		= 	wp_strip_all_tags( $_POST['subject'], true );
			//$description 	= 	apply_filters( 'the_content', $_POST['content'] ); 
			$description 	= 	nl2br( stripslashes_deep( $_POST['content'] ) );
			if( $_POST['test_only'] ){		
				$description .= "\r\n" . '<br/> -- This is a testing email. -- ';
			}
			$this->magic_field_replace( $_POST['magic_field_replace'] );		
			$subject 		= $this->replace_magic_field( $this->magic_fields, $subject );
			$description 	= $this->replace_magic_field( $this->magic_fields, $description );			
			$original_description	= $description;
			$sent_records			= array();
			$not_sent_records		= array();
			$total_emails			= 0;
			// Calculate how many emails
			foreach( $destinations as $destination_type => $emails_imploded ){ 
				
				if( !empty( $emails_imploded ) ){
					
					$destinations[ $destination_type ]	= explode( ',', $emails_imploded );
					$total_emails	+= count( $destinations[ $destination_type ] );
				} else {
					$destinations[ $destination_type ] = array();
				}
			}
			if( $_POST['send_type'] == 'Bulk' ){
				if( ! empty( $_POST['how_many'] ) && is_numeric( $_POST['how_many'] ) ){
					$this->page_size = 	$_POST['how_many'];
				} else {
					$this->page_size = 40; //SiteGround server limits it to 40 for normal hosting package. Use 40 as the default.
				}
			}
			if( empty( $_POST['start_from'] ) || $_POST['start_from'] < 1 ){
				$_POST['start_from'] = 1;
			}
			$_POST['start_from'] = intval( $_POST['start_from'] ) - 1;	// the field takes number from 1 to make more sense to human
			$total_page = ceil( ( $total_emails - $_POST['start_from'] ) / $this->page_size );
			$now 		= date("Y-m-d H:i:s");
			$to_address 	=	'';
			$cc_address 	=	'';
			$bcc_address 	=	'';

			$start_from		= $_POST['page'] * $this->page_size + $_POST['start_from'] ;
			$up_to			= ( $_POST['page'] + 1 ) * $this->page_size + $_POST['start_from'] ;
			if( $up_to > $total_emails ){
				$up_to		= $total_emails;
			}	
			$bulk_emails 	= '';
			foreach( $destinations as $destination_type => $emails_imploded ){ 
				if( !empty( $emails_imploded ) ){
					$emails		= $destinations[ $destination_type ];
					$i			= 0;					
					foreach ( $emails as $k => $email ) {
						//$email could be in these formats: <Name> someone@domain.com
						$try_count ++;
						if ( $try_count <= $start_from ){	
							continue;
						}
						// Restore original content	for individual information
						$description	=	$original_description;							
						// breakdown all tos, ccs, bccs
						if( $_POST['send_type'] == 'Individual' ){	
							$to_address 	=	'';
							if(  $destination_type == 'tos' ){
								$to_address 			= 	$email;  	
							}
							$cc_address 	=	'';
							if(  $destination_type == 'ccs' ){
								$cc_address 			= 	$email;  	
							}
							$bcc_address 	=	'';
							if(  $destination_type == 'bccs' ){
								$bcc_address 			= 	$email;  	
							}														
							$to_name			=	'';
							if( stripos( $email, '<') !== false ){
								$to_arr			= 	explode( '<', $email );

								$to_name		=	$to_arr[0];    								
							}

							$description	= 	str_replace( '{name}', $to_name, $description ); 
						} else {								
							if(  $destination_type == 'tos' ){
								$to_address .= 	$email . ',';  	
							}
							
							if(  $destination_type == 'ccs' ){
								$cc_address .= 	$email . ',';  	  	
							}
							
							if(  $destination_type == 'bccs' ){
								$bcc_address .=	$email . ',';  	 	
							}	
							$bulk_emails .= $email . ',';
							// build up emails; Only do it when accumulate the required amount of emails
							if( $up_to > $try_count && $try_count != $total_emails ){
								continue;	
							}
						}
						$is_emailed		=	$simpods_email->email( $from_name, $from_address, $to_name, $to_address, $subject, $description, $cc_address, $bcc_address );	//needed
						if( $is_emailed ){
							$send_count ++;
							if( $_POST['send_type'] == 'Individual' ){	
								array_push(  $sent_records, $email );
							} else {
								array_push(  $sent_records, $bulk_emails );
							}
						} else {

							if( $_POST['send_type'] == 'Individual' ){	
								array_push(  $not_sent_records, $email ); 
							} else {
								array_push(  $not_sent_records, $bulk_emails ); 
							}
						}

						// Split recepients across multiple requests to prevent timeouts. On the last one of each loop or the last one
						if( $up_to == $try_count || ( $up_to != $try_count && $try_count == $total_emails ) ){
							$not_sent_count 	= count( $not_sent_records );
							//email admin about the result 
							$involved_count	= $up_to - $start_from;
							$report 		= esc_html__('Group ID: ', 'simpods-mvc' ) . ' ' . ( $_POST['group_id'] ) . '.<br/>' . 
											  sprintf( esc_html__('Page settings: Page %d, %d per page', 'simpods-mvc' ), ( $_POST['page'] + 1 ), $this->page_size ) . '.<br/>' . 
											  esc_html__('Start from: ', 'simpods-mvc' ) . ' ' . ( $start_from + 1 ). '.<br/>' . 
											  esc_html__('Up to: ', 'simpods-mvc' ) . ' ' . ( $up_to ). '.<br/>' . 
											  esc_html__('User email addresses involved: ', 'simpods-mvc' ) . ' ' . $involved_count . '.<br/>' . 
											  esc_html__('Emails sent: ', 'simpods-mvc' ) . ' ' . $send_count . '.<br/>' . 
											  esc_html__('Emails failed: ', 'simpods-mvc' ) . $not_sent_count;
							if( is_email( $_POST['send_reports_to'] ) ){
								$admin_email 	= $_POST['send_reports_to'];
							} else {
								$admin_email 	= get_bloginfo( 'admin_email' );
							}				  
											  
							$is_admin_mailed 	= $simpods_email->email( get_bloginfo( 'name' ), 'noreply@' . $funs->get_domain(), get_bloginfo( 'name' ), $admin_email, sprintf(  __('Email Report - by %s - page ' , 'simpods-mvc' ), $_POST['send_type'] ) . ( $_POST['page'] + 1 ). '/' . $total_page , $report );	
							$user_role = '';
							if( ! empty( $_POST['user_role'] ) ){
								$user_role  = implode( ',', $_POST['user_role'] );
							}
							$report_record_data	= array(
														'spe_item_id' 			=> $_POST['id'],
														'spe_item_slug' 		=> $_POST['slug'],
														'spe_item_subject' 		=> $_POST['subject'],
														'spe_item_from' 		=> $_POST['from'],
														'spe_to' 				=> $_POST['to_email'],
														'spe_cc' 				=> $_POST['cc'],
														'spe_bcc' 				=> $_POST['bcc'],
														'spe_content'			=> $_POST['content'],
														'spe_instructions' 		=> $_POST['instructions'],
														'spe_test_user_only' 	=> $_POST['test_only'],
														'spe_users' 			=> $_POST['users'],
														'spe_user_roles' 		=> $user_role,
														'spe_recipients_field' 	=> $_POST['recipients_field'],
														'spe_send_type'			=> $_POST['send_type'],
														'spe_when_emailed' 		=> $now,
														'spe_success' 			=> implode( ',', $sent_records ),
														'spe_failed' 			=> implode( ',', $not_sent_records ),	
														'spe_summary' 			=> $report,	
														'spe_start'				=> ( $start_from + 1 ),	
														'spe_how_many'			=> $this->page_size,	
														'spe_addresses_involved'=> $involved_count,				
														'spe_group_id'			=> $_POST['group_id'],
													);
							$funs->general_insert( MVC_Admin_Simpods_Email::DB_TABLE, $report_record_data );	
							$for_json = array( 'message' => sprintf( esc_html__( 'Finished sending emails by %s.', 'simpods-mvc' ), $_POST['send_type'] ) , 'sent'=> $send_count, 'notSent' => $not_sent_count, 'more' => true, 'total_sent' => ( $_POST['total_sent'] + $send_count ), 'total_failed' => ( $_POST['total_failed'] + $not_sent_count ), 'report' => $report, 'group_id' => $_POST['group_id'] );
							if( $try_count == $total_emails ){										
								$for_json['more'] 		= false;	
							}
							wp_send_json_success( $for_json );

						}
						$i	++;
					}

				}
				
			}
			// Nothing sent;
			$for_json = array( 'message' => esc_html__( 'No email addresses involved. You may want to change the Start Email Position.', 'simpods-mvc' ) , 'sent'=> 0, 'notSent' => 0, 'more' => false, 'total_sent' => 0, 'total_failed' => 0, 'report' => '', 'group_id' => '' );
			wp_send_json_success( $for_json );
			
			
		} else {
			wp_send_json_success( array( 'message' => esc_html__( 'No email addresses ', 'simpods-mvc' ), 'sent'=> 0, 'notSent' => 0, 'more' => false, 'total_sent' => 0, 'total_failed' => 0 ) );
		}			
	}
	protected function magic_field_replace( $field_names = '' ){
		if( isset( $field_names ) && ! empty( $field_names ) ){
			$magic_fields	=	explode( PHP_EOL, $field_names );
			foreach( $magic_fields as $magic_field ){
				preg_match('/^\{{1}[a-zA-Z0-9-_]*\}:{1}/i', $magic_field, $magic_field_matches);
				if( ! empty( $magic_field_matches ) ){
					$field_name 	= substr( $magic_field_matches[0] , 0, -1 );
					$value	= substr( $magic_field , wp_strip_all_tags( strlen( $magic_field_matches[0] ) ) );
					$this->magic_fields[ $field_name ] = $value;
				}				
														
			}
		}	
	}
	/**
	 * Replace the magic fields in the content
	 * 
	 * @param array the magic fields array
	 * @param string the content
	 * 
	 * @return string return the content after replacing all the magic fields with the values
	 */ 
	protected function replace_magic_field( $magic_fields, $content ){
		foreach( $magic_fields as $field => $value ){
			$content	= 	str_replace( $field, $value, $content ); 
		}
		return $content;
	}
}
//new Ajax_Simpods_Email();
