<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Cross Simpods Admin Ajax For the Simpods team only
 *
 * @version: 0.0.1
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 24/12/2020
 */
class Ajax_Simpods_Cross_Simpods {
	public function __construct() {		
		add_action( 'wp_ajax_simpods_activate_plugin', array( $this, 'simpods_activate_plugin' ) );
		add_action( 'wp_ajax_simpods_install_plugin', array( $this, 'simpods_install_plugin' ) );
	}
	/**
	 * simpods_activate_plugin can be use to activate plugins by Ajax rather than doing it on the plugins page.
	 */ 
	public function simpods_activate_plugin() {
	
		if ( ! isset( $_POST['action'] ) || $_POST['action'] != 'simpods_activate_plugin' ) {
			wp_die();
		}
		if ( ! isset( $_POST['security'] ) || wp_verify_nonce( $_POST['security'], 'simpods_admin_ajax_nonce' ) === false ) {
			wp_die();
		}
	
		if( ! isset( $_POST['plugin'] ) || empty( $_POST['plugin'] ) ){
			wp_die();
		}
		require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
		$result = activate_plugin( $_POST['plugin'] );
		if ( is_wp_error( $result ) ) {
			wp_send_json_error( $result );
		} else {
			wp_send_json_success( );
		}
	}	
	/**
	 * simpods_activate_plugin can be use to install plugins by Ajax rather than doing it on the plugins page.
	 * @link https://wpreset.com/programmatically-automatically-download-install-activate-wordpress-plugins/
	 */ 
	public function simpods_install_plugin() {
	
		if ( ! isset( $_POST['action'] ) || $_POST['action'] != 'simpods_install_plugin' ) {
			wp_die();
		}
		if ( ! isset( $_POST['security'] ) || wp_verify_nonce( $_POST['security'], 'simpods_admin_ajax_nonce' ) === false ) {
			wp_die();
		}
	
		if( ! isset( $_POST['plugin'] ) || empty( $_POST['plugin'] ) ){
			wp_die();
		}
		if( ! isset( $_POST['plugin_zip'] ) || empty( $_POST['plugin_zip'] ) ){
			wp_die();
		}
		
		include_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
		wp_cache_flush();
		   
		$upgrader  = new Plugin_Upgrader();
		$installed = $upgrader->install( $_POST['plugin_zip'] );
		if( ! is_wp_error( $installed ) && $installed ){
			$result = activate_plugin( $_POST['plugin'] );
			if ( is_wp_error( $result ) ) {
				wp_send_json_error( $result );
			} else {
				wp_send_json_success( );
			}
		} else {
			wp_send_json_error( $installed );
		}
	}	
	
}

