<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods Hierarchy Ajax
 *
 * @version: 1.1.4
 * @package: Simpods MVC
 * @author: Andrew Palfrey
 * @since: 21/09/2018
 */
class Simpods_Hierarchy {
	public function __construct() {
		add_action( 'wp_ajax_hierarchy_child_change', array( $this, 'hierarchy_child_change' ) );
		add_action( 'wp_ajax_hierarchy_parent_change', array( $this, 'hierarchy_parent_change' ) );
	}
	/**
	 * Gets the available parent tables when the child table is changed
	 *
	 * @return array JSON Object
	 */
	public function hierarchy_child_change() {
		if ( !isset( $_POST['table'] ) || !isset( $_POST['action'] ) || $_POST['action'] != 'hierarchy_child_change' ) {
			exit();
		}
		if( !isset( $_POST['security'] ) || !wp_verify_nonce( $_POST['security'], 'simpods_hierarchy' ) ) {
			exit();
		}
		$simpods_hierarchy 	= new MVC_Admin_Simpods_Hierarchy( false );
		$return_data    = $simpods_hierarchy->filter_child_table( $_POST );
		wp_send_json( $return_data );
		wp_die();
	}
	/**
	 * Gets the categories from grandparent tables when the parent table is changed
	 *
	 * @return array JSON Object
	 */
	public function hierarchy_parent_change() {
		if ( !isset( $_POST['table'] ) || !isset( $_POST['action'] ) || $_POST['action'] != 'hierarchy_parent_change' ) {
			exit();
		}
		if( !isset( $_POST['security'] ) || !wp_verify_nonce( $_POST['security'], 'simpods_hierarchy' ) ) {
			exit();
		}
		$simpods_hierarchy 	= new MVC_Admin_Simpods_Hierarchy( false );
		$return_data    = $simpods_hierarchy->filter_parent_table( $_POST );
		wp_send_json( $return_data );
	}
}
//new Ajax_Simpods_Hierarchy();