<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods Install and Update Ajax
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 24/10/2018
 */
class Simpods_Install_Update {
	public function __construct() {
		add_action( 'wp_ajax_spiu_register_key', array( $this, 'spiu_register_key' ) );
		add_action( 'wp_ajax_spiu_install_update', array( $this, 'spiu_install_update' ) );
		add_action( 'wp_ajax_spiu_check_updates', array( $this, 'spiu_check_updates' ) );
	}
	/**
	 * Checks new key validity and registers product
	 *
	 * @return array JSON Object
	 */
	public function spiu_register_key() {
		if ( !isset( $_POST['product'] ) || !isset( $_POST['action'] ) || $_POST['action'] != 'spiu_register_key' ) {
			exit();
		}
		if ( !isset( $_POST['security'] ) || !wp_verify_nonce( $_POST['security'], 'simpods_install_update' ) ) {
			exit();
		}
		$install_update 	 = new MVC_Admin_Simpods_Install_Update( false );
		$return_data = $install_update->register( $_POST );
		wp_send_json( $return_data );
		
	}
	/**
	 * Fetches files and then install
	 *
	 * @return object JSON Object
	 */
	public function spiu_install_update() {
		if ( !isset( $_POST['product'] ) || !isset( $_POST['action'] ) || $_POST['action'] != 'spiu_install_update' ) {
			exit();
		}
		if ( !isset( $_POST['security'] ) || !wp_verify_nonce( $_POST['security'], 'simpods_install_update' ) ) {
			exit();
		}
		$install_update 	= new MVC_Admin_Simpods_Install_Update( false );
		$return_data = $install_update->install_update( $_POST );
		wp_send_json( $return_data );
		
	}
	/**
	 * Updates installed software
	 *
	 * @return object JSON Object
	 */
	public function spiu_check_updates() {
		if ( !isset( $_POST['action'] ) || $_POST['action'] != 'spiu_check_updates' ) {
			exit('Wrong action');
		}
		if ( !isset( $_POST['security'] ) || !wp_verify_nonce( $_POST['security'], 'simpods_install_update' ) ) {
			exit('Wrong nonce');
		}
		$install_update 	= new MVC_Admin_Simpods_Install_Update( false );
		$return_data = $install_update->check_updates( $_POST );
		wp_send_json( $return_data );
		
	}
}
//new Ajax_Simpods_Install_Update();