<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * A collection of functions for generic purposes for each section
 *
 * @version: 1.1.4
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 13/04/2015
 */
abstract class Ctrl_MVC_Admin_Controller {
	public function __construct() {
		$this->actions();
		$this->filters();
	}
	/**
	 * WordPress actions to hook when the admin controller is loaded
	 * @return null
	 */
	public function actions() {
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ) );
	}
	/**
	 * WordPress filters to hook when the admin controller is loaded
	 * @return null
	 */
	public function filters() {}
	/**
	 * Scripts & styles to register & enqueue when the admin controller is loaded
	 * @return null
	 */
	public function enqueue() {}
	/**
	 * Links to include_fn in simpods_functions (This is deprecated, here for compatibility)
	 */
	final public function include( $files, $is_child_first = true, $depths = array(), $show_error = false ) {
		global $funs;
		return $funs->include( $files, $is_child_first, $depths, $show_error );
	}
	protected function get_constants( $class ) {
		return (new ReflectionClass( $class ))->getConstants();
	}
	protected function get_constant( $class, $const ) {
		return $this->get_constants( $class )[$const];
	}
}
