<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods MVC Cross admin controller. 
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 04/04/2019
 */
class Ctrl_MVC_Admin_Simpods_Cross_Admin extends Ctrl_MVC_Admin_Controller {
	private $sorting_enabled = array();
	public function __construct() {
		global $funs;
		$this->sorting_enabled = Arrays::string_to_array( $funs->settings[ 'simpods_enable_sorting' ] );
		$this->actions();
		$this->filters();
		$this->clear_simpods_file_folder();
	}
	/**
	 * WordPress actions to hook when the admin controller is loaded
	 * @return null
	 */
	public function actions() {
		global $cross_admin, $funs; 
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ) );
		// Enable sorting on the post type
		if( in_array( MVC_Admin_Factory::$post_type, $this->sorting_enabled ) ){
			add_action( 'manage_'. MVC_Admin_Factory::$post_type . '_posts_custom_column', array( $cross_admin, 'column_contents' ), 10, 2);
		}
		
	}
	/**
	 * WordPress filters to hook when the admin controller is loaded
	 * @return null
	 */
	public function filters() {
		global $cross_admin;
		// Enable sorting on the post type
		if( in_array( MVC_Admin_Factory::$post_type, $this->sorting_enabled ) ){
			add_filter( 'manage_'. MVC_Admin_Factory::$post_type . '_posts_columns', array( $cross_admin, 'column_heads' ) );
			add_filter( 'posts_orderby', array( $cross_admin, 'posts_sorting' ) );
		}
	}
	/**
	 * Scripts & styles to register & enqueue when the admin controller is loaded
	 * @return null
	 */
	public function enqueue() {
		global $funs;
		//css
		$files = array(
			'bootstrap-select2'   	=> SIMPODS_MVC_URL . '/library/js/select2/css/select2.css',			
		);
		$depth = $funs->include( $files, true );		
		//js
		$files = array(			
			'bootstrap-select2'  	=> SIMPODS_MVC_URL . '/library/js/select2/js/select2.full.js',
		);
		$depth = $funs->include( $files, true );			
		// Enable sorting on the post type
		if( in_array( MVC_Admin_Factory::$post_type, $this->sorting_enabled ) ){
			wp_enqueue_script( 'jquery-ui-sortable' );
			$files = array(			
				'simpods-sorting'  		=> SIMPODS_MVC_URL . '/admin/js/simpods-sorting.js',
			);
			$depth = $funs->include( $files );		
		}
	}
	/**
	 * Stop saving uploaded files into Simpods File folders	 
	 */
	public function clear_simpods_file_folder(){		
		global $current_user;
		update_option( 'simpods_file_upload_folder_' . $current_user->ID, '' );
	}
}