<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods Install & Update Controller
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 12/10/2018
 */
class Ctrl extends Ctrl_MVC_Admin_Controller {
	public $wp_notices = '';
	public $disable    = '';
	public function __construct() {
		$this->notice();
		$this->actions();
		$this->filters();
		
	}
	/**
	 * WordPress actions to hook when the admin controller is loaded
	 * @return null
	 */
	public function actions() {
		global $cross_admin;
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ), 11 );
	}
	/**
	 * WordPress filters to hook when the admin controller is loaded
	 * @return null
	 */
	public function filters() {}
	/**
	 * Scripts & styles to register & enqueue when the admin controller is loaded
	 * @return null
	 */
	public function enqueue() {
		// Prepare Ajax
		wp_localize_script(
			'simpods-install-update',
			'simpods_install_update_ajax',
			array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'nonce'   => wp_create_nonce( 'simpods_install_update_ajax' ),
			)
		);
		wp_localize_script( 'simpods-install-update', 'spiu_l10n', array(
			'validated' => esc_html__( 'Validated, processing installation and update.', 'simpods-mvc' ),
			'processing' => esc_html__( 'Processing version', 'simpods-mvc' ),
		) );
		wp_localize_script(
			'simpods-install-update',
			'simpods_install_update_params',
			array(
				'disable' => $this->disable,				
			)
		);		
	}
	/**
	 * Send notification to the settings page
	 */
	private function notice() {
		global $cross_admin;
		// check themes and plugins update are allowed
		if( defined( 'DISALLOW_FILE_MODS' ) && DISALLOW_FILE_MODS == true ){
			$message = esc_html__( 'Plugin and Theme Update and Installation has been disabled.', 'simpods-mvc' );	
			$this->wp_notices  .= $cross_admin->notice( $message, 'warning', false );		
			$this->disable		= 'disabled="disabled"';
		}
	}
}
