<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods User Code Controller
 *
 * @package Simpods MVC
 * @author Andrew Palfrey
 * @since 22/01/2019
 */
class Ctrl extends Ctrl_MVC_Admin_Controller {
	const PAGE_SLUG = 'simpods-user-code';
	const DB_TABLE  = 'simpods_user_code';
	public $settings_form_items		= array();
	public $settings_form_settings	= array();
	public $add_form_items     = array();
	public $add_form_settings  = array();
	public $edit_form_items    = array();
	public $edit_form_settings = array();
	public $notice = '';
	public $wp_errors  = false;
	public function __construct() {
		$this->actions();
		$this->filters();
	}
	/**
	 * actions_fn: WP actions to globally hook when the admin controller is loaded
	 */
	public function actions() {
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ) );
	}
	/**
	 * filters_fn: WP filters to globally hook when the admin controller is loaded
	 */
	public function filters() {}
	/**
	 * enqueue_fn: Scripts and styles to globally enqueue when the admin controller is loaded
	 */
	public function enqueue() {}
	/**
	 * Sets up & processes all user code forms
	 *
	 * @return null
	 */
	public function forms() {
		$this->settings_form_items = array(
			'spuc_code'      => array(
				'type'    => 'toggle',
				'title'   => esc_html__( 'Extend User Table', 'simpods-mvc' ),
				'subtitle' => esc_html__( 'Extend users table by Pods Framework. If you have already extended Users table by Pods Framework. Please make sure its storage type is table-based instead of meta-based. Otherwise, it will cause conflicts.', 'simpods-mvc' ),
				'value'   => '1',
				'options' => array(
					'required' => false,
				),
			),
		);
		$this->settings_form_settings = array(
			'table'  => array(
				'class' => '',
				'id'    => '',
			),
			'submit' => array(
				'class' => '',
				'id'    => 'simpods-uc-settings-submit',
				'label' => esc_html__( 'Submit', 'simpods-mvc' ),
			),
			'form' => array(
				'id'     => 'simpods-uc-settings-form',
				'class'  => '',
				'method' => 'post',
				'action' => esc_url( admin_url( 'admin.php?page=' . self::PAGE_SLUG . '' ) ),
				'enctype' => 'multipart/form-data',
			),
			'nonce'  => 'simpods_extend_user_table',
			'action' => 'extend_user_table',
		);		
		$this->add_form_items = array(
			'how_many'         => array(
				'type'     => 'number',
				'title'    => esc_html__( 'No. of Codes', 'simpods-mvc' ),
				'subtitle' => esc_html__( 'The number of codes to create.', 'simpods-mvc' ),
				'options'  => array(
					'required' => true,
					'min'      => 1,
				),
				'errors'   => array(
					'error'   => esc_html__( 'You must enter how many codes to create.', 'simpods-mvc' ),
					'invalid' => esc_html__( 'You must enter a valid number of codes to create.', 'simpods-mvc' ),
					'min-max' => esc_html__( 'You must enter a valid number of codes to create.', 'simpods-mvc' ),
				),
			),
			'spuc_amount'      => array(
				'type'     => 'number',
				'title'    => esc_html__( 'No. of Users', 'simpods-mvc' ),
				'subtitle' => esc_html__( 'The number of users that can use this code.', 'simpods-mvc' ),
				'options'  => array(
					'required' => true,
					'min'      => 1,
				),
				'errors'   => array(
					'error'   => esc_html__( 'You must enter how many users can use this code.', 'simpods-mvc' ),
					'invalid' => esc_html__( 'You must enter a valid number of users that can use this code.', 'simpods-mvc' ),
					'min-max' => esc_html__( 'You must enter a valid number of users that can use this code.', 'simpods-mvc' ),
				),
			),
			'characters'       => array(
				'type'     => 'number',
				'title'    => esc_html__( 'No. of Characters', 'simpods-mvc' ),
				'subtitle' => esc_html__( 'The number of characters to use in the code.', 'simpods-mvc' ),
				'options'  => array(
					'required' => true,
					'min'      => 1,
				),
				'errors'   => array(
					'error'   => esc_html__( 'You must enter how many characters to use.', 'simpods-mvc' ),
					'invalid' => esc_html__( 'You must enter a valid number of characters to use.', 'simpods-mvc' ),
					'min-max' => esc_html__( 'You must enter a valid number of characters to use.', 'simpods-mvc' ),
				),
			),
			'spuc_expiry_date' => array(
				'type'    => 'date',
				'title'   => esc_html__( 'Expiry Date', 'simpods-mvc' ),
				'options' => array(
					'required' => false,
					'format'   => get_option( 'date_format' ),
				),
				'errors'  => array(
					'invalid' => esc_html__( 'You must enter a valid expiry date.', 'simpods-mvc' ),
				),
			),
			'spuc_note'        => array(
				'type'    => 'textarea',
				'title'   => esc_html__( 'Note', 'simpods-mvc' ),
				'options' => array(
					'required' => false,
				),
			),
			'spuc_active'      => array(
				'type'    => 'toggle',
				'title'   => esc_html__( 'Active', 'simpods-mvc' ),
				'value'   => '1',
				'options' => array(
					'required' => false,
				),
			),
		);
		$this->add_form_settings = array(
			'table'  => array(
				'class' => '',
				'id'    => '',
			),
			'submit' => array(
				'class' => '',
				'id'    => 'simpods-uc-add-submit',
				'label' => esc_html__( 'Generate Code(s)', 'simpods-mvc' ),
			),
			'form' => array(
				'id'     => 'simpods-uc-add-form',
				'class'  => '',
				'method' => 'post',
				'action' => esc_url( admin_url( 'admin.php?page=' . self::PAGE_SLUG . '' ) ),
				'enctype' => 'multipart/form-data',
			),
			'nonce'  => 'add_new_entry',
			'action' => 'add_new_entry',
		);
		$this->edit_form_items = array(
			'spuc_code'        => array(
				'type'    => 'text',
				'title'   => esc_html__( 'User Code', 'simpods-mvc' ),
				'value'   => '',
				'options' => array(
					'required' => true,
					'readonly' => true,
					'id'       => 'edit-spuc_code',
				),
			),
			'spuc_amount'      => array(
				'type'     => 'number',
				'title'    => esc_html__( 'No. of Users', 'simpods-mvc' ),
				'subtitle' => esc_html__( 'The number of users that can use this code.', 'simpods-mvc' ),
				'value'    => '',
				'options'  => array(
					'required' => true,
					'min'      => 1,
					'id'       => 'edit-spuc_amount',
				),
				'errors'   => array(
					'error'   => esc_html__( 'You must enter how many users can use this code.', 'simpods-mvc' ),
					'invalid' => esc_html__( 'You must enter a valid number of users that can use this code.', 'simpods-mvc' ),
					'min-max' => esc_html__( 'You must enter a valid number of users that can use this code.', 'simpods-mvc' ),
				),
			),

			'spuc_active'      => array(
				'type'    => 'toggle',
				'title'   => esc_html__( 'Active', 'simpods-mvc' ),
				'value'   => '1',
				'options' => array(
					'required' => false,
					'id'       => 'edit-spuc_active',
				),
			),
			'spuc_user_ids'    => array(
				'type'    => 'textarea',
				'title'   => esc_html__( 'Users', 'simpods-mvc' ),
				'subtitle'=> esc_html__( 'Update will remove invalid user IDs and those not assigned to this code.', 'simpods-mvc' ),
				'value'   => '',
				'options' => array(
					'readonly' => true,					
					'required' => false,
					'id'       => 'edit-spuc_user_ids',
				),
			),
			'spuc_expiry_date' => array(
				'type'    => 'date',
				'title'   => esc_html__( 'Expiry Date', 'simpods-mvc' ),
				'value'   => '',
				'options' => array(
					'required' => false,
					'format'   => get_option( 'date_format' ),
					'id'       => 'edit-spuc_expiry_date',
				),
				'errors'  => array(
					'invalid' => esc_html__( 'You must enter a valid expiry date.', 'simpods-mvc' ),
				),
			),
			'spuc_note'        => array(
				'type'    => 'textarea',
				'title'   => esc_html__( 'Note', 'simpods-mvc' ),
				'value'   => '',
				'options' => array(
					'required' => false,
					'id'       => 'edit-spuc_note',
				),
			),			
			'id'               => array(
				'type'    => 'number',
				'title'   => esc_html__( 'ID', 'simpods-mvc' ),
				'value'   => '',
				'options' => array(
					'required' => true,
					'readonly' => true,
					'id'       => 'edit-id',
				),
				'errors'  => array(
					'error' => esc_html__( 'There should be an ID in here...', 'simpods-mvc' ),
				),
			),
		);
		$this->edit_form_settings = array(
			'table'  => array(
				'class' => '',
				'id'    => '',
			),
			'submit' => false,
			'form'   => false,
			'nonce'  => 'edit_entry',
			'action' => 'edit_entry',
		);
		$this->extend_user_table();
		$this->add_user_codes();
		$this->edit_user_code();
	}

	private function extend_user_table(){
		global $funs, $cross_admin, $current_user;
		if ( !isset( $_POST['action'] ) || $_POST['action'] !== 'extend_user_table' ) {
			return;
		}
		if ( !isset( $_POST['_wpnonce'] ) || !wp_verify_nonce( $_POST['_wpnonce'], 'simpods_extend_user_table' ) ) {
			$message = esc_html__( 'Sorry, your nonce did not verify.', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		}
		if ( ! empty( $_POST['spuc_code'] ) ){
			$simpods_user_code = new MVC_Admin_Simpods_User_Code( false );
			$success = $simpods_user_code->update_user_pod();
			if( $success ){
				$message 		= esc_html__( 'Extended users table successfully.', 'simpods-mvc' );
				$css_class     	= 'success';
				$this->notice  .= $cross_admin->notice( $message, $css_class );
			} else {
				$message = esc_html__( 'Sorry, failed to extend users table.', 'simpods-mvc' );
				$css_class     = 'error';
				$this->notice .= $cross_admin->notice( $message, $css_class );			
			}
		}
		
	}
	/**
	 * Adds new user codes into the system
	 *
	 * @return null
	 */
	private function add_user_codes() {
		global $funs, $cross_admin, $current_user;
		if ( !isset( $_POST['action'] ) || $_POST['action'] !== 'add_new_entry' ) {
			return;
		}
		if ( !isset( $_POST['_wpnonce'] ) || !wp_verify_nonce( $_POST['_wpnonce'], 'add_new_entry' ) ) {
			$message = esc_html__( 'Sorry, your nonce did not verify.', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		}
		$post_data = $_POST;
		unset( $post_data['_wpnonce'] );
		unset( $post_data['_wp_http_referer'] );
		unset( $post_data['action'] );
		if ( !isset( $post_data['spuc_active'] ) ) {
			$post_data['spuc_active'] = '0';
		}
		$sanitized_data = array_map( 'wp_strip_all_tags', $post_data );
		$sanitized_data = $funs->escape( $sanitized_data );
		$sanitized_data = array_map( 'trim', $sanitized_data );
		if ( isset( $sanitized_data['spuc_expiry_date'] ) && $sanitized_data['spuc_expiry_date'] == '' ) {
			$sanitized_data['spuc_expiry_date'] = '0000-00-00';
		}
		$wp_errors = new WP_Error();
		if ( $sanitized_data['how_many'] == '' ) {
			$wp_errors->add( 'how_many_error', esc_html__( 'You must enter how many codes to create', 'simpods-mvc' ), 'how_many-error' );
		}
		if ( $sanitized_data['spuc_amount'] == '' ) {
			$wp_errors->add( 'spuc_amount_error', esc_html__( 'You must enter how many users can use the code', 'simpods-mvc' ), 'spuc_amount-error' );
		}
		if ( $sanitized_data['characters'] == '' ) {
			$wp_errors->add( 'characters_error', esc_html__( 'You must enter the length of the code', 'simpods-mvc' ), 'characters-error' );
		}
		if ( $sanitized_data['how_many'] !== '' && !is_numeric( $sanitized_data['how_many'] ) ) {
			$wp_errors->add( 'how_many_invalid', esc_html__( 'You must enter a valid number of codes to create', 'simpods-mvc' ), 'how_many-invalid' );
		}
		if ( $sanitized_data['spuc_amount'] !== '' && !is_numeric( $sanitized_data['spuc_amount'] ) ) {
			$wp_errors->add( 'spuc_amount_invalid', esc_html__( 'You must enter a valid number of users that can use this code', 'simpods-mvc' ), 'spuc_amount-invalid' );
		}
		if ( $sanitized_data['characters'] !== '' && !is_numeric( $sanitized_data['characters'] ) ) {
			$wp_errors->add( 'characters_invalid', esc_html__( 'You must enter a valid length of the code', 'simpods-mvc' ), 'characters-invalid' );
		}
		if ( $sanitized_data['spuc_expiry_date'] !== '0000-00-00' ) {
			$format = $this->add_form_items['spuc_expiry_date']['options']['format'];
			if ( !$funs->validate_date( $sanitized_data['spuc_expiry_date'], $format ) ) {
				$wp_errors->add( 'spuc_expiry_date_invalid', esc_html__( 'This is not a valid date.', 'simpods-mvc' ), 'spuc_expiry_date-invalid' );
			}
		}
		if ( $sanitized_data['spuc_active'] == '' || !is_numeric( $sanitized_data['spuc_active'] ) || intval( $sanitized_data['spuc_active'] ) > 1 || intval( $sanitized_data['spuc_active'] ) < 0 ) {
			$wp_errors->add( 'spuc_active_invalid', esc_html__( 'You must select whether or not the code should be active', 'simpods-mvc' ), 'spuc_active-invalid' );
		}
		if ( $wp_errors->get_error_code() ) {
			$this->wp_errors = $wp_errors;
			$message = esc_html__( 'Unable to create user codes', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		}
		if ( $sanitized_data['spuc_expiry_date'] !== '0000-00-00' ) {
			$sanitized_data['spuc_expiry_date'] = $funs->format_date( $sanitized_data['spuc_expiry_date'], 'Y-m-d', $format );
		}

					

		$created_count = 0;
		for ( $i = 0; $i < intval( $sanitized_data['how_many'] ); $i++ ) {
			$unique_code 	= $funs->unique_code( intval( $sanitized_data['characters'] ), self::DB_TABLE, 'spuc_code' );
			$now  			= date( 'Y-m-d H:i:s' );
			$data = array(
				'spuc_amount'          => $sanitized_data['spuc_amount'],
				'spuc_code'            => $unique_code,
				'spuc_user_ids'        => '',
				'spuc_created'         => $now,
				'spuc_modified'        => $now,
				'spuc_modified_author' => $current_user->ID,
				'spuc_author'          => $current_user->ID,
				'spuc_status'          => '',
				'spuc_note'            => $sanitized_data['spuc_note'],
				'spuc_expiry_date'     => $sanitized_data['spuc_expiry_date'],
				'spuc_active'     	   => $sanitized_data['spuc_active'],
			);
			$new_id = $funs->general_insert( self::DB_TABLE, $data );
			$created_count++;
			do_action( 'simpods-mvc-admin-user-code-insert', $new_id, $data );
		}
		$message 		= $created_count . ' ' . esc_html__( 'codes created.', 'simpods-mvc' );
		$css_class     	= 'success';
		$this->notice  .= $cross_admin->notice( $message, $css_class );
		return true;
	}
	/**
	 * Updates user codes within the system
	 *
	 * @return null
	 */
	private function edit_user_code() {

		global $funs, $cross_admin, $current_user;
		if ( !isset( $_POST['action'] ) || $_POST['action'] !== 'edit_entry' ) {
			return;
		}
		if ( !isset( $_POST['_wpnonce'] ) || !wp_verify_nonce( $_POST['_wpnonce'], 'edit_entry' ) ) {
			$message = esc_html__( 'Sorry, your nonce did not verify.', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		} 
		$post_data 	= $_POST;
		$id   		= intval( $post_data['id'] );
		unset( $post_data['_wpnonce'] );
		unset( $post_data['_wp_http_referer'] );
		unset( $post_data['action'] );
		unset( $post_data['id'] );
		unset( $post_data['spuc_code'] );
		if ( !isset( $post_data['spuc_active'] ) ) {
			$post_data['spuc_active'] = '0';
		}
		$sanitized_data = array_map( 'wp_strip_all_tags', $post_data );
		$sanitized_data = $funs->escape( $sanitized_data );
		$sanitized_data = array_map( 'trim', $sanitized_data );
		$wp_errors 	= new WP_Error();
		$format 		= '';
		if ( isset( $sanitized_data['spuc_expiry_date'] ) && $sanitized_data['spuc_expiry_date'] == '' ) {
			$sanitized_data['spuc_expiry_date'] = '0000-00-00';
		}
		if ( $sanitized_data['spuc_amount'] == '' ) {
			$wp_errors->add( 'spuc_amount_error', esc_html__( 'You must enter how many users can use the code', 'simpods-mvc' ), 'spuc_amount-error' );
		}
		if ( $sanitized_data['spuc_amount'] !== '' && !is_numeric( $sanitized_data['spuc_amount'] ) ) {
			$wp_errors->add( 'spuc_amount_invalid', esc_html__( 'You must enter a valid number of users that can use this code', 'simpods-mvc' ), 'spuc_amount-invalid' );
		}
		if ( $sanitized_data['spuc_expiry_date'] !== '0000-00-00' ) {
			$format = $this->edit_form_items['spuc_expiry_date']['options']['format'];
			if ( !$funs->validate_date( $sanitized_data['spuc_expiry_date'], $format ) ) {
				$wp_errors->add( 'spuc_expiry_date_invalid', esc_html__( 'This is not a valid date.', 'simpods-mvc' ), 'spuc_expiry_date-invalid' );
			}
		}
		if ( $sanitized_data['spuc_active'] == '' || !is_numeric( $sanitized_data['spuc_active'] ) || intval( $sanitized_data['spuc_active'] ) > 1 || intval( $sanitized_data['spuc_active'] ) < 0 ) {
			$wp_errors->add( 'spuc_active_invalid', esc_html__( 'You must select whether or not the code should be active', 'simpods-mvc' ), 'spuc_active-invalid' );
		}
		if ( $wp_errors->get_error_code() ) {
			$this->wp_errors = $wp_errors;
			$message = esc_html__( 'Unable to create user codes', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		}
		if ( $sanitized_data['spuc_expiry_date'] !== '0000-00-00' ) {
			$sanitized_data['spuc_expiry_date'] = $funs->format_date( $sanitized_data['spuc_expiry_date'], 'Y-m-d', $format );
		}
		$temporary_user_ids = explode( ',', $sanitized_data['spuc_user_ids'] );
		$temporary_user_ids = array_map( 'trim', $temporary_user_ids );
		$user_ids  = array();
		$pod_table = 'pods_user';
		// foreach ( $temporary_user_ids as $user_id ) {
		// 	if ( $user_id !== '' && is_numeric( $user_id ) ) {
		// 		$user_data = get_user_by('id', $user_id );
		// 		if ( $user_data ) {

		// 		}
		// 	}
		// }
		$existing_users = $funs->simpods_select(
			array(),
			array(
				'target_tb' => $pod_table,
				'search'    => 'AND FIND_IN_SET( "' . $id . '", `spuc_code` )'
			)
		);	// users have been assigned the code	
		if( ! empty( $existing_users ) ){	
			foreach( $existing_users as $k => $user_data ){		
				array_push( $user_ids, $user_data['id'] );
			}
		}		
		$user_ids = array_unique( $user_ids );
		$sanitized_data['spuc_user_ids']        = implode( ',', $user_ids );
		$sanitized_data['spuc_modified']        = date( 'Y-m-d H:i:s' );
		$sanitized_data['spuc_modified_author'] = $current_user->ID;
		$is_done = $funs->general_update( self::DB_TABLE, $sanitized_data, array( 'id' => $id ) );
		do_action( 'simpods-mvc-admin-user-code-update', $is_done, $id, $user_ids );
		if ( !$is_done ) {
			$message = esc_html__( 'Unable to update User Code', 'simpods-mvc' );
			$css_class     = 'error';
			$this->notice .= $cross_admin->notice( $message, $css_class );
			return false;
		}
		$message = esc_html__( 'User Code updated.', 'simpods-mvc' );
		$css_class     = 'success';
		$this->notice .= $cross_admin->notice( $message, $css_class );
		return true;
	}
}
