"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

jQuery(document).ready(function ($) {
  if (typeof history.pushState != "undefined") {
    $('#simpods-wrap a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
      var current_tab = $(e.target).attr('aria-controls'),
          page_url = new URL(document.location),
          page_title = $(document).find('title').text();
      page_url.searchParams.set('tab', current_tab);
      history.pushState({
        Title: page_title,
        Url: page_url.href
      }, page_title, page_url.href);
    });
  }
  /**
   * Init the datetimepickers
   */


  if (typeof $.fn.datetimepicker !== 'undefined' && typeof $.fn.datetimepicker.Constructor !== 'undefined') {
    $.extend($.fn.datetimepicker.Constructor.Default, {
      icons: {
        time: 'fas fa-clock',
        date: 'fas fa-calendar-alt',
        up: 'fas fa-angle-up',
        down: 'fas fa-angle-down',
        previous: 'fas fa-chevron-left',
        next: 'fas fa-chevron-right',
        today: 'fas fa-calendar-check',
        clear: 'fas fa-trash-alt',
        close: 'fas fa-times'
      },
      buttons: {
        showToday: true,
        showClear: true,
        showClose: true
      }
    });
    $('.input-group.date').each(function () {
      var format = $(this).children('input[data-type]').data('value');
      $(this).datetimepicker({
        format: format
      });
    });
  }
  /**
   * Item deletion functionality w/ modal
   */


  $('.trash-btn').click(function (e) {
    e.preventDefault();
    var this_element = $(this),
        id = this_element.data('value');
    $('.delete-modal').modal();
    $(document).on('click', '#delete-item', function (e) {
      e.preventDefault();
      $('#trash-' + id).prop('checked', !$('#trash-' + id).prop('checked'));
      var input = $('<input>').attr('type', 'hidden').attr('name', 'action').val('remove_entry');
      $('#trash-' + id).after(input);
      this_element.parents('form').find('.trash-btn, .edit-btn, .bulk-btn').prop('disabled', true);
      this_element.parents('form').submit();
      $('.delete-modal').modal('hide');
    });
    $(document).on('click', '#keep-item', function (e) {
      e.preventDefault();
      $('.delete-modal').modal('hide');
    });
  });
  $('.delete-modal').on('hide.bs.modal', function (e) {
    $(document).off('click', '#delete-item');
    $(document).off('click', '#keep-item');
  });
  /**
   * Format toggle fields based on validity
   */

  $(document).on('click', 'button[type="submit"], input[type="submit"]', function () {
    $('.toggle-container').each(function () {
      $(this).removeClass('is-valid is-invalid');

      if ($(this).children('input[type="checkbox"]').hasClass('is-valid')) {
        $(this).addClass('is-valid');
      }

      if ($(this).children('input[type="checkbox"]').hasClass('is-invalid')) {
        $(this).addClass('is-invalid');
      }
    });
  });
  /**
   * File functionality for the settings helper
   */

  var file_field = '',
      img_display = '',
      media_types = '';
  $('.sim-file-upload').click(function (e) {
    e.preventDefault();
    var btn_element = $(this),
        btn_id = btn_element.prop('id'),
        is_multiple = btn_element.data('multiple') == 'true' || btn_element.data('multiple') == '1',
        selected_img;
    media_types = maybe_parse_json(btn_element.data('type'));
    file_field = btn_element.data('field');
    img_display = btn_element.data('display');
    var media_title = l10n.select_media,
        media_select_btn = l10n.select_btn;

    if (is_multiple) {
      media_title += l10n.multiple;
    }

    if (typeof wp.media.frames.simpods_frame === 'undefined') {
      wp.media.frames.simpods_frame = [];
    } // configuration of the media manager new instance


    wp.media.frames.simpods_frame[file_field] = wp.media({
      title: media_title,
      multiple: is_multiple,
      library: {
        type: media_types
      },
      button: {
        text: media_select_btn
      }
    }); // Function used for the image selection and media manager closing

    var simpods_media_set_image = function simpods_media_set_image() {
      var selection = wp.media.frames.simpods_frame[file_field].state().get('selection'); // no selection

      if (!selection) {
        return;
      }

      var field_values = [],
          display_html = ''; // iterate through selected elements

      selection.each(function (attachment) {
        var id = attachment.id,
            url = attachment.attributes.url,
            type = attachment.attributes.mime;
        field_values.push(id);
        var is_img_type = false,
            img_reg_exp = new RegExp('^image.*$');
        $.each(media_types, function (idx, value) {
          if (img_reg_exp.test(value)) {
            is_img_type = true;
          }
        });

        if (is_img_type) {
          if (typeof attachment.attributes.sizes.thumbnail != 'undefined') {
            display_html += '<img src="' + attachment.attributes.sizes.thumbnail.url + '" class="simpods_media_set_image"  height="82" />';
          } else {
            display_html += '<img src="' + attachment.attributes.sizes.full.url + '" class="simpods_media_set_image"  height="82" />';
          }
        }
      });
      $('#' + file_field).val(field_values.join(','));
      $('#' + img_display).html(display_html);
      $('.media-modal-close').click();
    };

    var simpods_media_reopen = function simpods_media_reopen() {
      var selection_value = $('#' + file_field).val(),
          selections = selection_value.split(',');
      selections = selections.filter(Boolean);
      var selection = wp.media.frames.simpods_frame[file_field].state().get('selection');

      if (selections && selections.length) {
        $.each(selections, function (idx, value) {
          var attachment = wp.media.attachment(value);
          attachment.fetch();
          selection.add(attachment ? [attachment] : []);
        });
      }
    }; // image selection event


    wp.media.frames.simpods_frame[file_field].on('select', simpods_media_set_image); // Re-select media

    wp.media.frames.simpods_frame[file_field].on('open', simpods_media_reopen);
    wp.media.frames.simpods_frame[file_field].open();
  });
  $('.sim-file-clear').click(function (e) {
    e.preventDefault();
    var btn_element = $(this);
    file_field = btn_element.data('field');
    img_display = btn_element.data('display');
    $('#' + file_field).val('');
    $('#' + img_display).html('');
  });
  $('.colorpicker-container').each(function () {
    var id = $(this).children('.input-group').children('.form-control').attr('id'),
        format = $(this)[0].hasAttribute('data-format') ? $(this).data('format') : 'hex';
    init_colorpicker(id, format);
  });
  $('.code-editor').each(function () {
    var id = $(this).attr('id');
    init_code_editor(id);
  });
  display_errors(); // wp 5.0.3 add admin notice to inside .hide-if-js, there is the soluction to display the controller message before they fix it.

  if ($('.wrap.hide-if-js.block-editor-no-js').length != 0) {
    if ($(this).find('#simpods-controller-display').length != 0) {
      $('.wrap.hide-if-js.block-editor-no-js').removeClass('hide-if-js');
      $('.wrap.block-editor-no-js').children().hide();
      $('#simpods-controller-display').css('display', 'block');
    }
  }

  $('.add-repeater').click(function (e) {
    var comments = $(this).parents('.form-group').get_comments(),
        template = comments.length > 0 ? comments[0] : false;

    if (!template) {
      return false;
    }

    var index = $(this).parents('.form-group').children('.input-group').last().data('index');
    index = typeof index === "undefined" ? 0 : parseInt(index) + 1;
    template = template.replaceAll('{index}', index);
    template = template.replaceAll(/{value[_]?.*}/g, '');
    $(template).insertBefore($(this).parent());
  });
  $('body').on('click', '.remove-repeater', function () {
    $(this).parents('.input-group').remove();
  });
});

function show_hide_fields() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  options = Object.assign({
    field_val: '',
    fields: '',
    target_val: '',
    row: true,
    required: true,
    not_equal: false
  }, options);
  var $item = jQuery(options.fields);

  if (options.row) {
    $item = jQuery(options.fields).parents('tr');
  }

  if (!options.not_equal && options.field_val === options.target_val) {
    $item.removeClass('d-none');

    if (options.required) {
      jQuery(options.fields).prop('required', true);
    }
  } else if (options.not_equal && options.field_val !== options.target_val) {
    $item.removeClass('d-none');

    if (options.required) {
      jQuery(options.fields).prop('required', true);
    }
  } else {
    $item.addClass('d-none');

    if (options.required) {
      jQuery(options.fields).prop('required', false);
    }
  }

  if (options.row) {
    // console.log( '#' + $item.parents( 'table' ).attr( 'id' ) + ' tr' )
    update_striping('#' + $item.parents('table').attr('id') + ' tr');
  }
}

function update_striping(selector_str) {
  var count = 0;
  jQuery(selector_str).each(function (idx, row_obj) {
    jQuery(row_obj).removeClass('striped');

    if (!jQuery(row_obj).hasClass('d-none') && !jQuery(row_obj).hasClass('header-row')) {
      if (count % 2 != 0) {
        jQuery(row_obj).addClass('striped');
      }

      count++;
    }

    if (jQuery(row_obj).hasClass('header-row')) {
      count = 0;
    }
  });
}
/**
 * @link https://gist.github.com/zackkatz/1394a32e174e00d515ac
 */


function maybe_parse_json(string) {
  var json_object; // Parse valid JSON

  try {
    json_object = jQuery.parseJSON(string);
  } catch (exception) {
    // The JSON didn't parse most likely because PHP warnings.
    // We attempt to strip out all content up to the expected JSON `{"`
    var second_try = string.replace(/((.|\n)+?){"/gm, "{\"");

    try {
      json_object = jQuery.parseJSON(second_try);
    } catch (exception) {
      json_object = [string];
    }
  }

  return json_object;
}
/**
 * Sets up the functionality for editing items
 * @param {string} id The ID of the modal to initialize
 */


function open_edit_modal() {
  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  if (id == '') {
    return false;
  }

  if (!id.startsWith('#')) {
    id = '#' + id;
  }

  jQuery('.edit-btn').click(function (e) {
    var vals_obj = {},
        this_element = jQuery(this);
    this_element.parents('tr').children('td.values').children().each(function () {
      var key = jQuery(this).data('key'),
          value = jQuery(this).data('value');
      vals_obj[key] = value;

      if (typeof vals_obj[key] === 'string') {
        vals_obj[key] = vals_obj[key].replaceAll('\\r\\n', '\r\n');
      }
    });

    for (var key in vals_obj) {
      if (vals_obj.hasOwnProperty(key)) {
        var field_element = jQuery('#edit-' + key);

        if (field_element.parent().hasClass('toggle-container')) {
          if (vals_obj[key] == '1') {
            field_element.prop('checked', true);
          } else {
            field_element.prop('checked', false);
          }
        }

        if (field_element.hasClass('checkboxes')) {
          // uncheck all check boxes so it won't keep the check status from the previous item
          jQuery('#edit-' + key + ' input').each(function () {
            jQuery(this).prop('checked', false);
          });
          var values = vals_obj[key].toString().split(',');
          values.forEach(function (val_key) {
            field_element = jQuery('#edit-' + key + '-' + val_key);
            field_element.prop('checked', true);
          });
        } else {
          if (field_element.is('select')) {
            if (field_element.children('option[value="' + vals_obj[key] + '"]').length) {
              field_element.val(vals_obj[key]);
            } else {
              field_element.val('');
            }
          } else {
            field_element.val(vals_obj[key]);
          }
        }
      }
    }

    jQuery(id).modal();
  });
}
/**
 * Initialize the colorpickers
 * @param {string} id The ID of the colorpicker to initialise
 * @param {string} format The color format to use in the picker, default "hex"
 */


function init_colorpicker(id) {
  var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'hex';

  if (!id.startsWith('#')) {
    id = '#' + id;
  }

  var picker_ele = jQuery(id);
  picker_ele.colorpicker({
    format: format,
    horizontal: true,
    popover: {
      container: id + '-cp-container'
    },
    template: '<div class="colorpicker">' + '<div class="colorpicker-saturation"><i class="colorpicker-guide"></i></div>' + '<div class="colorpicker-hue"><i class="colorpicker-guide"></i></div>' + '<div class="colorpicker-alpha">' + ' <div class="colorpicker-alpha-color"></div>' + ' <i class="colorpicker-guide"></i>' + '</div>' + '<div class="colorpicker-bar">' + ' <div class="input-group">' + '   <input class="form-control input-block color-io" />' + ' </div>' + '</div>' + '</div>'
  }).on('colorpickerCreate colorpickerUpdate', function (e) {
    picker_ele.parent().find('.colorpicker-input-addon>i').css('background-color', e.value);
  }).on('colorpickerCreate', function (e) {
    setTimeout(function () {
      resize_color_picker(picker_ele);
    }, 1000);
  }).on('colorpickerShow', function (e) {
    var color_picker_input_ele = e.colorpicker.popupHandler.popoverTip.find('.color-io');
    color_picker_input_ele.val(e.color.string());
    color_picker_input_ele.on('change keyup', function () {
      e.colorpicker.setValue(color_picker_input_ele.val());
    });
  }).on('colorpickerHide', function (e) {
    var color_picker_input_ele = e.colorpicker.popupHandler.popoverTip.find('.color-io');
    color_picker_input_ele.off('change keyup');
  }).on('colorpickerChange', function (e) {
    var color_picker_input_ele = e.colorpicker.popupHandler.popoverTip.find('.color-io');

    if (e.value === color_picker_input_ele.val() || !e.color || !e.color.isValid()) {
      return;
    }

    color_picker_input_ele.val(e.color.string());
  });
  picker_ele.parent().find('.colorpicker-input-addon').on('click', function (e) {
    picker_ele.colorpicker('colorpicker').show();
  });
  jQuery(window).resize(function (e) {
    resize_color_picker(picker_ele);
  });
}
/**
 * Resize the colorpicker element when screensize changes
 * @param {element} picker_ele The element to resize
 */


function resize_color_picker(picker_ele) {
  var rem_value = parseInt(getComputedStyle(document.documentElement).fontSize),
      width = picker_ele.parent().width() - rem_value * .75 * 2 - 2,
      color_picker_obj = picker_ele.colorpicker('colorpicker'),
      slider_obj = color_picker_obj.options.slidersHorz;
  slider_obj.alpha.maxLeft = width;
  slider_obj.alpha.maxTop = 0;
  slider_obj.hue.maxLeft = width;
  slider_obj.hue.maxTop = 0;
  slider_obj.saturation.maxLeft = width;
  slider_obj.saturation.maxTop = 150;
  color_picker_obj.update();
}
/**
 * Initialize the code editors
 * @param {string} id The ID of the code editor to initialize
 */


function init_code_editor(id) {
  if (!id.startsWith('#')) {
    id = '#' + id;
  }

  var format = jQuery(id)[0].hasAttribute('data-format') ? jQuery(id).data('format') : 'html',
      editor_settings_obj = wp.codeEditor.defaultSettings ? _.clone(wp.codeEditor.defaultSettings) : {};
  editor_settings_obj.codemirror = _.extend({}, editor_settings_obj.codemirror, {
    mode: format
  });
  wp.codeEditor.initialize(jQuery(id), editor_settings_obj);
}
/**
 * Displays available server-side error messages
 */


function display_errors() {
  if (typeof wp_errors == "undefined" && (typeof wp_errors === "undefined" ? "undefined" : _typeof(wp_errors)) == "object") {
    wp_errors = wp_errors;
  }

  if ((typeof wp_errors === "undefined" ? "undefined" : _typeof(wp_errors)) === 'object') {
    jQuery.each(wp_errors.error_data, function (index, val) {
      if (val !== 'form-error' && val !== 'form-success') {
        jQuery('#' + val).addClass('invalid-feedback d-block').removeClass('d-none');
        jQuery('#' + val).parent().find('.form-control').addClass('is-invalid').removeClass('is-valid');
      } else {
        jQuery('#' + val).addClass('d-block').removeClass('d-none').html(wp_errors.errors[index]);
      }
    });
  }
}

String.prototype.replaceAll = function (search, replacement) {
  var target = this;
  return target.split(search).join(replacement);
};

jQuery.fn.get_comments = function () {
  return this.contents().map(function () {
    if (this.nodeType === 8) return this.nodeValue;
  }).get();
};
//# sourceMappingURL=simpods-admin.js.map
