"use strict";

var select_list = '<option value="">' + sh_l10n.select + '</option>',
    parent_list = '<option value="">' + sh_l10n.child_table + '</option>',
    grandpa_list = '<option value="">' + sh_l10n.parent_table + '</option>',
    grandpa_item_list = '<option value="">' + sh_l10n.parent_table + '</option>';
jQuery(document).ready(function ($) {
  $('#simpods-sph-add-submit').prop('disabled', true); // Update parent table when child table updates

  $('#sp_child').on('change', function () {
    var list = parent_list;
    $('#sp_parent').prop('disabled', true).html(list);
    $('#sp_granditem').prop('disabled', true).html(grandpa_item_list);
    $('#sp_parent').parents('td').addClass('field-spinner');

    if ($(this).val() == '') {
      $('#sp_parent').html(list);
      $('#sp_granditem').html(grandpa_list);
      $('#sp_parent').parents('td').removeClass('field-spinner');
      $('#simpods-sph-add-submit').prop('disabled', true);
    } else {
      var data_obj = {
        table: $(this).val(),
        action: 'hierarchy_child_change',
        security: simpods_hierarchy_ajax.nonce
      };
      $.post(simpods_hierarchy_ajax.ajaxurl, data_obj, function (return_obj) {
        list = select_list;

        if (return_obj != null) {
          var options_obj = {};

          for (var key in return_obj) {
            var type_str = return_obj[key].type.replace('_', ' '),
                title = return_obj[key].title,
                label = type_str.capitalize() + ': ' + title;
            options_obj[key] = label;
          }

          options_obj = sort_associated_object(options_obj);

          for (var key in options_obj) {
            list += '<option value="' + key + '">' + options_obj[key] + '</option>';
          }
        }

        $('#sp_parent').html(list);
        $('#sp_granditem').html(grandpa_item_list);
        $('#sp_parent').prop('disabled', false);
        $('#sp_parent').parents('td').removeClass('field-spinner');
      });
    }
  }); // Update grandparent table when parent table updates

  $('#sp_parent').on('change', function () {
    var list = grandpa_item_list;
    $('#sp_granditem').prop('disabled', true).html(list);
    $('#sp_granditem').parents('td').addClass('field-spinner');

    if ($(this).val() == '') {
      $('#sp_granditem').html(list);
      $('#sp_granditem').parents('td').removeClass('field-spinner');
      $('#simpods-sph-add-submit').prop('disabled', true);
    } else {
      var data_obj = {
        table: $(this).val(),
        action: 'hierarchy_parent_change',
        security: simpods_hierarchy_ajax.nonce
      };
      $.post(ajax_script.ajaxurl, data_obj, function (return_obj) {
        list = '<option value="">' + sh_l10n.grandparent + '</option>';
        $('.grandtable').html('');

        if (return_obj != null && return_obj['grandtable'] != null && return_obj['grandtable'].length != 0) {
          $('.grandtable').html(' - From ' + return_obj['grandtable']);
          list = '<option value="0">' + sh_l10n.all + '</option>';
        }

        if (return_obj != null && return_obj['categories'] != null && return_obj['categories'].length != 0) {
          for (var key in return_obj['categories']) {
            list += '<option value="' + key + '">' + return_obj['categories'][key] + '</option>';
          }
        }

        $('#sp_granditem').html(list).prop('disabled', false);
        $('#simpods-sph-add-submit').prop('disabled', false);
        $('#sp_granditem').parents('td').removeClass('field-spinner');
      });
    }
  });
  $('#edit-sp_child').on('change', function () {
    var vals_obj = {
      id: $('#edit-id').val()
    };
    $('#simpods-sph-edit select').each(function () {
      var key_str = $(this).attr('name'),
          val_str = $(this).val();
      vals_obj[key_str] = val_str;
    });
    var options_str = get_options(vals_obj);
    $('#edit-sp_parent').prop('disabled', true);
    $('#edit-sp_parent').empty().append(options_str);

    if ($('#edit-sp_parent').children('option[value="' + vals_obj.sp_parent + '"]').length) {
      $('#edit-sp_parent').val(vals_obj.sp_parent);
    } else {
      $('#edit-sp_parent').val('');
    }

    $('#edit-sp_parent').prop('disabled', false);
  }); // Update grandparent table when parent table updates

  $('#edit-sp_parent').on('change', function () {
    var list = grandpa_item_list;
    $('#edit-sp_granditem').prop('disabled', true).html(list);
    $('#edit-sp_granditem').parents('td').addClass('field-spinner');

    if ($(this).val() == '') {
      $('#edit-sp_granditem').html(list);
      $('#edit-sp_granditem').parents('td').removeClass('field-spinner');
      $('#simpods-sph-edit-submit').prop('disabled', true);
    } else {
      editor_grandparent($(this).val());
    }
  });
  $('.edit-btn').click(function (e) {
    var vals_obj = {},
        $this_el = jQuery(this);
    $this_el.parents('tr').children('td.values').children().each(function () {
      var key_str = jQuery(this).data('key'),
          val_str = jQuery(this).data('value');
      vals_obj[key_str] = val_str;

      if (typeof vals_obj[key_str] === 'string') {
        vals_obj[key_str] = vals_obj[key_str].replaceAll('\\r\\n', '\r\n');
      }

      if (key_str === 'sp_parent') {
        $('#edit-sp_granditem').prop('disabled', true);
        editor_grandparent(vals_obj[key_str]);
      }
    });
    var options_str = get_options(vals_obj);
    $('#edit-sp_parent').empty().append(options_str);
  });
  $('#simpods-sph-add-submit').click(function (e) {
    e.preventDefault();

    if ($('#simpods-sph-add-form').find('input, select, textarea').bootstrap_validate()) {
      $('#simpods-sph-add-form').submit();
    }
  });
  $('#simpods-sph-edit-submit').click(function (e) {
    e.preventDefault();

    if ($('#simpods-sph-edit').find('input, select, textarea').bootstrap_validate()) {
      $('#simpods-sph-edit').submit();
    }
  });
  open_edit_modal('simpods-sph-modal');
});

function get_options(vals_obj) {
  var options_arr = Object.assign({}, tables),
      options_str = '<option value="">' + sh_l10n.select + '</option>',
      parents_arr = [];
  delete options_arr[vals_obj.sp_child];

  for (var key in areas) {
    if (!areas.hasOwnProperty(key) || areas[key].id == vals_obj.id || areas[key].sp_child != vals_obj.sp_child) {
      continue;
    }

    parents_arr.push(areas[key].sp_parent);
  }

  parents_arr = parents_arr.filter(function (value, index, self) {
    return self.indexOf(value) === index;
  });

  for (var key in options_arr) {
    if (!options_arr.hasOwnProperty(key) || parents_arr.includes(key)) {
      continue;
    }

    options_str += '<option value="' + key + '">' + options_arr[key] + '</option>';
  }

  return options_str;
}

function editor_grandparent(table_str) {
  var list = grandpa_item_list,
      data_obj = {
    table: table_str,
    action: 'hierarchy_parent_change',
    security: simpods_hierarchy_ajax.nonce
  };
  jQuery('#edit-sp_granditem').html(list).parents('td').addClass('field-spinner');
  jQuery('#simpods-sph-edit-submit').prop('disabled', true);
  jQuery.post(ajax_script.ajaxurl, data_obj, function (return_obj) {
    jQuery('.grandtable').html('');
    list = '<option value="">' + sh_l10n.grandparent + '</option>';

    if (return_obj != null && return_obj['grandtable'] != null && return_obj['grandtable'].length != 0) {
      jQuery('.grandtable').html(' - From ' + return_obj['grandtable']);
      list = '<option value="0">' + sh_l10n.all + '</option>';
    }

    if (return_obj != null && return_obj['categories'] != null && return_obj['categories'].length != 0) {
      for (var key in return_obj['categories']) {
        list += '<option value="' + key + '">' + return_obj['categories'][key] + '</option>';
      }
    }

    jQuery('#edit-sp_granditem').html(list).prop('disabled', false);
    jQuery('#simpods-sph-edit-submit').prop('disabled', false);
    jQuery('#edit-sp_granditem').parents('td').removeClass('field-spinner');
  });
} // https://stackoverflow.com/a/3291856


function sort_associated_object(list) {
  var sortable = [];

  for (var key in list) {
    sortable.push([key, list[key]]);
  }

  sortable.sort(function (a, b) {
    return a[1] < b[1] ? -1 : a[1] > b[1] ? 1 : 0;
  });
  var ordered_list = {};

  for (var i = 0; i < sortable.length; i++) {
    ordered_list[sortable[i][0]] = sortable[i][1];
  }

  return ordered_list;
} // https://stackoverflow.com/a/3291856


String.prototype.capitalize = function () {
  return this.charAt(0).toUpperCase() + this.slice(1);
};
//# sourceMappingURL=simpods-hierarchy.js.map
