"use strict";

jQuery(document).ready(function ($) {
  $('.spiu-check-update-btn').click(function (evt) {
    evt.preventDefault();
    check_updates();
  });
  /**
   * check simpodsmvc.me to see if updates availabe
   * @return null
   */

  function check_updates() {
    $('#spiu-check-update-spinner').removeClass('d-none');
    $('#spiu-notice').removeClass('notice');
    $('#spiu-notice').removeClass('notice-success');
    $('#spiu-notice').removeClass('notice-error');
    $('#spiu-notice').text('');
    var data_obj = {
      action: 'spiu_check_updates',
      security: $('#spiu_install_update_nonce').val()
    };
    $.post(simpods_install_update_ajax.ajaxurl, data_obj, function (return_obj) {
      $('#spiu-notice').text(return_obj['status']);

      if (return_obj['eligible'] == true) {
        $('#spiu-notice').addClass('notice notice-success');
        location.reload();
      } else {
        $('#spiu-notice').addClass('notice notice-error');
        $('#spiu-check-update-spinner').addClass('d-none');
      }
    });
  }

  $('.spiu-call-modal').click(function (e) {
    if ($(this).hasClass('disabled') == false) {
      // pass the data into the modal form
      $('#spiu-licence-key').removeClass('is-invalid');
      $('#spiu_licence-error').addClass('d-none');
      $('#spiu-licence-key').val('');
      $('#spiu-licence-key').val($(this).data('licence'));
      $('#spiu-product').val($(this).data('product'));
      $('#spiu-admin-page-slug').val($(this).data('admin-page-slug'));
      $('#spiu-product_title').val($(this).data('title'));
      $('#spiu_admin_page_slug').val($(this).data('admin-page-slug'));
      $('#spiu-modal').modal();
      enable_buttons();
      $('#spiu-cat').val($(this).data('cat'));
      $('#spiu-modal-feedback').removeClass('notice');
      $('#spiu-modal-feedback').removeClass('notice-success');
      $('#spiu-modal-feedback').removeClass('notice-error');
      $('#spiu-modal-feedback').text('');
      $('#spiu-modal-feedback').addClass('d-none');
      $('#spiu-modal-info').html($('#' + $('#spiu-product').val() + '-info').html() + '<br/>' + $('#' + $('#spiu-product').val() + '-latest-version').html());
      $('#spiu-licence-key-input-wrap').removeClass('d-none');

      if ($(this).data('licence-required') == 1) {
        $('#spiu-licence-key').prop('disabled', false);
        $('#spiu-licence-key-no-needed').addClass('d-none');
      } else {
        $('#spiu-licence-key').prop('disabled', true);
        $('#spiu-licence-key-no-needed').removeClass('d-none');
      }
    }
  });
  $('.spiu-call-modal a').click(function (e) {
    e.stopPropagation();
  });
  $('#spiu-submit').on('click', function (evt) {
    $('#spiu-modal-feedback').removeClass('notice-success');
    $('#spiu-modal-feedback').removeClass('notice-error');
    $('#spiu-submit').prop('disabled', true);
    $('#friend-spinner').removeClass('d-none');
    evt.preventDefault();
    var is_licence_required = $('#' + $('#spiu-product').val() + '-product-btn').data('licence-required');

    if (is_licence_required == 1 && $.trim($('#spiu-licence-key').val()) == '') {
      $('#spiu-licence-key').addClass('is-invalid');
      $('#spiu_licence-error').removeClass('d-none');
    } else {
      $('#spiu-licence-key').removeClass('is-invalid');
      $('#spiu_licence-error').addClass('d-none');
    }

    if (is_licence_required == 1 && ($.trim($('#spiu-licence-key').val()) == '' || $.trim($('#spiu-product').val()) == '')) {
      //allow entering the licence
      $('#friend-spinner').addClass('d-none');
      enable_buttons();
    } else {
      var data_obj = {
        product: $('#spiu-product').val(),
        action: 'spiu_register_key',
        security: $('#spiu_install_update_nonce').val(),
        key: $('#spiu-licence-key').val(),
        get_key: is_licence_required
      }; // check with simpodsmvc.me to see if this update is eligible

      $.post(simpods_install_update_ajax.ajaxurl, data_obj, function (return_obj) {
        $('#spiu-modal-feedback').removeClass('d-none');

        if (return_obj != null) {
          if (return_obj['eligible'] == true) {
            $('#spiu-modal-feedback').text(spiu_l10n.validated);
            $('#spiu-modal-feedback').addClass('notice notice-success'); //$('#' + $('#spiu-product').val() + '-info').text( spiu_l10n.processing + ': ' + return_obj['version'] );

            $('#spiu-target_theme').val(return_obj['target_theme']);
            $('#spiu-fetch_file').val(return_obj['file']);
            $('#spiu-center_nonce').val(return_obj['nonce']);
            $('#spiu-version').val(return_obj['version']);
            $('#spiu_admin_page_slug').val(return_obj['simpods_admin_page_slug']);

            if (typeof return_obj['redirect_to_its_area'] != 'undefined') {
              $('#spiu-redirect_to_its_area').val(return_obj['redirect_to_its_area']);
            } //console.log(return_obj);
            // submit the same form, this time, it is not ajax. A zip file will be pull over to intall the files


            $('#spiu-install-update-form').submit();
            /*
            var goFetch_obj = {
            	fetch_file: return_obj['file'],
            	center_nonce: return_obj['nonce'],
            	security: 	return_obj['remote_nonce'],
            	action: 'spiu_install_update',
            	product: data_obj['product'],
            };
            		$.post(
            	ajax_script.ajaxurl,
            	goFetch_obj,
            	function( install_obj ) {
            		console( install_obj );
            	}
            )	*/
          } else {
            $('#spiu-modal-feedback').text(return_obj['status']);
            $('#friend-spinner').addClass('d-none');
            enable_buttons();
            $('#spiu-modal-feedback').addClass('notice notice-error');
          }
        } else {
          $('#spiu-modal-feedback').text('System Error. Please contact the admin.');
          $('#spiu-modal-feedback').addClass('notice notice-error');
        }
      });
    }
  });
  /**
   * Remove disabled attribute is the disable string is empty, so the buttons are enabled.
   */

  function enable_buttons() {
    if (simpods_install_update_params['disable'] == '') {
      $('#spiu-submit').prop('disabled', false);
    }
  }
});

function activate_plugin(plugin_file, redirect_to) {
  var data = {
    action: 'simpods_activate_plugin',
    security: simpods_admin_ajax.nonce,
    plugin: plugin_file
  };
  jQuery('#spiu-check-update-spinner').removeClass('d-none');
  jQuery.post(simpods_admin_ajax.ajaxurl, data, function (return_obj) {
    jQuery('#spiu-check-update-spinner').addClass('d-none');

    if (return_obj.success == true) {
      if (redirect_to != '') {
        window.location = redirect_to;
      } // button.parent().parent('.card-square').find('.bg-danger').text('Activated');
      // button.parent().parent('.card-square').find('.bg-danger').removeClass('bg-danger').addClass('bg-success');
      // button.replaceWith('<button type="button" class="btn btn-outline-simpods-purple btn-block btn-simpods-disabled" disabled="">Active</button>');

    } else {
      alert('Failed. Please try it in the Plugins section.');
    }
  });
}
//# sourceMappingURL=simpods-install-update.js.map
