"use strict";

var select_list = '<option value="">' + sh_l10n.select + '</option>',
    friend_list = '<option value="">' + sh_l10n.main_table + '</option>';
jQuery(document).ready(function ($) {
  $('#simpods-la-add-submit').prop('disabled', true); // Update friend tables when main table changed

  $('#spl_main').on('change', function () {
    var list = friend_list;
    $('#spl_friend').prop('disabled', true).html(list);
    $('#spl_friend').parents('td').addClass('field-spinner');

    if ($(this).val() == '') {
      $('#spl_friend').html(list);
      $('#spl_friend').parents('td').removeClass('field-spinner');
      $('#simpods-la-add-submit').prop('disabled', true);
    } else {
      var data_obj = {
        table: $(this).val(),
        action: 'linked_area_main_change',
        security: simpods_linked_areas_ajax.nonce
      };
      $.post(ajax_script.ajaxurl, data_obj, function (return_obj) {
        list = select_list;

        if (return_obj != null) {
          var options_obj = {};

          for (var key in return_obj) {
            var type = return_obj[key].type.replace('_', ' '),
                title = return_obj[key].title,
                label = type.capitalize() + ': ' + title;
            options_obj[key] = label;
          }

          options_obj = sort_associated_object(options_obj);

          for (var key in options_obj) {
            list += '<option value="' + key + '">' + options_obj[key] + '</option>';
          }
        }

        $('#spl_friend').html(list).prop('disabled', false);
        $('#spl_friend').parents('td').removeClass('field-spinner');
        $('#simpods-la-add-submit').prop('disabled', false);
      });
    }
  });
  $('#edit-spl_main').on('change', function () {
    var values_obj = {
      id: $('#edit-id').val()
    };
    $('#simpods-la-edit select').each(function () {
      var key = $(this).attr('name'),
          value = $(this).val();
      values_obj[key] = value;
    });
    var options_list = get_options(values_obj);
    $('#edit-spl_friend').empty().append(options_list);

    if ($('#edit-spl_friend').children('option[value="' + values_obj.spl_friend + '"]').length) {
      $('#edit-spl_friend').val(values_obj.spl_friend);
    } else {
      $('#edit-spl_friend').val('');
    }
  });
  $('.edit-btn').click(function (e) {
    var values_obj = {},
        this_element = jQuery(this);
    this_element.parents('tr').children('td.values').children().each(function () {
      var key = jQuery(this).data('key'),
          value = jQuery(this).data('value');
      values_obj[key] = value;

      if (typeof values_obj[key] === 'string') {
        values_obj[key] = values_obj[key].replaceAll('\\r\\n', '\r\n');
      }
    });
    var options_list = get_options(values_obj);
    $('#edit-spl_friend').empty().append(options_list);
  });
  $('#simpods-la-add-submit').click(function (e) {
    e.preventDefault();

    if ($('#simpods-la-add-form').find('input, select, textarea').bootstrap_validate()) {
      $('#simpods-la-add-form').submit();
    }
  });
  $('#simpods-la-edit-submit').click(function (e) {
    e.preventDefault();

    if ($('#simpods-la-edit').find('input, select, textarea').bootstrap_validate()) {
      $('#simpods-la-edit').submit();
    }
  });
  open_edit_modal('simpods-la-modal');
});

function get_options(values_obj) {
  var options = Object.assign({}, tables),
      options_list = '<option value="">' + sh_l10n.select + '</option>',
      friends = [];
  delete options[values_obj.spl_main];

  for (var key in areas) {
    if (!areas.hasOwnProperty(key) || areas[key].id == values_obj.id || areas[key].spl_main != values_obj.spl_main) {
      continue;
    }

    friends.push(areas[key].spl_friend);
  }

  friends = friends.filter(function (value, index, self) {
    return self.indexOf(value) === index;
  });

  for (var key in options) {
    if (!options.hasOwnProperty(key) || friends.includes(key)) {
      continue;
    }

    options_list += '<option value="' + key + '">' + options[key] + '</option>';
  }

  return options_list;
} // https://stackoverflow.com/a/3291856


function sort_associated_object(list) {
  var sortable = [];

  for (var key in list) {
    sortable.push([key, list[key]]);
  }

  sortable.sort(function (a, b) {
    return a[1] < b[1] ? -1 : a[1] > b[1] ? 1 : 0;
  });
  var ordered_list = {};

  for (var i = 0; i < sortable.length; i++) {
    ordered_list[sortable[i][0]] = sortable[i][1];
  }

  return ordered_list;
} // https://stackoverflow.com/a/3291856


String.prototype.capitalize = function () {
  return this.charAt(0).toUpperCase() + this.slice(1);
};
//# sourceMappingURL=simpods-linked-areas.js.map
