<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * MVC Admin Parent Cross Admin class
 *
 * @version: 2.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 11/10/2017
 */
class MVC_Admin_Parent_Cross_Admin extends MVC_Admin_General {
	
	public $message_css_class  	= '';
	public $full_logo    		= '';
	public $simple_logo  		= '';
	
	public function __construct( $can_init = true ) { 
		if ( $can_init ) {
			MVC_Admin_Factory::$post_type = $this->get_cur_post_type();
		
			$this->force_actions();
			$this->force_filters();
		}
	}
	public function actions() {}
	public function filters() {}
	public function enqueue() {}
	/**
	 * to_submenu_fn: add this to the submenu of Simpods
	 */
	public function to_submenu() {}
	/**
	 * interface_fn: add an interface of this
	 */
	public function interface() {}
	final public function for_ajax() {
		global $funs;
		MVC_Admin_Factory::$post_type 	= $this->get_cur_post_type();
		$tables							= $funs->get_tables();
//		MVC_Admin_Factory::$act_tables     	= array_merge( $tables['act_tables'], $tables['act_pod_tables'] ) ;
		MVC_Admin_Factory::$act_tables     	= $tables['act_tables'] ;
   		MVC_Admin_Factory::$act_pod_tables 	= $tables['act_pod_tables'];
	}
	final public function force_actions() {
		//	post types
		add_action( 'save_post', array( $this, 'ID_to_id' ) );
		// users
		add_action( 'profile_update', array( $this, 'ID_to_id' ) );
		add_action( 'user_register', array( $this, 'ID_to_id' ), 10, 1 );
		add_action( 'admin_enqueue_scripts', array( $this, 'force_enqueue' ), 9 );
		add_action( 'admin_enqueue_scripts', array( $this, 'page_specific_enqueue' ), 11 );

	}
	final public function force_filters() {
		//add_filter( 'map_meta_cap', array( $this, 'mc_admin_users_caps' ), 1, 4 );
		remove_all_filters( 'enable_edit_any_user_configuration' );
		add_filter( 'enable_edit_any_user_configuration', '__return_true' );
		add_filter( 'admin_head', array( $this, 'mc_edit_permission_check' ), 1, 4 );
	}
	final public function force_enqueue() {
		global $funs;
		// Simpods MVC Only
		// $parent_css_files = array(
		// 	'simpods-font'        => SIMPODS_URL . '/mvc/css/simpods-font.css',
		// 	'simpods-helpers' => SIMPODS_URL . '/mvc/library/css/simpods-helpers/simpods-helpers.css',
		// 	'simpods_admin'   => SIMPODS_URL . '/mvc/admin/css/simpods-admin.css',
		// );
		// $funs->include( $parent_css_files, false );
		// $parent_js_files = array(
		// 	'simpods_admin'    => SIMPODS_URL . '/mvc/admin/js/simpods-admin.js',
		// );
		// $funs->include( $parent_js_files, false );

		// Simpods MVC Only
		wp_register_script( 'simpods-admin', SIMPODS_URL . '/mvc/admin/js/simpods-admin.js' );
		wp_enqueue_script( 'simpods-admin' );	

		$parent_css_files = array( );

		wp_register_style( 'simpods-font', SIMPODS_URL . '/mvc/css/simpods-font.css' );			
		wp_enqueue_style( 'simpods-font' );	
		array_push( $parent_css_files, 'simpods-font' );

		wp_register_style( 'simpods-helpers', SIMPODS_URL . '/mvc/library/css/simpods-helpers/simpods-helpers.css' );			
		wp_enqueue_style( 'simpods-helpers' );	
		array_push( $parent_css_files, 'simpods-helpers' );

		wp_register_style( 'simpods-admin', SIMPODS_URL . '/mvc/admin/css/simpods-admin.css' );			
		wp_enqueue_style( 'simpods-admin' );	
		array_push( $parent_css_files, 'simpods_admin' );

		wp_localize_script(
			'simpods-admin',
			'simpods_admin_ajax',
			array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'nonce'   => wp_create_nonce( 'simpods_admin_ajax_nonce' ),
			)
		);	
		wp_localize_script( 'simpods-admin', 'l10n', array(
			'select_media' 		=> esc_html__( 'Select Media', 'simpods-cpd' ),
			'multiple'     		=> ' - ' . esc_html__( 'Use Ctrl or Shift to select multiple files.', 'simpods-cpd' ),
			'select_btn'   		=> esc_html__( 'Use Selected', 'simpods-cpd' ),
			'updated_refresh'   => esc_html__( 'Update completed. Refreshing the page', 'simpods-cpd' ),
			'updating'			=> esc_html__( 'Updating', 'simpods-cpd' ),
			'update_failed'		=> esc_html__( 'update failed. Please contact the admin', 'simpods-cpd' ),
		) );		
		// Child Only, use $funs->include() and don't specify the paths so they can be overwritten 
		$child_files = array(
			'mvc-admin-general'  => '/mvc/admin/js/mvc-admin-general.js',			
		);
		$funs->include( $child_files, true );
		$child_files = array(			
			'mvc-admin-general' => '/mvc/admin/css/mvc-admin-general.css',
		);
		$funs->include( $child_files, true );		
	}
	final public function bootstrap_custom() {
		global $funs;
		//wp_register_script( 'polyfill', 'https://polyfill.io/v3/polyfill.min.js?flags=gated&features=default' );
		//wp_enqueue_script( 'polyfill' );
		$can_include_polyfill = apply_filters( 'admin_simpods_include_polyfill', true );
		if( $can_include_polyfill ){
			wp_register_script( 'polyfill', 'https://cdn.polyfill.io/v3/polyfill.js?flags=gated&features=default' ); 
			wp_enqueue_script( 'polyfill' ); 
		}		
		wp_register_script( 'simpods-admin-library', SIMPODS_URL . '/mvc/admin/library/js/simpods-admin/js/simpods-admin-library.min.js' );
		wp_enqueue_script( 'simpods-admin-library' );	
		wp_register_style( 'simpods-admin-library', SIMPODS_URL . '/mvc/admin/library/js/simpods-admin/css/simpods-admin-library.min.css' );			
		wp_enqueue_style( 'simpods-admin-library' );			
		// $files = array(
		// 	'simpods-admin-library'  => SIMPODS_URL . '/mvc/admin/library/js/simpods-admin/js/simpods-admin-library.js',			
		// );
		// $funs->include( $files, false );
		// $files = array(			
		// 	'simpods-admin-library' => SIMPODS_URL . '/mvc/admin/library/js/simpods-admin/css/simpods-admin-library.css',
		// );
		// $funs->include( $files, false );		
		wp_enqueue_code_editor( array( 'type' => 'text/html' ) );
		
	}
	/**
	 * Returns the nav menu for the simpods admin area
	 * @return string Simpods navigation html
	 */
	final public function simpods_menu() {
		global $funs;
		$full_logo = $funs->get_final_path( 'mvc/admin/images/simpods-logos', 'simpods-logo-cutout-white-text.svg', 0, 0, 1, 1 );
		$this->full_logo = $full_logo['url'];
		$simple_logo = $funs->get_final_path( 'mvc/admin/images/simpods-logos', 'simpods-logo-cutout-white.svg', 0, 0, 1, 1 );
		$this->simple_logo = $simple_logo['url'];
		$menu_html = '<div id="simpods-menu" class="bg-dark col-12 p-0">
						<div class="simpods-logo-back d-none d-lg-block">
							<img src="' . $this->full_logo . '" alt="Simpods Logo" />
							<p class="m-0"><strong>' . esc_html__( 'Version', 'simpods-mvc' ) . ': </strong>' . SIMPODS_VERSION . '</p>
						</div>
						<nav class="navbar navbar-expand-lg navbar-dark">
							<span class="d-lg-none navbar-brand pl-3">
								<img src="' . $this->simple_logo . '" alt="Simpods Logo">
								<p class="m-0">v' . SIMPODS_VERSION . '</p>
							</span>
							<button class="navbar-toggler navbar-toggler-right mr-3" type="button" data-toggle="collapse" data-target="#simpods-nav-menu" aria-controls="simpods-nav-menu" aria-expanded="false" aria-label="' . esc_html__( 'Toggle navigation', 'simpods-mvc' ) . '">
								<span class="navbar-toggler-icon"></span>
							</button>
							<div class="navbar-collapse collapse py-3" id="simpods-nav-menu">
								<ul class="navbar-nav flex-column">
									';
		foreach ( MVC_Admin_Factory::$menu_items as $menu_item ) {
			$page_url = admin_url( 'admin.php' ) . '?page=' . $menu_item['slug'];
			$menu_html .= '<li class="nav-item ' . $this->get_active_link( $menu_item['slug'] ) . '">
				<a class="nav-link" href="' . esc_url( $page_url ) . '">
					<span class="' . $menu_item['icon'] . ' mr-2"></span>
					<span>' . $menu_item['title'] . '</span>
				</a>
			</li>';
		}
		$menu_html .= '
									</ul>
								</div>
							</nav>
						</div>';
		return $menu_html;
	}
	/**
	 * Ensures only administrator users can access wp-admin
	 *
	 * @return null
	 */
	public function blockusers_init() {
		global $current_user;
		if ( is_user_logged_in() ) {
			if ( is_admin() && !current_user_can( 'administrator' ) && !( defined( 'DOING_AJAX' ) && DOING_AJAX ) && !in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) ) {
				wp_redirect( home_url() );
				exit;
			}
		}
	}
	/**
	 * Initialize the message for the action
	 * @param  string $message The message
	 * @param  string $css_class     The class name
	 * @return null
	 */
	public function init_message( $message, $css_class = 'notice-info' ) {
		$this->message = $message;
		$this->message_css_class  = $css_class;
		add_action( 'admin_notices', array( $this, 'render_message' ) );
		if( is_multisite() ){
			add_action( 'network_admin_notices', array( $this, 'render_message' ) );
		}
	}
	/**
	 * Renders a message
	 * @return null
	 */
	public function render_message() {
		printf(
			'<div id="simpods-controller-display" class="%s notice is-dismissible block-editor screen-meta"><p><strong>%s</strong>%s</p></div>',
			$this->message_css_class,
			esc_html__( 'Simpods - Current controller path: ', 'simpods-mvc' ),
			$this->message
		);
	}
	/**
	 * Inserts a post ID to a pods table. By default, pods won't insert an entry if the pods table doesn't have any fields.
	 *
	 * @return null
	 */
	public function ID_to_id() {
		global $wpdb;
		$tables = MVC_Admin_Factory::$act_tables;
		if ( isset( $_GET['page'] ) && strpos( $_GET['page'], 'pods-manage-' ) === 0 ) {
			//only for post type table and user
			return;
		} else {
			$table = MVC_Admin_Factory::$post_type;
		}
		$idx = '';
		// find out the index in the table array
		foreach ( $tables as $key => $table_data ) {
			if ( $table == $table_data['pod'] ) {
				$idx = $key;
				break;
			}
		}
		// if no table found, return
		if ( $idx == '' ) {
			return;
		}
		$id = get_the_ID();
		if ( $tables[ $idx ]['type'] == 'user' ) {
			global $user_id;
			$id = $user_id;
		}
		if ( $tables[ $idx ]['type'] == 'post_type' ) {
			$id = get_the_ID();
		}
		// try to insert
		if ( is_numeric( $id ) && $id != 0 ) {
			$query = $wpdb->prepare( 'INSERT IGNORE INTO `' . $wpdb->prefix . $tables[$idx]['name'] . '` (`id`) VALUES ("%d");', array( $id ) );
			$wpdb->query( $query );
		}
	}
	/**
	 * Allow administrators on multisite to edit users!
	 *
	 * @param array   $caps All capabilities
	 * @param string  $cap Each capability
	 * @param integer $user_id User ID
	 * @param unknown $args Unknown, not specified by the author
	 * @return array
	 */
	public function mc_admin_users_caps( $caps, $cap, $user_id, $args ) {
		foreach ( $caps as $key => $capability ) {
			if ( $capability != 'do_not_allow' ) {
				continue;
			}
			switch ( $cap ) {
			case 'edit_user':
			case 'edit_users':
				$caps[ $key ] = 'edit_users';
				break;
			case 'delete_user':
			case 'delete_users':
				$caps[ $key ] = 'delete_users';
				break;
			case 'create_users':
				$caps[ $key ] = $cap;
				break;
			}
		}
		return $caps;
	}
	 /**
	  * Checks that both the editing user and the user being edited are
	  * members of the blog and prevents the super admin being edited.
	  * @link https://thereforei.am/2011/03/15/how-to-allow-administrators-to-edit-users-in-a-wordpress-network/
	  *
	  * @return void
	  */
	public function mc_edit_permission_check() {
		global $current_user, $profileuser;
		$screen = get_current_screen();
		wp_get_current_user();
		if ( !is_super_admin( $current_user->ID ) && in_array( $screen->base, array( 'user-edit', 'user-edit-network' ) ) ) {
			// editing a user profile
			if ( is_super_admin( $profileuser->ID ) ) {
				// trying to edit a superadmin while less than a superadmin
				wp_die( esc_html__( 'You do not have permission to edit this user.', 'simpods-mvc' ) );
			} elseif ( !( is_user_member_of_blog( $profileuser->ID, get_current_blog_id() ) && is_user_member_of_blog( $current_user->ID, get_current_blog_id() ) ) ) {
				// editing user and edited user aren't members of the same blog
				wp_die( esc_html__( 'You do not have permission to edit this user.', 'simpods-mvc' ) );
			}
		}
	}
	/**
	 * Automatically load the js and css for the current template. Priorities: child theme > parent theme > plugin > component > simpods mvc 
	 *
	 * @return null
	 */
	final public function page_specific_enqueue() {
		global $funs;
		$depths = array(
			'js'  => MVC_Admin_Parent_Factory::$scripts,
			'css' => MVC_Admin_Parent_Factory::$styles,
		);
		// Child theme, and then parent theme first
		$files = array(
			MVC_Admin_Factory::$short_controller_slug . '' => '/mvc/admin/css/' . MVC_Admin_Factory::$short_controller_slug . '.css',			
		);
		$depths = $funs->include( $files, true, $depths );
		$files = array(			
			MVC_Admin_Factory::$short_controller_slug . ''  => '/mvc/admin/js/' . MVC_Admin_Factory::$short_controller_slug . '.js',
		);
		$depths = $funs->include( $files, true, $depths );	
		//Now process component plugins.
		$component_plugins = SIMPODS_COMPONENT_PLUGINS;

        if ( is_array( $component_plugins ) ) {
        	// same name files can be loaded, just prefix with the plugin name
        	//if( ! in_array( MVC_Admin_Factory::$short_controller_slug . '-js', $depths['js'] ) ){
            	foreach ( $component_plugins as $plugin_slug => $plugin_info ) {
            		$path 	= WP_PLUGIN_URL . '/' . $plugin_slug . '/mvc/admin/js/' . MVC_Admin_Factory::$short_controller_slug.'.js';            		
					$files = array(
						 $plugin_slug . '-' . MVC_Admin_Factory::$short_controller_slug . ''  => $path,
					);
					$depths = $funs->include( $files, false, $depths );
					
            	}
        	//}
        	// if the css file is not avaiable in the theme
        	//if( ! in_array( MVC_Admin_Factory::$short_controller_slug . '-css', $depths['css'] ) ){
            	foreach ( $component_plugins as $plugin_slug => $plugin_info ) {
            		$path 	= WP_PLUGIN_URL . '/' . $plugin_slug . '/mvc/admin/css/' . MVC_Admin_Factory::$short_controller_slug.'.css';
					$files = array(
						$plugin_slug . '-' . MVC_Admin_Factory::$short_controller_slug . ''  => $path,
					);
					$depths = $funs->include( $files, false, $depths );
					
            	}
        	//}        	
        	// same name files can be loaded, just prefix with the plugin name
     //    	//if( ! in_array( MVC_Admin_Factory::$short_controller_slug . '-js', $depths['js'] ) ){
     //        	foreach ( $component_plugins as $plugin_slug => $plugin_info ) {
     //         		$path 	= WP_PLUGIN_URL . '/' . $plugin_slug . '/mvc/admin/js/' . MVC_Admin_Factory::$short_controller_slug.'.js';            

					// $script_id = $plugin_slug . ' - ' . MVC_Admin_Factory::$short_controller_slug;
					// wp_register_script( $script_id, $path );
					// wp_enqueue_script( $script_id );	
					// array_push( $depths['js'], $script_id );
     //        	}
     //    	//}
     //    	// if the css file is not avaiable in the theme
     //    	//if( ! in_array( MVC_Admin_Factory::$short_controller_slug . '-css', $depths['css'] ) ){
     //        	foreach ( $component_plugins as $plugin_slug => $plugin_info ) {
     //         		$path 	= WP_PLUGIN_URL . '/' . $plugin_slug . '/mvc/admin/css/' . MVC_Admin_Factory::$short_controller_slug.'.css';

					// $style_id = $plugin_slug . ' - ' . MVC_Admin_Factory::$short_controller_slug;
					// wp_register_style( $style_id, $path );			
					// wp_enqueue_style( $style_id );	
					// array_push( $depths['css'], $style_id );					
     //        	}
     //    	//}              	
        }	
	}
	/**
	 * Register a Simpods Plugin. Controllers and AJax named like cross_{plugin-folder}.php 
	 * and cross_{plugin-folder}.php will be autoloaded. No need to register them.
	 *
	 * @param string|array plugin folder name|$settings_data array(
     *       'plugin-folder'  => array(
	 *	
     *           'front' => array(
     *               'ctrl' => array(
     *                   'ctrl_example' => 'ctrl_example.php',
     *               ),
     *               'ajax' => array(
     *                   'example_ajax' => 'example_ajax.php',
     *               ),
     *           ),
     *           'admin' => array(
     *               'ctrl' => array(  
     *               	'ctrl_example' => 'ctrl_example.php', // custom controller instance won't be auto-created.                      
	 *              ),
     *              'ajax' => array(
     *               	'example_ajax' => 'example_ajax.php',
     *              ),
     *          ),
     *      )
     *   );
     * @return null
	 */
	final public function register_simpods_plugin( $settings_data, $network_wide ){

		$saved_plugins = SIMPODS_COMPONENT_PLUGINS; //get_option( 'simpods_component_plugins', array() );

		$settings	= $settings_data;
		if( is_string( $settings_data ) ) {
			$settings = array( $settings_data => array() );
		}
		if( is_array( $settings ) ){
			foreach( $settings as $key => $v_arr ) {
				if( is_string( $key ) && is_array( $v_arr ) ){
					$saved_plugins[ $key ] = $v_arr;
				}
			}
		}
		
		update_option( 'simpods_component_plugins', $saved_plugins );
				
		
		if ( MULTISITE_ON == true && $network_wide ) {
			$saved_plugins = SIMPODS_COMPONENT_PLUGINS_MULTISITE;
			
			$settings	= $settings_data;
			if( is_string( $settings_data ) ) {
				$settings = array( $settings_data => array() );
			}
			if( is_array( $settings ) ){
				foreach( $settings as $key => $v_arr ) {
					if( is_string( $key ) && is_array( $v_arr ) ){
						$saved_plugins[ $key ] = $v_arr;
					}
				}
			}
			
			update_blog_option( 1, 'simpods_component_plugins_multisite', $saved_plugins );
			
		}
	}
	/**
	 * deregister a Simpods plugin
	 *
	 * @param string $plugin_name the plugin name
	 * @return null
	 */
	final public function deregister_simpods_plugin( $plugin_name, $network_wide ){

		$saved_plugins = SIMPODS_COMPONENT_PLUGINS; //get_option( 'simpods_component_plugins', array() );

		if( is_string( $plugin_name ) ) {
			if( isset( $saved_plugins[ $plugin_name ] ) ){
				unset( $saved_plugins[ $plugin_name ] );
			}
		}

		update_option( 'simpods_component_plugins', $saved_plugins );

		if ( MULTISITE_ON == true && $network_wide ) {
			$saved_plugins = SIMPODS_COMPONENT_PLUGINS_MULTISITE;
			if( is_string( $plugin_name ) ) {
				if( isset( $saved_plugins[ $plugin_name ] ) ){
					unset( $saved_plugins[ $plugin_name ] );
				}
			}
			update_blog_option( 1, 'simpods_component_plugins_multisite', $saved_plugins );
		}
	}
	/**
	 * Add custom column heads to the post table
	 * 
	 * @param $columns_head array the column heads
	 */ 
	public function column_heads( $column_heads ) {
	    $column_heads[ 'simpods_sorting' ]  = esc_html__( 'Sort', 'simpods-mvc' );
	    return $column_heads;
	}
	/**
	 * Add custom column contents to the post table
	 * 
	 * @param $column_name string the name of the column
	 * @param $post_id int the post id
	 */ 	 
	public function column_contents( $column_name, $post_id ) {
	    if ( $column_name == 'simpods_sorting') {
			$post       = get_post( $post_id );
			    	
	        echo '<span class="' . $column_name . '_data" data-id= "' . absint( $post_id ) . '" data-order="' . absint( $post->menu_order ) . '" ><span class="dashicons dashicons-sort"></span></span>';
	    }
	}
	/**
	 * Add menu_order to the order command
	 *
	 * @since 2.0.0
	 * @param string $order_by order by in the query.
	 *
	 * @return string append menu_order to $order_by
	 */
	public function posts_sorting( $order_by ) {
		global $wpdb;
		if ( false === strpos( $order_by, 'menu_order' ) ) {
			$order_by = $wpdb->prefix . 'posts.menu_order ASC, ' . $order_by;
		}
		return $order_by;
	}	
}
