<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Simpods Email
 *
 * @package Simpods MVC
 * @author Dongjie Xu
 * @since 1.0.0 20/05/2015
 */
class MVC_Admin_Simpods_Email extends MVC_Admin_General {
	const PAGE_SLUG  			= 'simpods-email';
	const DB_TABLE    			= 'simpods_email';
	
	const PAGE_CAP    			= 'simpods_edit_email';	
	const PAGE_ICON 			= 'dashicons dashicons-email-alt';
	const FIELD_PREFIX    		= 'spe_';
	const URL_VAR 				= 'simpods_email';

	const EMAIL_VERSION 		= '1.152.45';
	const EMAIL_DEV     		= false;
	// databse table version
	private $database_version 	= 1.154;	
	private $admin_pods 		= null;
	public static $page_title 	= 'Simpods Email';	
	//public $order_int			= 10;	
	/**
	 * Constructer
	 * @param Boolean $can_init toggle to run the functions in the constructer,
	 *							$can_init set to true will run automatically
	 */
	public function __construct( $can_init = true ) {
		
		// carry on if it is on the right section
		if ( $can_init ) {
			//$this->create_db();	
			$this->admin_pods = new MVC_Admin_Pods( false );
			$this->actions();
			$this->filters();
			
			$this->install_email();
			
		}
		
	}
	/**
	 * actions_fn wp actions to hook automatically. Global effect.
	 */
	public function actions() {
		//add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ) );
	}
	/**
	 * filters_fn wp filters to hook automatically. Global effect.
	 */
	public function filters() {}
	/**
	 * enqueue_fn scripts and styles to enqueue automatically. Global effect.
	 */
	public function enqueue() {}
	/**
	 * to_submenu_fn: add this to the submenu of Simpods
	 */
	public function to_submenu() {}
	/**
	 * interface_fn: add an interface of this
	 */
	public function interface() {
		global $ctrl, $cross_admin, $funs;
		if( ! current_user_can( 'edit_posts' ) ){
			return false;
		}
		$alert = '<div class="alert alert-primary" role="alert">
				' . esc_html__('No email records.', 'simpods-mvc') . '
				</div>';		
		if( ! $funs->check_db_table( self::DB_TABLE ) ){
			$skip_check = true;
			$this->create_db( $skip_check );					
		} 
		//$settings_helper = new MVC_Admin_Settings_Helper();
		//$tables 		= MVC_Admin_Factory::$act_pod_tables;
		$ctrl->notice  .= $this->test_for_pods();
		//$ctrl->forms();
		$ctrl->notice  .= $this->simpods_admin_remove_item( self::DB_TABLE );
		$records 		= $funs->simpods_select( array(), array( 'target_tb' => self::DB_TABLE, 'order_by' => 'spe_group_id', 'order' => 'DESC' ) );
		$count_data   	= $funs->simpods_select( array(), array( 'target_tb' => self::DB_TABLE, 'count_only' => true ) );
		?>
		<div class="wrap" id="simpods-wrap">
			<div class="row m-0">
			<?php echo $cross_admin->simpods_menu(); ?>
				<div id="simpods-component-panel" class="col-12 col-lg p-3">
					<h1><?php echo self::$page_title; ?></h1>
					<?php echo $ctrl->notice; ?>		
					<hr>	
					<?php 
					if ( is_array( $records ) && !empty( $records ) ) { 
					?>
					
					<div id="simpods-ga-table">
					<?php
						foreach ( $records as &$record_data ) {
							$record_data = $funs->escape_attrs( $record_data );
							// $lastLogin_str = $record_data['spe_last_login'];
							// if ( $lastLogin_str !== '' && $lastLogin_str !== '0000-00-00' ) {
							// 	$lastLogin_str = strtotime( $lastLogin_str );
							// 	$lastLogin_str = date( 'd/m/Y', $lastLogin_str );
							// } else {
							// 	$lastLogin_str = 'Never';
							// }
							// $date_str 		= 'N/A';
							// $rawDate_str 	= '';
							// $record_data['spe_expiry_date-formatted'] = $record_data['spe_expiry_date'];
							// if ( $record_data['spe_expiry_date'] !== '0000-00-00' ) {
							// 	$rawDate_str = $record_data['spe_expiry_date'];
							// 	$date_str = date( get_option( 'date_format' ), strtotime( $record_data['spe_expiry_date'] ) );
							// 	$record_data['spe_expiry_date'] = date( get_option( 'date_format' ), strtotime( $record_data['spe_expiry_date'] ) );
							// } else {
							// 	$record_data['spe_expiry_date'] = '';
							// }
							// $record_data['spe_last_login']  = $lastLogin_str;
							// $record_data['spe_expiry_date-formatted'] = $date_str;
							// $record_data['spe_role-formatted'] = $roles_arr[$record_data['spe_role']];
						}
						$headers = array(
							'spe_group_id'          	=> esc_html__( 'Group ID', 'simpods-mvc' ),
							'spe_item_subject'          => esc_html__( 'Subject', 'simpods-mvc' ),
							'spe_send_type'             => esc_html__( 'Type', 'simpods-mvc' ),							
							'spe_start'            		=> esc_html__( 'Start Position', 'simpods-mvc' ),
							'spe_addresses_involved'    => esc_html__( 'Addresses Involved', 'simpods-mvc' ),
							'spe_when_emailed' 			=> esc_html__( 'When', 'simpods-mvc' ),
						);
						$edit_fields = array(
							'spe_item_subject' ,
							'spe_recipients_field',
							'spe_success',
							'spe_failed',
							'spe_user_roles',
						);
						$edit_settings = array(
							'id-prefix' => 'simpods-email',
							'action'    => admin_url( 'admin.php?page=' . self::PAGE_SLUG . '' ),
							'title'     => esc_html__( 'View Email Record', 'simpods-mvc' ),
							'view_only' => true,
						);
						echo $this->simpods_table( $headers, $records, self::PAGE_SLUG, true, $edit_fields, $edit_settings );
						?>
					</div>
					<?php 
					} else {
						echo $alert;
					}
					?>		
				</div>
			</div>
		</div>
	<?php			
	}
	/**
	 * interface_fn: retrun an panel on the Simpods theme settings
	 */
	public function panel() {
		return '';
	}
	public function email_addresses( $user_roles = array(), $users_imploded = '' ){
		$recipient	=	'';
		// get emails from role
		if( !empty( $user_roles ) ){
			$users = get_users( array( 'role__in'	=> $user_roles, ) );
			foreach ( $users as $user_obj ) {
				if( !empty( $user_obj->first_name ) || !empty( $user_obj->last_name ) ){
					$recipient .= ', ' . $user_obj->first_name . ' ' . $user_obj->last_name . ' <' . $user_obj->user_email . '>';
				} else {
					$recipient .= ', ' .  $user_obj->user_email; 
				}
			}
		}

		// extra users
		if( !empty( $users_imploded ) ){
			$user_emails	=	explode(',', $users_imploded );
			foreach ( $user_emails as $email ) {
				$email = str_replace( '<', ' <', trim( $email ) );				
				if( is_email( $email ) && strpos( $email, '|') === false ){
					$recipient .= ',' . $email ;
				} else if( substr( $email,0, 1 ) == '{' && substr( $email, -1 ) == '}' ){
					$recipient .= ',' . $email ;
				} else { 
					if( strpos( $email, '|') === false ){
						preg_match ( '/(?:"?([^"]*)"?\s)?(?:<?(.+@[^>]+)>?)/', $email, $matches ); 
						if( isset( $matches[2] ) && is_email( $matches[2] ) ){
							$recipient .= ',' . trim( $matches[1] ) . ' < ' . $matches[2] . ' >';
						} 
					} else { 
						$matches = explode('|', $email );
						if( count( $matches ) >= 2 ){
							$matches[1] = trim( $matches[1] );
							
							if( is_string( $matches[0] ) && ! is_email( $matches[0] ) && is_email( $matches[1] ) ){
								$recipient .= ',' . trim( $matches[0] ) . ' < ' . $matches[1] . ' >';								
							}
						}
						
					}
				}
			}	
		} 

		$recipient = ltrim( $recipient, ','); 
		return $recipient;
	}
	/**
	 * create the areas relationship database, important logic: each child can only have one parent
	 * Still in progress, not finished. In the future, people should be able to see the performance of emails sent in the admin.
	 */
	public function create_db( $skip_check = false ) {
		if( ! $skip_check ) {
			if ( !isset( $_GET['page'] ) || $_GET['page'] != self::PAGE_SLUG ) {
				return false;
			}		
			if ( get_option( self::DB_TABLE . '_db_version', 0 ) >= $this->database_version && array_key_exists( self::DB_TABLE, unserialize( SIMPODS_ALL_TABLES )['act_tables'] ) ) {
				return false;
			}
		}
		global $wpdb, $table_prefix;
		$columns = array(
			'spe_group_id' => array(
				'type'     => 'int(11)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),			
			'spe_item_id' => array(
				'type'     => 'int(11)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_item_slug' => array(
				'type'     => 'varchar(1000)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_item_subject' => array(
				'type'     => 'varchar(1000)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_item_from' => array(
				'type'     => 'varchar(255)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_to' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),
			'spe_cc' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),					
			'spe_bcc' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),
			'spe_content' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),
			'spe_instructions' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),			
			'spe_test_user_only' => array(
				'type'     => 'tinyint(1)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_users' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),
			'spe_user_roles' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),
			'spe_recipients_field' => array(
				'type'     => 'varchar(10)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),	
			'spe_send_type' => array(
				'type'     => 'varchar(255)',
				'settings' => 'NOT NULL',
				'default'  => 'DEFAULT "Bulk"',
			),	
			'spe_start' => array(
				'type'     => 'int(11)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),	
			'spe_how_many' => array(
				'type'     => 'int(11)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),
			'spe_addresses_involved' => array(
				'type'     => 'int(11)',
				'settings' => 'NOT NULL',
				'default'  => '',
			),											
			'spe_when_emailed' => array(
				'type'     => 'datetime',
				'settings' => 'NULL',
				'default'  => 'NULL',
			),	
			'spe_success' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),			
			'spe_failed' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),		
			'spe_summary' => array(
				'type'     => 'text',
				'settings' => '',
				'default'  => '',
			),														
		);
		$this->import_database( self::DB_TABLE, $columns );
		update_option( self::DB_TABLE . '_db_version', $this->database_version );
	}	
	/**
	 * Installs the Simpods Email pod & fields
	 * @return null
	 */
	public function install_email() {
		if( ! self::EMAIL_DEV ){
			if ( ! class_exists( 'PodsAPI' ) || ( version_compare( get_option( 'simpods_email_version', '0.0.0' ), self::EMAIL_VERSION, '>=' ) ) ) {
				return false;
			} 
		}
		global $funs;
		$pods   = array(
			'simpods_email' => array(
				'name'    => 'simpods_email',
				'label'   => esc_html__( 'Simpods Emails', 'simpods-mvc' ),
				'type'    => 'pod',
				'storage' => 'table',
				'options' => array(
					'show_in_menu'   => 1,
					'public'         => 1,
					'show_ui'        => 1,
					'menu_icon'      => 'dashicons-email-alt',
					'label_singular' => esc_html__( 'Simpods Email', 'simpods-mvc' ),
					'ui_fields_manage' => array(
						'name',
						'permalink',
						'modified',
						'id',
					),
				),
				'fields'  => array(),
			),
		);
		$fields = array(
			'simpods_email' => array(
				'name' => array(
					'name'    => 'name',
					'label'   => esc_html__( 'Name', 'simpods-mvc' ),
					'type'    => 'text',
					'options' => array(
						'required' => 1,
						'unique'   => 1,
					),
				),
				'permalink' => array(
					'name'        => 'permalink',
					'label'       => esc_html__( 'Permalink', 'simpods-mvc' ),
					'description' => esc_html__( 'Used as ID, don\'t change it after save.', 'simpods-mvc' ),
					'type'        => 'text',
					'options'     => array(
						'required' => 1,
						'unique'   => 1,
					),
				),
				'details' => array(
					'name'        => 'details',
					'label'       => esc_html__( 'Email Details', 'simpods-mvc' ),
					'description' => esc_html__( '', 'simpods-mvc' ),
					'type'        => 'simpodsheaderfield',
					'options'     => array(
						'simpodsheaderfield' => 'h1',
					),
				),
				'subject' => array(
					'name'    => 'subject',
					'label'   => esc_html__( 'Subject', 'simpods-mvc' ),
					'type'    => 'text',
					'options' => array(
						'required' => 1,
					),
				),
				'from_email' => array(
					'name'        => 'from_email',
					'label'       => esc_html__( 'From', 'simpods-mvc' ),
					'description' => esc_html__( 'The Email address to send from. Defaults to admin email if empty. Use a same domain email for HTML content.', 'simpods-mvc' ),
					'type'        => 'email',
				),
				'to_email' => array(
					'name'        => 'to_email',
					'label'       => esc_html__( 'To', 'simpods-mvc' ),
					'description' => esc_html__( 'The Email address(es) to send to. If you want to include a name in an email address, please use this format name1|email1@domain.com, name2|email2@domain.com Same to the email fields below.', 'simpods-mvc' ),
					'type'        => 'paragraph',
					'options'     => array(
										//'wysiwyg_editor' => 'cleditor',
										),
				),
				'cc' => array(
					'name'        => 'cc',
					'label'       => esc_html__( 'CC', 'simpods-mvc' ),
					'description' => esc_html__( 'Any Email address(es) to send the email to in the CC field.', 'simpods-mvc' ),
					'type'        => 'paragraph',
					'options'     => array(),
				),
				'bcc' => array(
					'name'        => 'bcc',
					'label'       => esc_html__( 'BCC', 'simpods-mvc' ),
					'description' => esc_html__( 'Any Email address(es) to send the email to in the BCC field.', 'simpods-mvc' ),
					'type'        => 'paragraph',
					'options'     => array(),
				),
				'content' => array(
					'name'        => 'content',
					'label'       => esc_html__( 'Content', 'simpods-mvc' ),
					'description' => sprintf(
						/* translators: %1$s: <code> tag, %2$s: </code> tag */
						esc_html__( 'Use the following magic fields to be replaced by dynamic values: {name} to extra the name from the emails following this format: name <email@domain.com>. {current_user_login} : current logged-in user username, {current_user_firstname} : current logged-in user firstname, {current_user_lastname} : current logged-in user last name, {current_user_display_name} : current logged-in user display name, {current_user_level} current logged-in user level, {current_user_id} : current logged-in user id, {current_user_email} current logged-in user email, {current_date_dmy} : current date in d/m/y format, {current_date_mdy} : current date in m/d/y format, {current_date_ymd} : current date in y/m/d format', 'simpods-mvc' ),
						'<code>', '</code>'
					),
					'type'        => 'wysiwyg',
					'options'     => array(),
				),
				'instructions' => array(
					'name'        => 'instructions',
					'label'       => esc_html__( 'Notes', 'simpods-mvc' ),
					'description' => esc_html__( 'This field is aiming for keeping information about how to use the email template.', 'simpods-mvc' ),
					'type'        => 'paragraph',
					'options'     => array(),
				),				
				'send_emails' => array(
					'name'        => 'send_emails',
					'label'       => esc_html__( 'Send Emails', 'simpods-mvc' ),
					'type'        => 'simpodsheaderfield',
					'options'     => array(
						'simpodsheaderfield' => 'h1',
					),
				),
				'test_user_only'                => array(
					'name'    => 'test_user_only',
					'label'   => esc_html__( 'Test User Only', 'simpods-mvc' ),
					'type'    => 'boolean',
					'options' => array(
						'boolean_format_type' => 'dropdown',
						'boolean_yes_label'   => esc_html__( 'Yes', 'simpods-mvc' ),
						'boolean_no_label'    => esc_html__( 'No', 'simpods-mvc' ),
						'default_value' => '0',
					),
				),
				'users' => array(
					'name'        => 'users',
					'label'       => esc_html__( 'Test Users', 'simpods-mvc' ),
					'description' => esc_html__( 'Separated email addresses by comma.', 'simpods-mvc' ),
					'type'        => 'paragraph',
					'options'     => array(						
					),
				),
				'user_roles' => array(
					'name' => 'user_roles',
					'label' => esc_html__( 'User Roles', 'simpods-mvc' ),
					'type' => 'pick',
					'pick_object' => 'role',
					'options' => array(
						'pick_format_type' => 'multi',
						'pick_format_multi' => 'checkbox',
						'pick_limit' => '0',
						'simpods_condition' => 'test_user_only|0',
					),
				),
				'recipients_field' => array(
					'name'        => 'recipients_field',
					'label'       => esc_html__( 'Recipients Field', 'simpods-mvc' ),
					'description' => esc_html__( 'Default to To.', 'simpods-mvc' ),
					'type'        => 'pick',
					'pick_object' => 'custom-simple',
					'options'     => array(
						'pick_custom'        => implode( "\n", array(
							'to_email|' . esc_html__( 'To', 'simpods-mvc' ),
							'cc|' . esc_html__( 'CC', 'simpods-mvc' ),
							'bcc|' . esc_html__( 'BCC', 'simpods-mvc' ),
						) ),
						'pick_format_type'   => 'single',
						'pick_format_single' => 'dropdown',
						'default_value'      => 'to_email',
					),
				),
				'send_type' => array(
					'name'        => 'send_type',
					'label'       => esc_html__( 'Send Type', 'simpods-mvc' ),
					'description' => esc_html__( 'Bulk will ignore the replacements of user details. Default to Bulk.', 'simpods-mvc' ),
					'type'        => 'pick',
					'pick_object' => 'custom-simple',
					'options'     => array(
						'pick_custom'        => implode( "\n", array(
							'Individual|' . esc_html__( 'Individual', 'simpods-mvc' ),
							'Bulk|' . esc_html__( 'Bulk', 'simpods-mvc' ),
						) ),
						'pick_format_type'   => 'single',
						'pick_format_single' => 'dropdown',
						'default_value'      => 'Bulk',
					),
				),
				'start_email_position' => array(
					'name'        => 'start_email_position',
					'label'       => esc_html__( 'Start Email Position', 'simpods-mvc' ),
					'description' => esc_html__( 'Ignore the number of email addresses found before this number.', 'simpods-mvc' ),
					'type'        => 'number',
				),				
				'how_many_each_time' => array(
					'name'        => 'how_many_each_time',
					'label'       => esc_html__( 'How Many Each Time', 'simpods-mvc' ),
					'description' => esc_html__( 'How many emails to send each time. Please consider the limitation from the server. For example, a server may only allow an bulk email message to have max 40 recipients. Default to 40 if empty.', 'simpods-mvc' ),
					'type'        => 'number',
					'options' => array(
						'pick_format_type' 	=> 'multi',
						'pick_format_multi' => 'checkbox',
						'pick_limit' 		=> '0',
						'simpods_condition' => 'send_type|Bulk|',
						'default_value'     => '40',
					),					
				),			
				// 'prepend_to_name' => array(
				// 	'name'        => 'prepend_to_name',
				// 	'label'       => esc_html__( 'Prepend To Name', 'simpods-mvc' ),
				// 	'description' => esc_html__( 'If your email address is in this format: Name <email>, the name can be used ', 'simpods-mvc' ),
				// 	'type'        => 'number',
				// 	'options' => array(
				// 		'pick_format_type' 	=> 'multi',
				// 		'pick_format_multi' => 'checkbox',
				// 		'pick_limit' 		=> '0',
				// 		'simpods_condition' => 'send_type|Bulk|',
				// 		'default_value'     => '40',
				// 	),					
				// ),						
				'magic_field_replace' => array(
					'name'        => 'magic_field_replace',
					'label'       => esc_html__( 'Magic Field Replace', 'simpods-mvc' ),
					'description' => sprintf(
						/* translators: %1$s: <code> tag, %2$s: </code> tag */
						esc_html__( 'Replace the default magic fields when values are empty. Format: %1$s{magic_field}:value%2$s, one pair per line.', 'simpods-mvc' ),
						'<code>', '</code>'
					),
					'type'        => 'paragraph',
					'options'     => array(),
				),
				'send_reports_to' => array(
					'name'        => 'send_reports_to',
					'label'       => esc_html__( 'Send Reports To', 'simpods-mvc' ),
					'description' => sprintf(						
						esc_html__( 'Default to the default admin email if empty.', 'simpods-mvc' ),
						'<code>', '</code>'
					),
					'type'        => 'email',
					'options'     => array(),
				),				
				'send_email' => array(
					'name' => 'send_email',
					'label' => esc_html__( 'Send Email', 'simpods-mvc' ),
					'type' => 'simpodsbuttonfield',
					'options' => array(
						'simpodsbuttonfield_wrap' => 'div',
						'simpodsbuttonfield_link' => '',
						'simpodsbuttonfield_link_target' => '',
					),
				),
			),
		);
		$remove = array( 'author' );
		$pod_ids = $funs->create_pods( $pods, $remove );
		$funs->create_fields( $fields, $pods, $pod_ids );
		
		if( version_compare( self::EMAIL_VERSION, '1.152.46', '<' ) ){
			
			$this->admin_pods->update_pod_options( $pod_ids, $pods ) ;
		}
		update_option( 'simpods_email_version', self::EMAIL_VERSION );
	}	

	/**
	 * Create Email templates, called when install pages and recreate pages requirement.	 
	 * 
	 * @param array $emails the email template settings. example: 
	 				$emails	= array(
							'simpods-communication-webinar-notification-to-users' => 
								array( 
									'set' =>
										array(
											'permalink'		=> 'unique-permalink',
											'name' 			=> 'esc_html__('Name', 'domain')',
											'subject' 		=> esc_html__('Subject', 'domain'),
											'from_email'	=> 'noreply@' . $domain, 
											'to_email'		=> get_bloginfo( 'admin_email' ),
											'content'		=> esc_html__('Dear {name}', 'domain'),
											'instructions'	=> esc_html__('How to use magic fields', 'domain'),
											),	
									'data_type' =>	array( '%s', '%s', '%s', '%s', '%s', '%s'	)
								),									
							);
	 */	
	public function create_emails( $emails ){	
		global $funs, $wpdb;
		
		if( isset( MVC_Admin_Factory::$act_tables[ 'pods_simpods_email' ] ) ){
			$done   = true;
			foreach( $emails as $key => $email ){
				
				$item = $funs->simpods_select( 
								array( 
									'permalink' 		=> $email[ 'set' ][ 'permalink' ],								
								),
								array( 
									'target_tb' => 'pods_simpods_email', 
									'limit'		=> 1,
								)												
							);

				// if not created
				if( count( $item ) == 0 ){

				    $inserted = $wpdb->insert(
						$wpdb->prefix . 'pods_simpods_email',
						$email[ 'set' ],
						$email[ 'data_type' ]
					);
					if( ! $inserted ){
		                $done = false;
		            }
				}  
			}

			return $done;
		} else {
			return false;
		}
	}			
} 