<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}

/**
 * Simpods MVC Login Attempts Class
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 06/07/2020
 */
class MVC_Admin_Simpods_Login_Attempts extends MVC_Admin_General {

	/* Start Simpods MVC page variables */

	// The table name to be created to hold the settings
	const MAIN_TB 		= 'simpods_login_attempts';

	const INIT_CLASS	= true;
	/* End Simpods MVC page variables */
	// database table version
	private $db_version = 1.02;



	public function __construct( $init = true ) {
		
		// carry on if it is on the right section
		if ( $init ) {

			$this->create_db();
		}

	}

	/**
	 * WordPress actions to hook when the admin controller is loaded
	 * @return null
	 */
	public function actions() {}

	/**
	 * WordPress filters to hook when the admin controller is loaded
	 * @return null
	 */
	public function filters() {}

	/**
	 * Create the database for this area
	 * @return null
	 */
	public function create_db() {
		if ( get_option( self::MAIN_TB . '_version', 0 ) >= $this->db_version && array_key_exists( self::MAIN_TB, unserialize( SIMPODS_ALL_TABLES )['act_tables'] ) ) {
			return;
		}

		$db_columns 		=   array(
			'ip'		=> array(
				'type'		=> 'varchar(50)',
				'settings'	=> 'NOT NULL',
				'default'	=> '',
			),
			'attempts'		=> array(
				'type'		=> 'int(11)',
				'settings'	=> 'NOT NULL',
				'default'	=> '',
			),			
			'date'		=> array(
				'type'     => 'datetime',
   				'settings' => 'NOT NULL',
   				'default'	=> 'DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP',
			),								
		);	


		$this->import_database( self::MAIN_TB, $db_columns );

		update_option( self::MAIN_TB . '_version', $this->db_version );

	}

}
