<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Parent Cross site class
 *
 * @version: 2.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 26/02/2013
 */
class MVC_Front_Parent_Cross_Site extends MVC_Front_General {
	public $message_css_class  	= '';
	public $messages 			= '';
	public $excluded_types    	= array(
										'attachment',
										'revision',
										'nav_menu_item',
										'custom_css',
										'customize_changeset',
										'_pods_template',
									);
	public function __construct( $can_init = true ) {
		if ( $can_init ) {
			
		}
	}
	public function actions() {
		
	}
	public function filters() {}
	public function enqueue() {}
	final public function init() {
		$this->force_cur_page_id();
		$this->force_actions();
		$this->force_filters();
	}
	final public function defer_scripts() {
		global $funs;
		// When the defer scripts setting is set to true, add a section to defer the script
		if ( !empty( $funs->settings ) && isset( $funs->settings['style_defer_scripts'] ) && $funs->settings['style_defer_scripts'] == '1' ) {
			remove_action( 'wp_head', 'wp_print_scripts' );
			remove_action( 'wp_head', 'wp_print_head_scripts', 9 );
			remove_action( 'wp_head', 'wp_enqueue_scripts', 1 );
			add_action( 'wp_footer', 'wp_print_scripts', 5 );
			add_action( 'wp_footer', 'wp_enqueue_scripts', 5 );
			add_action( 'wp_footer', 'wp_print_head_scripts', 5 );
		}
	}
	final public function for_ajax() {
		global $funs;
		$tables								= $funs->get_tables();
		MVC_Front_Factory::$act_tables     	= $tables['act_tables']; //array_merge( $tables['act_tables'], $tables['act_pod_tables'] ) ;
   		MVC_Front_Factory::$act_pod_tables 	= $tables['act_pod_tables'];
	}
	final private function force_actions() {		
		//add_action( 'wp_enqueue_scripts', array( $this, 'force_cur_page_id' ), 0 );
		add_action( 'wp_enqueue_scripts', array( $this, 'library_enqueue' ), 8 );
		add_action( 'wp_enqueue_scripts', array( $this, 'simpods_enqueue' ), 9 );
		// page specificed loaded after other scripts for the page, to localize variables, create an action to do wp_enqueue_scripts at lv 11 in that page's controller
		add_action( 'wp_enqueue_scripts', array( $this, 'page_specific_enqueue' ), 11 );
		add_action( 'wp_enqueue_scripts', array( $this, 'defer_scripts' ) );
	}
	final private function force_filters() {
		add_filter( 'widget_text', 'do_shortcode' );
		//add_filter( 'script_loader_tag', array( $this, 'format_scripts' ), 10, 2 ); // caused problems to some plugins.
	}
	final public function library_enqueue() {
		if ( !in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) ) {
			$can_include_polyfill = apply_filters( 'simpods_include_polyfill', true );
			if( $can_include_polyfill ){
				wp_register_script( 'polyfill', 'https://cdn.polyfill.io/v3/polyfill.js?flags=gated&features=default' ); //https://polyfill.io/v3/polyfill.js?flags=gated&features=default
				wp_enqueue_script( 'polyfill' ); 
			}
			global $funs;
			$settings = $funs->settings;
			$files = array();
			if ( !empty( $settings ) && isset( $settings['style_include_bootstrap'] ) && is_string( $settings['style_include_bootstrap'] ) ) {
				if ( $settings['style_include_bootstrap'] == 'bs3' ) {
					$files['bootstrap-js']  = SIMPODS_MVC_URL . '/library/js/bootstrap-3/js/bootstrap.min.js';
					$files['bootstrap-css'] = SIMPODS_MVC_URL . '/library/js/bootstrap-3/css/bootstrap.min.css';
				} else
				if ( $settings['style_include_bootstrap'] == 'bs4' ) {
					// $files['popper-js']     = '/mvc/library/js/popper/popper.min.js';
					$files['bootstrap-js']  = SIMPODS_MVC_URL . '/library/js/bootstrap-4/js/bootstrap.bundle.min.js';
					$files['bootstrap-css'] = SIMPODS_MVC_URL . '/library/js/bootstrap-4/css/bootstrap.min.css';
				}
			} else {
				$files['bootstrap-js']  = SIMPODS_MVC_URL . '/library/js/bootstrap-4/js/bootstrap.bundle.min.js';
				$files['bootstrap-css'] = SIMPODS_MVC_URL . '/library/js/bootstrap-4/css/bootstrap.bundle.min.css';
			}
			if ( !empty( $settings ) && isset( $settings['style_include_fontawesome'] ) && is_string( $settings['style_include_fontawesome'] ) ) {
				if ( $settings['style_include_fontawesome'] == 'fa4' ) {
					$files['font-awesome'] = SIMPODS_MVC_URL . '/library/css/font-awesome-4/css/font-awesome.min.css';
				} else
				if ( $settings['style_include_fontawesome'] == 'fa5-css' ) {
					$files['font-awesome'] = SIMPODS_MVC_URL . '/library/css/font-awesome-5/css/all.css';
				} else
				if ( $settings['style_include_fontawesome'] == 'fa5-css-shims' ) {
					$files['font-awesome']       = SIMPODS_MVC_URL . '/library/css/font-awesome-5/css/all.css';
					$files['font-awesome-shims'] = SIMPODS_MVC_URL . '/library/css/font-awesome-5/css/v4-shims.css';
				} else
				if ( $settings['style_include_fontawesome'] == 'fa5-js' ) {
					$files['font-awesome'] = SIMPODS_MVC_URL . '/library/js/font-awesome-5/js/all.js';
				} else
				if ( $settings['style_include_fontawesome'] == 'fa5-js-shims' ) {
					$files['font-awesome']       = SIMPODS_MVC_URL . '/library/js/font-awesome-5/js/all.js';
					$files['font-awesome-shims'] = SIMPODS_MVC_URL . '/library/js/font-awesome-5/js/v4-shims.js';
				}
			} else {
				$files['font-awesome'] = SIMPODS_MVC_URL . '/mvc/library/css/font-awesome-5/css/all.min.css';
			}
			if ( !empty( $settings ) && isset( $settings['style_include_match_height'] ) ) {
				if ( !empty( $settings ) || $settings['style_include_match_height'] ) {
					$files['match-height'] = SIMPODS_MVC_URL . '/library/js/match-height/match-height.min.js';
				}
			}
			$files = apply_filters( 'simpods_library_enqueue', $files );
			$funs->include( $files );
		}
	}
	final public function simpods_enqueue() {
		global $funs;
		$files = array(
			'sim-font'            	=> SIMPODS_MVC_URL . '/css/simpods-font.css',
			'general-default'  		=> '/mvc/js/default.js', // rewritable
			'simpods-helpers' 		=> SIMPODS_MVC_URL . '/library/css/simpods-helpers/simpods-helpers.min.css',
			'general-theme-style' 	=> '/mvc/css/style-theme.css', // rewritable
		);
		$depths = array(
			'js'  => MVC_Front_Factory::$scripts,
			'css' => MVC_Front_Factory::$styles,
		);
		$depths = $funs->include( $files, true, $depths );
		MVC_Front_Factory::$scripts = $depths['js'];
		MVC_Front_Factory::$styles  = $depths['css'];
		wp_localize_script(
			'general-default',
			'ajax_script',
			array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'nonce'   => wp_create_nonce( 'nice-day' ),
			)
		);
		wp_localize_script(
			'general-default',
			'site_url',
			trailingslashit( site_url() )
		);
	}
	/**
	 * automatically load the js and css for the current template
	 * @return null
	 */
	final public function page_specific_enqueue() {
		global $page_info, $funs;
		$id =	get_queried_object_id();
		if( $id != 0 ){
			MVC_Front_Factory::$current_page_id		=	$id;
			MVC_Front_Factory::$current_term_id		=	$id;
			MVC_Front_Factory::$current_author_id	=	$id;
			MVC_Front_Factory::$current_tag_id		=	$id;
		}
		$depths = array(
			'js'  => MVC_Front_Factory::$scripts,
			'css' => MVC_Front_Factory::$styles,
		);
		$slug 			= $page_info['slug'];
		$slug 			= preg_replace( '/.*?\//', '', $slug );
		$slug 			= str_replace( '.php', '', $slug );
		$plugin_name 	= '';
		if( isset( $page_info['plugin'] ) ){
			$plugin_name = $page_info['plugin'] . '-';
		}
		$files = array(
			$plugin_name . $slug . '' => $page_info['css'],			
		);		
		$depths = $funs->include( $files, true, $depths );
		$files = array(			
			$plugin_name . $slug . ''  => $page_info['js'],
		);		
		$depths = $funs->include( $files, true, $depths );		
		MVC_Front_Factory::$scripts = $depths['js'];
		MVC_Front_Factory::$styles  = $depths['css'];
	}
	/**
	 * Formats the script tag of enqueued scripts.
	 * @param  string $tag    The script tag to be echoed to the page
	 * @param  string $handle The "name" of the script enqueued
	 * @return string
	 */
	final public function format_scripts( $tag, $handle ) {
		// Add the handle to the script tag
		//$tag = str_replace( ' src', ' id=' . $handle . ' src', $tag );
		if( ! empty( $handle ) && strpos( $tag, ' id=' ) === false ) {
			$handle = esc_attr( $handle );
			if( strpos( $tag, 'src="' ) !== false ){ // this tag use double quotation marks
				$tag = str_replace( ' src', ' id="' . $handle . '" src', $tag );
			} else {
				if( strpos( $tag, "src='" ) !== false ){ // this tag use single quotation marks
					$tag = str_replace( " src", " id='" . $handle . "' src", $tag );
				}
			}
		}		
		return $tag;
	}
	/**
	 * initialize the message for the action
	 * @param  string the message
	 * @param  string $css_class     class name
	 * @return null
	 */
	final public function init_message( $messages, $css_class = 'notice-info' ) {
		$this->messages = $messages;
		add_action( 'wp_footer', array( $this, 'render_message' ) );
	}
	/**
	 * render the message
	 * @return null
	 */
	final public function render_message() {
		echo '<div id="simpods-controller-display" class="' . $this->message_css_class . ' pdt5 pdr10 pdb5 pdl10" style="position:absolute; z-index: 100000; top:50px; background: #fff; colour:#333; width:100%">';
		if ( isset( $this->messages['original_ctrl'] ) && $this->messages['original_ctrl'] != '' ) {
			echo '<strong>' . $this->messages['original_label'] . '</strong>' . $this->messages['original_ctrl'] . '<br/>';
		}
		echo '<strong>' . $this->messages['current_label'] . '</strong>' . $this->messages['current_ctrl'] . '<br/>';
		echo '</div>';
	}
	/**
	 * function get_theme_menu_fn: pass in a menu location and it will return the menu object
	 *
	 * @para (string) $location theme location of a menu
	 * @return (object) menu object
	 */
	public function get_theme_menu( $location ) {
		$locations = get_nav_menu_locations();
		if ( !isset( $locations[ $location ] ) ) {
			return false;
		}
		$menu_term = get_term( $locations[ $location ], 'nav_menu' );
		if ( !$menu_term ) {
			$menu_term = false;
		}
		return $menu_term;
	}
	/**
	 * Returns a specified, formatted, bootstrap menu
	 * @param  string  $location Which menu to return
	 * @param  string  $nav_css_class Any classes to add to the nav tag
	 * @param  boolean $can_separate      Whether to separate the nav into just the nav & toggle or not (default true)
	 * @param  array   $skip_items     Any items to skip
	 * @return string/array
	 */
	public function bootstrap_menu( $location, $nav_css_class = '', $can_separate = true, $skip_items = array(), $nav_brand = '' ) {
		global $current_user, $funs;
		$settings 		= $funs->settings;
		$menu   		= '';
		$menu_id 		= 'bootstrap_' . $location . '_nav';
		$toggle_html 	= '';
		$menu_term  	= $this->get_theme_menu( $location );
		if ( !$menu_term || !is_object( $menu_term ) || !property_exists( $menu_term, 'term_id' ) ) {
			return;
		}
		if ( !is_array( $settings ) || !isset( $settings['style_include_bootstrap'] ) || $settings['style_include_bootstrap'] == 'no' ) {
			return;
		}
		$items = wp_get_nav_menu_items( $menu_term->term_id );
		$toggle_icon = '';
		if ( is_array( $settings ) && isset( $settings['style_include_fontawesome'] ) && $settings['style_include_fontawesome'] !== 'no' ) {
			if ( $settings['style_include_fontawesome'] == 'fa4' ) {
				$toggle_icon = '<i class="fa fa-bars fa-fw" aria-hidden="true"></i>';
			} else {
				$toggle_icon = '<i class="fas fa-bars fa-fw"></i>';
			}
		}
		if ( $settings['style_include_bootstrap'] == 'bs4' ) {
			if ( $nav_css_class == '' ) {
				$nav_css_class = 'navbar-expand-lg navbar-light bg-light';
			}
			$toggle_html = '<button type="button" class="navbar-toggler ml-auto" data-toggle="collapse" data-target="#' . $menu_id . '" aria-controls="' . $menu_id . '" aria-expanded="false" aria-label="' . esc_html__( 'Toggle navigation', 'simpods-mvc' ) . '">' . $toggle_icon . '</button>';
		} else {
			if ( $nav_css_class == '' ) {
				$nav_css_class = 'navbar-default';
			}
			$toggle_html = '<button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#' . $menu_id . '" aria-expanded="false"><span class="sr-only">' . esc_html__( 'Toggle navigation', 'simpods-mvc' ) . '</span>' . $toggle_icon . '</button>';
		}
		if ( !$can_separate ) {
			$menu .= '<nav class="navbar ' . $nav_css_class . '">';
			if ( $nav_brand !== '' ) {
				$menu .= '<a class="navbar-brand" href="' . home_url() . '">' . $nav_brand . '</a>';
			}
			$menu .= $toggle_html;
		}
		$menu .= '<div class="collapse navbar-collapse" id="' . $menu_id . '">';
		if ( $settings['style_include_bootstrap'] == 'bs4' ) {
			$menu .= '<ul class="navbar-nav" id="' . $location . '_men">';
		} else {
			$menu .= '<ul class="nav navbar-nav" id="' . $location . '_men">';
		}
		$menus = array();
		foreach ( $items as $menu_item ) {
			if ( isset( $skip_items['id'] ) && in_array( $menu_item->object_id, $skip_items['id'] ) ) {
				continue;
			}
			if ( isset( $skip_items['url'] ) && in_array( $menu_item->url, $skip_items['url'] ) ) {
				continue;
			}
			
			$id                      	= $menu_item->ID;
			$url                     	= $menu_item->url;
			$menus[ $id ]           	= $menu_item;
			$menus[ $id ]->children 	= false;
			$menus[ $id ]->parent   	= true;
			if ( $menu_item->menu_item_parent != 0 ) {
				$parent_id = $menu_item->menu_item_parent;
				$menus[ $id ]->parent = false;
				if ( !is_array( $menus[ $parent_id ]->children ) ) {
					$menus[ $parent_id ]->children = array();
				}
				$menus[ $parent_id ]->children[] = array(
					'id'  => $id,
					'url' => $url,
				);
			}
		}
		foreach ( $menus as $id => $menu_item ) {
			if ( !$menu_item->parent ) {
				continue;
			}
			$menu .= $this->loop_menu( $menu_item, $menus, $location );
		}
		$menu .= '</ul>';
		$menu .= '</div>';
		if ( !$can_separate ) {
			$menu .= '</nav>';
		}
		if ( !$can_separate ) {
			return $menu;
		} else {
			return array( 'toggle' => $toggle_html, 'main' => $menu, 'menu_details' => $menu_term  );
		}
	}
	/**
	 * Returns menu items to add to the menu
	 * @param  object  $menu_item     The menu item
	 * @param  array   $menus     The full menu array
	 * @param  string  $location The menu being returned
	 * @param  string  $submenu_css_class      The class for the submenu (not including the bootstrap defaults)
	 * @param  integer $level       What "level" the item is on
	 * @return string
	 */
	public function loop_menu( $menu_item, $menus, $location, $submenu_css_class = 'submenu', $level = 1 ) {
		global $current_user, $funs;
		$settings 			= $funs->settings;
		$html 				= '';
		$link_text 			= $menu_item->title;
		$url      			= $menu_item->url;
		$li_id 				= $location . '_nav_' . $menu_item->object_id;
		$li_cass_class   	= 'menu-item standard-menu menu-item-' . $menu_item->object_id . ' lv' . $level;
		$link_cass_class 	= 'lv' . $level . '_url';
		$link_extra   		= '';
		$before      		= '';
		$before_css_class 	= '';
		$before_extra 		= '';
		$after       		= '';
		$after_class  		= '';
		$after_extra  		= '';
		if ( $settings['style_include_bootstrap'] == 'bs4' ) {
			if ( $level == 1 ) {
				$li_cass_class .= ' nav-item';
				$link_cass_class .= ' nav-link';
			} else
			if ( $level > 1 ) {
				$li_cass_class .= ' dropdown-item';
			}
		}
		if ( !empty( $menu_item->classes ) ) {
			$li_cass_class .= ' ' . implode( ' ', $menu_item->classes );
		}
		if ( $menu_item->target == '' ) {
			$menu_item->target = '_self';
		}
		$link_extra .= ' target="' . $menu_item->target . '"';
		if ( $menu_item->attr_title !== '' ) {
			$link_extra .= ' title="' . $menu_item->attr_title . '"';
		}
		global $wp;
		$this_url = trailingslashit( home_url( $wp->request ) );
		if ( is_array( $menu_item->children ) && !empty( $menu_item->children ) ) {
			$li_cass_class .= ' menu-item-has-children dropdown';
			if ( $url == '' || $url == '#' ) {
				$link_cass_class .= ' dropdown-toggle';
				$link_extra .= ' role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"';
			} else {
				if ( $settings['style_include_bootstrap'] == 'bs4' ) {
					$link_text .= ' <span class="dropdown-toggle mgl4"></span>';
				}
			}
			if ( $settings['style_include_bootstrap'] == 'bs3' ) {
				$link_text .= ' <span class="caret"></span>';
			}
			foreach ( $menu_item->children as $childInfo_arr ) {
				if ( trailingslashit( $childInfo_arr['url'] ) == $this_url ) {
					$li_cass_class .= ' current_parent active';
					break;
				}
			}
		}
		if ( $url == $this_url ) {
			$li_cass_class .= ' current_item active';
		}
		$html .= '<li id="' . $li_id . '" class="' . $li_cass_class . '">';
		$html .= '<div class="before' . $before_css_class . '"' . $before_extra . '>' . $before . '</div>';
		$html .= '<a href="' . $url . '" class="' . $link_cass_class . '"' . $link_extra . '>';
		$html .= $link_text;
		$html .= '</a>';
		$html .= '<div class="after' . $after_class . '"' . $after_extra . '>' . $after . '</div>';
		if ( is_array( $menu_item->children ) && !empty( $menu_item->children ) ) {
			$dropdownClass_str = $submenu_css_class . ' dropdown-menu mgt0';
			$html .= '<ul class="' . $dropdownClass_str . '" id="drop-' . $menu_item->object_id . '">';
			foreach ( $menu_item->children as $childInfo_arr ) {
				$child_int = $childInfo_arr['id'];
				$html .= $this->loop_menu( $menus[$child_int], $menus, $location, $submenu_css_class . '_' . $submenu_css_class, ( $level + 1 ) );
			}
			$html .= '</ul>';
		}
		$html .= '</li>';
		return $html;
	}
	/**
	 * cur_page_id_fn: assign current page id to MVC_Front_Factory::$current_page_id,
	 * considering abandoning. The ids are set by page_specific_enqueue()
	 *
	 * @var (array) MVC_Front_Factory::$current_page_id static variable to save the current page id
	 */
	final public function force_cur_page_id() {
		global $wpdb, $wp_post_types;
		// Page ID is not avalible in CLI mode
		if ( 'cli' == PHP_SAPI ){
			return;
		}
		// if $_GET['p'] is there, use it as it is the default wp variable to pass page id
		if ( isset( $_GET['p'] ) && is_numeric( $_GET['p'] ) ) {
			MVC_Front_Factory::$current_page_id = $_GET['p'];
			return;
		}
		$site_url = str_replace( array( 'http://' . $_SERVER['SERVER_NAME'], 'https://' . $_SERVER['SERVER_NAME'] ), '', site_url() );
		$slug = str_replace( $site_url, '', $_SERVER['REQUEST_URI'] );
		$slug = str_replace( array( 'http://' . $_SERVER['SERVER_NAME'], 'https://' . $_SERVER['SERVER_NAME'] ), '', $slug );
		// remove from #comment-page-
		if ( strpos( $slug, '/page/' ) !== false ) {
			$slug = substr( $slug, 0, strpos( $slug, '/page/' ) ) . '/';
		}
		// remove from #comment-page-
		if ( strpos( $slug, '/comment-page-' ) !== false ) {
			$slug = substr( $slug, 0, strpos( $slug, 'comment-page-' ) ) . '/';
		}
		// remove pages like 2
		preg_match( '/\/[0-9]+\//', $slug, $matches_arr, PREG_OFFSET_CAPTURE );
		if ( count( $matches_arr ) > 0 && isset( $matches_arr[0][1] ) && is_numeric( $matches_arr[0][1] ) ) {
			$slug = substr( $slug, 0, $matches_arr[0][1] ) . '/';
		}
		$url_exploded = explode( '?', $slug );
		// remove first slash
		if ( substr( $url_exploded[0], 0, 1 ) == '/' ) {
			$url_exploded[0] = substr( $url_exploded[0], 1, -1 );
		}
		// remove last slash
		if ( substr( $url_exploded[0], -1, 1 ) == '/' ) {
			$url_exploded[0] = substr( $url_exploded[0], 0, -1 );
		}
		$slug_exploded = explode( '/', $url_exploded[0] );
		// if not the home page
		$page = false;
		if ( $slug_exploded[count( $slug_exploded ) - 1] != '' ) {
			// construct page path
			$page_path 	= implode( '/', $slug_exploded );
			$page     	= get_page_by_path( $page_path );
			if ( $page ) {
				MVC_Front_Factory::$current_page_id = $page->ID;
			} else {
				$post_types = get_post_types();
				$found 		= false;
				foreach ( $post_types as $key => $post_type_data ) {
					if ( !in_array( $key, $this->excluded_types ) ) { // if the post type is not a post type for a template
						$page = get_page_by_path( $slug_exploded[count( $slug_exploded ) - 1], OBJECT, $key );
						if ( $page ) {
							//if the wordpress link is the same as the url, it is the right one
							if ( isset( $_SERVER['REQUEST_SCHEME'] ) && get_permalink( $page->ID ) == $_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"] ) {
								MVC_Front_Factory::$current_page_id = $page->ID;
								$found                        = true;
								break;
							}
						}
					}
				}
				//author
				if ( count( $slug_exploded ) == 2 && $slug_exploded[0] == 'author' ) {
					$user = get_user_by( 'slug', $slug_exploded[1] );
					if ( $user ) {
						MVC_Front_Factory::$current_author_id = $user->ID;
					}
				}
				// if not found, try to use the last second one as tag
				if ( !$found && count( $slug_exploded ) == 2 ) {
					$this->get_taxonomy();
					if ( MVC_Front_Factory::$current_term_id != 0 ) {
						$found = true;
					}
				}
				// if not found, try to use the last second one as the post type
				if ( !$found && count( $slug_exploded ) >= 2 ) {
					$page = get_page_by_path( $slug_exploded[count( $slug_exploded ) - 1], OBJECT, $slug_exploded[count( $slug_exploded ) - 2] );
					if ( $page ) {
						$found  = true;
						MVC_Front_Factory::$current_page_id = $page->ID;
					} else {
						// if not found, replace - to _, as Pods create post types with _
						$page = get_page_by_path( $slug_exploded[count( $slug_exploded ) - 1], OBJECT, str_replace( '-', '_', $slug_exploded[count( $slug_exploded ) - 2] ) );
						if ( $page ) {
							$found  = true;
							MVC_Front_Factory::$current_page_id = $page->ID;
						}
					}
				}

			}
		}
		if ( $slug_exploded[0] == '' && !is_404() ) {
			$home_page_id = get_option( 'page_on_front' );
			if ( get_option( 'show_on_front' ) == 'page' ) {
				if ( is_numeric( $home_page_id ) && $home_page_id ) {
					MVC_Front_Factory::$current_page_id = $home_page_id;
				} else {
					MVC_Front_Factory::$current_page_id = get_option( 'page_for_posts' );
				}
			}
		}
	}
	/**
	 * function get_taxonomy_fn: return taxonomy template file names
	 */
	final public function get_taxonomy( $attributes = array() ) {
		if ( '' == $_SERVER['REQUEST_URI'] ) {
			return NULL;
		}
		global $wpdb;
		$filters =  wp_parse_args( 
			$attributes,
			array(
			'template' => true,
		) );
		$url = $_SERVER['REQUEST_URI'];
		if ( strpos( $_SERVER['REQUEST_URI'], '?' ) !== false ) {
			$url = substr( $url, 0, strpos( $_SERVER['REQUEST_URI'], '?' ) );
		}
		if ( strpos( $url, '#' ) !== false ) {
			$url = substr( $url, 0, strpos( $url, '#' ) );
		}
		$url_exploded 	= explode( '/', $url );
		$count 			= count( $url_exploded );
		if ( $url_exploded[ $count  - 1] == '' ) {
			$slug   = $url_exploded[ $count - 2 ];
			$tax_idx = 3;
		} else {
			$slug   = $url_exploded[ $count - 1 ];
			$tax_idx = 2;
		}
		$tax = $url_exploded[ $count - $tax_idx ];
		if ( $tax == 'tag' ) {
			$tax = 'post_tag';
		}
		// pods use underscore by default instead of dash
		$pod_tax 	= str_replace( '-', '_', $tax );
		$query 		= $wpdb->prepare( 'SELECT tt_tb.`taxonomy` AS `taxonomy`, t_tb.`term_id` AS `term_id` FROM `' . $wpdb->prefix . 'terms` AS t_tb INNER JOIN `' . $wpdb->prefix . 'term_taxonomy` AS tt_tb ON tt_tb.`term_id` = t_tb.`term_id` WHERE t_tb.`slug` = "%s" AND tt_tb.`taxonomy` in ( "%s", "%s" ) LIMIT 0, 1;', array( $slug, $tax, $pod_tax ) );
		$items 		= $wpdb->get_results( $query, ARRAY_A );
		if ( $items ) {
			MVC_Front_Factory::$current_term_id = $items[0]['term_id'];
		}
		if ( $filters['template'] ) {
			$slug = $items ? 'taxonomy-' . $items[0]['taxonomy'] . '.php' : false;
			if ( $slug == 'taxonomy-category.php' ) {
				// if it is the wp default post cateogry, use category instead
				$slug = 'category.php';
			}
			if ( $slug == 'taxonomy-post_tag.php' ) {
				// if it is the wp default post cateogry, use category instead
				$slug = 'tag.php';
			}
			return $slug;
		} else {
			return $items ? $items[0] : false;
		}
	}
	/**
	 * Return an ID of an attachment by searching the database with the file URL.
	 *
	 * First checks to see if the $url is pointing to a file that exists in
	 * the wp-content directory. If so, then we search the database for a
	 * partial match consisting of the remaining path AFTER the wp-content
	 * directory. Finally, if a match is found the attachment ID will be
	 * returned.
	 *
	 * http://frankiejarrett.com/get-an-attachment-id-by-url-in-wordpress/
	 *
	 * @return {int} $attachment
	 */
	public function get_attachment_image_by_url( $url ) {
		// Split the $url into two parts with the wp-content directory as the separator.
		$parse_url = explode( parse_url( WP_CONTENT_URL, PHP_URL_PATH ), $url );
		// Get the host of the current site and the host of the $url, ignoring www.
		$this_host = str_ireplace( 'www.', '', parse_url( home_url(), PHP_URL_HOST ) );
		$file_host = str_ireplace( 'www.', '', parse_url( $url, PHP_URL_HOST ) );
		// Return nothing if there aren't any $url parts or if the current host and $url host do not match.
		if ( !isset( $parse_url[1] ) || empty( $parse_url[1] ) || ( $this_host != $file_host ) ) {
			return;
		}
		// Now we're going to quickly search the DB for any attachment GUID with a partial path match.
		// Example: /uploads/2013/05/test-image.jpg
		global $wpdb;
		$prefix     = $wpdb->prefix;
		$attachment = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM " . $prefix . "posts WHERE guid RLIKE %s;", $parse_url[1] ) );
		// Returns null if no attachment is found.
		return $attachment[0];
	}
	/**
	 * process data if the current page required login
	 */
	public function login_required( $redirect_url = '' ) {
		global $current_user, $wpdb;
		// check if login required
		$login_required = pods_field( 'page', MVC_Front_Factory::$current_page_id, 'login_required', false );
		// if no data saved, it will be an empty array
		if ( !is_numeric( $login_required ) ) {
			$login_required = 0;
		}
		$role_checked = true;
		if ( $login_required && !is_user_logged_in() ) {
			// if not logged in, redirect to home
			$role_checked = false;
			if ( filter_var( $redirect_url, FILTER_VALIDATE_URL ) ) {
				wp_redirect( $redirect_url );
			} else {
				wp_redirect( site_url() );
			}
			exit;
		}
		if ( is_user_logged_in() ) {
			// if count( $current_user->roles ) == 0 , and the user is not registered to the site
			if ( count( $current_user->roles ) == 0 ) {
				// if yes, check if the user is allowed to access the app, if allowed, assign the user to the app
				foreach ( MVC_Front_Factory::$blogs as $blog_data ) {
					if ( $blog_data['blog_id'] == get_current_blog_id() ) {
						$passed = false;
						// if it is the app's main page and the app allows auto registration, add the app to the user
						if ( $blog_data['users_can_reg'] == 1 ) {
							// if users don't have to receive inviations to register
							if ( $blog_data['users_by_invitation'] == 0 ) {
								$siteID_str = $blog_data['blog_id'] == 1 ? '' : $blog_data['blog_id'] . '_';
								// default to subscriber
								$role_arr = array( 'subscriber' => 1 );
								update_user_meta( $current_user->ID, $wpdb->base_prefix . $siteID_str . 'capabilities', $role_arr );
								update_user_meta( $current_user->ID, $wpdb->base_prefix . $siteID_str . 'user_level', 0 );
								$current_user->roles = array_keys( $role_arr );

								$passed  = true;
							} else {
								// if it has to be invited, redirect to sign up page
								if ( get_page_by_path( 'sign-in' ) != MVC_Front_Factory::$current_page_id ) {
									$role_checked = false;
									wp_redirect( get_permalink( get_page_by_path( 'sign-in' ) ) );
									exit;
								}
							}
						} else {
							$passed = true;
						}
						if ( !$passed ) {
							if ( !isset( $blog_data['cur_user_level'] ) || !$blog_data['cur_user_level'] == '' || !is_array( $blog_data['cur_user_caps'] ) || ( is_array( $blog_data['cur_user_caps'] ) && count( $blog_data['cur_user_caps'] ) == 0 ) ) {
							}
						}
						break;
					}
				}
			}
		}
		$this->roles_required();
	}
	public function roles_required() {
		global $current_user;
		$roles_imploded = pods_field( 'page', MVC_Front_Factory::$current_page_id, 'roles_required', false );
		if ( is_array( $roles_imploded ) || is_null( $roles_imploded ) || $roles_imploded == '' ) {
			return false;
		}
		$roles = explode( ',', $roles_imploded );
		$roles = array_map( 'trim', $roles );
		if ( empty( $roles ) ) {
			return false;
		}
		if ( !is_user_logged_in() ) {
			return false;
		}
		if ( !in_array( $current_user->roles[0], $roles ) ) {
			wp_redirect( site_url() );
			exit;
		}
	}
	/**
	 * day_diff_fn: days and time difference
	 *
	 * @para string $datetime_a example: 2014-10-11 11:12:11
	 * @para string $datetime_b example: 2014-10-11 11:12:11
	 * @return datatime object
	 * @since 09/09/2014
	 */
	public static function day_diff( $datetime_a, $datetime_b ) {
		$date = new DateTime( $datetime_a );
		$now  = new DateTime( $datetime_b );
		return $date->diff( $now );
	}
}
