<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Factory for frontend, collection of static functions and variables
 * for generic purpose, such as processing math or array
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 05/08/2014
 */
class MVC_Front_Parent_Factory {
	// save all files included by this theme
	// include all main classes for child classes
	public static $cross_blog   		= '';
	public static $order_table  		= 'simpods_orders';
	public static $roles_OKs     		= array();
	public static $menus       			= array();
	public static $current_page_id   	= 0;
	public static $current_tag_id    	= 0;
	public static $current_term_id   	= 0;
	public static $current_author_id 	= 0;
	public static $clone_id     		= 0;
	public static $is_mobile    		= false;
	public static $pages       			= array();
	public static $options     			= array();
	public static $styles      			= array();
	public static $scripts     			= array( 'jquery', 'jquery-touch-punch' );
	public static $php_files    		= array();
	public static $act_tables     		= array(); // details  of pods tables
	public static $act_pod_tables  		= array();
	public static $table_pack     		= 'wp';
	public static $included   			= array();
	public static $load_img_src 		= '';
	public static $messages   			= array();
	public static $blogs      			= array();
	private static $main_classes 		= array( 'mvc-front-general', 'mvc-front-parent-cross-site' );
	private static $models      		= array();
	// Include all classes
	public static $classes 	= array();
	// Classes need to initialise
	private static $core_init 	= array();
	public static $init_classes 	= array();
	final public static function build( $class_to_build = '' ) {
		global $funs, $wp_filesystem; 
		$tables          		= unserialize( SIMPODS_ALL_TABLES );
		self::$act_tables    	= $tables['act_tables']; //array_merge( $tables['act_tables'], $tables['act_pod_tables'] ) ;
		self::$act_pod_tables 	= $tables['act_pod_tables'];
		$main_classes = self::$main_classes;
		// allow people to include a parent class
		$main_classes = apply_filters( 'front_parent_factory_main_classes', $main_classes );
		foreach ( $main_classes as $name_str ) {
			// Include main classes first, before loading the child classes
			$file = $funs->get_final_path( 'mvc/models/', strtolower( $name_str ) . '.class.php', 0, 0, 1 );
			if ( ! empty( $file ) ) { // get_final_path_fn already checks if it exists or not
				include_once $file;
			}
		}
		self::$init_classes = apply_filters( 'simpods_mvc_front_init_classes', self::$init_classes );
		self::$init_classes = array_merge( self::$core_init, self::$init_classes );
		self::$init_classes = array_unique( self::$init_classes );
		self::$classes 	= Simpods_Autoload::$classes;
		foreach ( self::$classes as $class ) {
			$init_class = in_array( $class, self::$init_classes ) || ( defined( $class . '::INIT_CLASS' ) && $class::INIT_CLASS == true );
			if ( get_parent_class( $class ) == 'MVC_Front_General' && $class_to_build != $class && $init_class ) {
				// if extended by the general class and not the main one, run the class with init
				$GLOBALS[ $class . '' ] = new $class(); // Give auto instantiated classes names to reduce potential re-instantiations
			}
		}
		$class_built	= '';
		if ( class_exists( $class_to_build ) ) {
			$class_built = new $class_to_build();
			return $class_built;
		}
	}
}
