<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Pods Header field class
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 22/11/2018
 */
class MVC_Front_Pods_Header_Field extends MVC_Front_General {
	const PAGE_SLUG  = 'simpods-header-field';
	const FIELD = 'simpodsheaderfield';
	public static $page_title = 'Pods Header Field';
	/**
	 * Constructor
	 * @param Boolean $can_init toggle to run the functions in the constructor
	 */
	public function __construct( $can_init = true ) {
		self::$page_title = esc_html__( 'Pods Header Field', 'simpods-mvc' );
		// carry on if it is on the right section
		if ( $can_init ) {
			// for checking if this class is activated
			if ( !defined( 'SIMPODS_HEADER_FIELD' ) ) {
				define( 'SIMPODS_HEADER_FIELD', true );
			}
			$this->actions();
			$this->filters();
		}
	}
	public function actions() {
		add_action( 'init', array( $this, 'register' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue' ) );
	}
	public function filters() {}
	public function enqueue() {
		global $funs;
		$files = array(
			'pods-header-field-css' => '/mvc/admin/css/pods_header_field.min.css',
		);
		$funs->include( $files, false );
	}
	/**
	 * Initializes the MVC_Front_Pods_Header_Field() class
	 *
	 * Checks for an existing MVC_Front_Pods_Header_Field() instance
	 * and if it doesn't find one, creates it.
	 *
	 * @since 1.0.0
	 */
	public static function init() {
		static $this_cla = false;
		if ( !$this_cla ) {
			$this_cla = new self( false );
		}
		return $this_cla;
	}
	/**
	 * Registers class, if Pods is active.
	 *
	 * @since 1.0.0
	 */
	public function register() {
		// if ( defined( 'PODS_VERSION' ) ) {
		// 	$GLOBALS['MVC_Admin_Pods_Header_Field'] = self::init();
		// }
		if ( function_exists( 'pods_register_field_type' ) ) {
			pods_register_field_type( self::FIELD, SIMPODS_MVC_DIR . '/admin/models/pods-fields/podsfield-' . self::FIELD . '.php' );
		}
	}
}
