<?php

if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}

/**
 * Simpods Guest Accounts Front class
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Andrew Palfrey
 * @since: 06/06/2017
 */
class MVC_Front_Simpods_Guest_Accounts extends MVC_Front_General {

	const DB_TABLE = 'simpods_guest_accounts';

	public function __construct( $can_init = true ) {

		// carry on if it is on the right section

		if ( $can_init ) {

			$this->actions();
			$this->filters();
			$this->guest_user_check();
		}

	}

	public function actions() {}

	public function filters() {}

	public function enqueue() {}

	/**
	 * Checks whether an account is a guest account, is active and not expired. Logs the login for the user in the database
	 *
	 * @return null
	 */
	private function guest_user_check() {
		global $current_user, $wpdb, $funs;

		if ( is_user_logged_in() && get_option( self::DB_TABLE . '_version', 0 ) ) {
			$fields = array(
				'spga_user_id' => $current_user->ID,
			);
			$attributes = array(
				'target_tb' => 'simpods_guest_accounts',
			);

			$guest_info = $funs->simpods_select( $fields, $attributes );

			if ( !empty( $guest_info ) ) {
				$guest_info = $guest_info[0];

				$date = strtotime( $guest_info['spga_expiry_date'] );
				$now  = strtotime( date( 'Y-m-d' ) );

				if ( $date < $now ) {
					wp_update_user( array( 'ID' => $current_user->ID, 'role' => '' ) );
					wp_logout();
					$message = '<h1 style="text-align:center;font-family:sans-serif;">' . esc_html__( 'Your account has expired', 'simpods-mvc' ) . '</h1>';
					exit( print_r( $message, true ) );
				} else {
					$table       = $wpdb->prefix . self::DB_TABLE;
					$update_info = array(
						'spga_last_login' => date( 'Y-m-d' ),
					);
					$wheres = array(
						'spga_user_id' => $current_user->ID,
					);

					$funs->general_update( $table, $update_info, $wheres );

					update_user_meta( $current_user->ID, 'last_login', date( 'Y-m-d' ) );
				}

			} else {
				update_user_meta( $current_user->ID, 'last_login', date( 'Y-m-d' ) );
			}

		}

	}

}

//new MVC_Front_Simpods_Guest_Accounts();
