<?php

if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}

/**
 * Simpods Linked Areas class
 *
 * @version: 2.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 14/08/2014
 */
class MVC_Front_Simpods_Linked_Areas extends MVC_Front_General {

	public function __construct( $can_init = true ) {

		// carry on if it is on the right section

		if ( $can_init ) {
			$this->actions();
			$this->filters();
		}

	}

	public function actions() {}

	public function filters() {}

	public function enqueue() {}

	/**
	 * Gets items from a category
	 *
	 * @param string  $tb_str        The category table to pull from
	 * @param unknown $category_table_id     The category table id. It could be pod id or posts, users
	 * @param integer $category_id     The category ID
	 * @param array   $attributes      Some attributes of what to pull
	 * @param boolean $can_echo_query Echo the query on screen
	 * @param boolean $can_prefix  If true, prefixes table names with the WordPress table prefix (default true)
	 * @return array Array of found rows. If there are none, the array will be empty.
	 */
	public function cat_items( $table, $category_table_id, $category_id, $attributes = array(), $can_echo_query = false, $can_prefix = true ) {
		global $wpdb;

		$attributes =  wp_parse_args(
			$attributes,
			array(
				'order'    => 'ASC',
				'order_by' => '',
				'group_by' => '',
				'start'    => 0,
				'limit'    => 0,
			)
			
		);

		$params = array();

		$where = ' AND `sp_linked_areas` REGEXP "(:\"' . esc_sql( $category_table_id ) . '.' . intval( $category_id ) . '\";{1,})"';

		$table = esc_sql( $table );

		if ( $can_prefix ) {
			$table = $wpdb->prefix . $table;
		}

		if ( count( $params ) > 0 ) {
			$query = $wpdb->prepare( 'SELECT
										 *
										 FROM ' . $table . '
										 WHERE 1 = 1 ' . $where . ' ', $params );
		} else {
			$query = 'SELECT
										 *
										 FROM ' . $table . '
										 WHERE 1 = 1 ' . $where . ' ';
		}

		if ( $can_echo_query ) {
			echo $query;
		}

		$items = $wpdb->get_results( $query, ARRAY_A );

		return $items;
	}

}
