<?php
if ( preg_match( '#' . basename( __FILE__ ) . '#', $_SERVER['PHP_SELF'] ) ) {exit( 'You are not allowed to call this page directly.' );}
/**
 * Login attempt class
 *
 * @version: 1.0.0
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 06/07/2020
 */
class MVC_Front_Simpods_Login_Attempts extends MVC_Front_General {

	const MAIN_TB 		= 'simpods_login_attempts';
	/**
	 * Constructor
	 * @param Boolean $can_init toggle to run the functions in the constructor
	 */
	public function __construct( $can_init = true ) {
		// carry on if it is on the right section
		if ( $can_init ) {

		}

	}

	public function actions() {

	}

	public function filters() {}

	public function enqueue() {

	}

	/**
	 * get an attempt
	 */ 
	public function fetch( $fields = array() ){
		global $funs;

		$defaults = array(
						'ip' 	=> $_SERVER['REMOTE_ADDR'],								
					);
		// Parse incoming $args into an array and merge it with $defaults
		$fields = wp_parse_args( $fields, $defaults );

		$attrs  = array( 
					'target_tb' => self::MAIN_TB,
					);

		$existed_items 	= $funs->simpods_select( $fields, $attrs );

		if( !empty( $existed_items ) ){
			return $existed_items[0];
		}
		return array();
	}
	/**
	 * register an attempt
	 */
	public function register(){
		global $funs;
		$success 	= false;
		$fields = array(
						'ip' 	=> $_SERVER['REMOTE_ADDR'],								
					);

		$attrs  = array( 
					'target_tb' => self::MAIN_TB,
					);

		$existed_items 	= $funs->simpods_select( $fields, $attrs );

		$fields['date']	= date( 'Y-m-d H:i:s' );			
		if( empty( $existed_items ) ){
			$fields['attempts'] = 1;
			$success 	= $funs->general_insert( self::MAIN_TB, $fields );
		} else {
			$fields['attempts'] = $existed_items[0]['attempts'] + 1;
			$where 	= array(	
							'id' => $existed_items[0]['id']
						);
			$success 	= $funs->general_update( self::MAIN_TB, $fields, $where );
		}

		return $success;
	}

	public function remove( $attrs ){
		global $wpdb;
		$defaults = array(
						'ip' 			=> '',					
						);

		// Parse incoming $args into an array and merge it with $defaults
		$attrs = wp_parse_args( $attrs, $defaults );

		$query 		= $wpdb->prepare( 'DELETE FROM `' . $wpdb->prefix . self::MAIN_TB . '` WHERE `ip` = %s' , array_values( $attrs ) );
		$success 	=  $wpdb->query( $query );

		return $success;
	}	
}

