<?php
/** 
 * @package Simpods MVC
 * @author Dongjie Xu
 * @since 20/05/2015
 */
global $funs, $cross_admin, $ctrl, $cross_ctrl;

$file = SIMPODS_MVC_DIR . '/admin/models/mvc-admin-parent-factory.class.php'; 
if( $wp_filesystem->exists( $file ) ){ 
	include_once $file;
}
$_SESSION['remote_ip'] = $_SERVER['REMOTE_ADDR'];
$component_plugins = SIMPODS_COMPONENT_PLUGINS;
if ( !empty( $component_plugins ) ) {
	foreach( $component_plugins as $plugin_name => $plugin_details ){
		if( !empty( $plugin_details['admin'] ) && !empty( $plugin_details['admin']['model'] ) ){
			$component_plugin_classes = array_map( 'strtolower', array_keys( $plugin_details['admin']['model'] ) ); // Please use INIT_CLASS = true in your class instead.			
			MVC_Admin_Factory::$init_classes = array_merge( MVC_Admin_Factory::$init_classes, $component_plugin_classes );
		}
	}
}
// Files to load for components
// $component_load = SIMPODS_COMPONENTS;
// if ( !empty( $component_load ) && !empty( $component_load['admin'] ) && !empty( $component_load['admin']['model'] ) ) {
// 	$component_class = array_map( 'strtolower', array_keys( $component_load['admin']['model'] ) );
// 	MVC_Admin_Factory::$init_classes = array_merge( MVC_Admin_Factory::$init_classes, $component_class );
// }
if( get_parent_class( 'MVC_Admin_Factory' ) != 'MVC_Admin_Parent_Factory' ){
	esc_html_e( 'MVC_Admin_Factory should extend MVC_Admin_Parent_Factory', 'simpods-mvc');
	die();
}
// create the instance of the corse site class
$cross_admin = MVC_Admin_Factory::build( 'MVC_Admin_Cross_Admin' );
$parent_controllers = array(
	'controller'    => SIMPODS_MVC_DIR . '/admin/control/ctrl-mvc-admin-controller.php',
	'simpods-cross' => SIMPODS_MVC_DIR . '/admin/control/ctrl-mvc-admin-simpods-cross-admin.php',	
	'cross-simpods' => SIMPODS_MVC_DIR . '/admin/control/ctrl-mvc-admin-simpods-parent-cross-simpods.php',
);
// $funs->include( $parent_controllers, false, array(), true );
foreach( $parent_controllers as $key => $file ){	
	if( $wp_filesystem->exists( $file ) ){ 
		include_once $file;
	}	
}
$child_controllers = array(
	'cross-admin'   => '/mvc/admin/control/ctrl-mvc-admin-cross-admin.php',
	'cross-simpods' => '/mvc/admin/control/ctrl-mvc-admin-simpods-cross-simpods.php',
);
$funs->include( $child_controllers, true, array(), true );
if ( !defined( 'DOING_AJAX' ) ) {	
	$GLOBALS['cross_ctrl'] = new Ctrl_MVC_Admin_Cross_Admin();
	$GLOBALS['admin_ctrl'] = new Ctrl_MVC_Admin_Simpods_Cross_Admin();
}
// if simpods- prefix is found, load crose simpods controller. Controllers Priority: cross admin > cross simpods > specific page
if ( isset( $_REQUEST[ 'page' ] ) && ! empty( $_REQUEST[ 'page' ] ) && substr( $_REQUEST[ 'page' ], 0, 8 ) === 'simpods-' ) {
	if ( !defined( 'DOING_AJAX' ) ) {
		$GLOBALS['simpods_ctrl'] = new Ctrl_MVC_Admin_Simpods_Cross_Simpods();
		$GLOBALS['simpods_ctrl']->init();
	}
}
// Include component cross admin controllers
if ( !empty( $component_load ) && !empty( $component_load['admin'] ) && !empty( $component_load['admin']['ctrl'] ) ) {
	$funs->include( $component_load['admin']['ctrl'], true, array(), true );
}
// load simpods component plugin controllers
$plugin_load = array(
	'where' => 'admin',
	'type' 	=> 'ctrl',
);	
//Load Simpods plugin files. This function only load registered ajax and controller files from 'simpods_component_plugins'		
$funs->load_simpods_plugin_files( $plugin_load );	
$controller_found    	= false;
$controller_slug      	= '';
$controller_name       = '';
if ( MVC_Admin_Factory::$post_type != '' ) {
	$controller_found = true;
	$controller_name  = MVC_Admin_Factory::$post_type;
}
if ( isset( $_GET['page'] ) ) {
	$controller_found = true;
	$controller_name  = esc_attr( $_GET['page'] );

}
if ( !$controller_found ) {
	// if not post type or page. load the a page with the same php name
	preg_match( '/\/wp-admin\/([^\/]+)\.php/i', $_SERVER['PHP_SELF'], $file_match );
	if ( isset( $file_match[1] ) && trim( $file_match[1] ) != '' ) {
		$controller_found = true;
		$controller_name  = esc_attr( $file_match[1] );		
	}
}
if ( !$controller_found ) {
	// if not post type or page. load the a page with the same php name
	preg_match( '/\/wp-admin\/network\/([^\/]+)\.php/i', $_SERVER['PHP_SELF'], $file_match );
	if ( isset( $file_match[1] ) && trim( $file_match[1] ) != '' ) {
		$controller_found = true;
		$controller_name  = esc_attr( $file_match[1] );		
	}
}

$controller_slug  = 'ctrl-mvc-admin-' . $controller_name . '.class.php';//Backward compatibility before 3.0.0
if ( ! wp_doing_ajax() ) {
	$_GLOBALS['cur_admin_page'] = $controller_name;
	if ( !headers_sent() ) {
		if (session_status() == PHP_SESSION_NONE) {
			//@session_save_path('/tmp');
		    @session_start();
		}
		$_SESSION['cur_admin_page'] = $controller_name;
		session_write_close();
	}
}
//Backward compatibility before 3.0.0
MVC_Admin_Factory::$short_controller_slug = str_replace( array( 'ctrl-mvc-admin-', '.class.php' ), array( '','' ), $controller_slug );
$custom_ctrl = new Simpods_Controllers( false );
$ctrl_lookup = $custom_ctrl->look_up();
$location 		= sprintf(
					esc_html__( '%1$s Plugin: Simpods MVC  %2$s', 'simpods-mvc' ),
					'<strong> -',
					'</strong>'
				);
$file        = '';
if ( $ctrl_lookup ) {
	//overwrited by custom ctrl
	$controller_slug = $ctrl_lookup;
	$is_url 		 = false;
	$is_relative 	 = false;
	$is_multisites_ignored = true;
	$file            = $funs->get_final_path( 'mvc/admin/control', $controller_slug, $is_url, $is_relative, $is_multisites_ignored );
	$location        = sprintf(
		esc_html__( '%1$s Custom %2$s', 'simpods-mvc' ),
		'<strong> -',
		'</strong>'
	);
} else {
	
	/* allow users to relocate the controller */
	// with the full name before version 2.0.1
	$controller_slug  = apply_filters( 'simpods_admin_ctrl_slug', 'ctrl-mvc-admin-' . $controller_name . '.class.php' );
	// with exact name since 2.0.1
	$controller_name  = apply_filters( 'simpods_admin_ctrl_name', $controller_name );	
	//since 2.0.1, controller file names with $controller_name.php has higher priority than ctrl_mvc_admin_$controller_name.class.php.
	$full_file_info = $funs->get_final_path( '/mvc/admin/control', $controller_slug, 0, 0, 0, 1 );
	$full_file      = $full_file_info['path'];	
	$file_info      = $funs->get_final_path( '/mvc/admin/control', $controller_name . '.php', 0, 0, 0, 1 );
	$file           = $file_info['path'];
	if ( ( $wp_filesystem->exists( $full_file ) && !$wp_filesystem->is_dir( $full_file ) ) && ( !$wp_filesystem->exists( $file ) || $wp_filesystem->is_dir( $file ) ) ) { // if the file with the short name not there but the full name one exists, use the full name one
		$file_info = $full_file_info;
		$file      = $full_file;
	}
	if( $file_info['where'] == 'child' ){
		$location = sprintf(
			esc_html__( '%1$s Child theme %2$s', 'simpods-mvc' ),
			'<strong> -',
			'</strong>'
		) ;
	}
	if( $file_info['where'] == 'parent' ){
		$location = sprintf(
			esc_html__( '%1$s Parent theme %2$s', 'simpods-mvc' ),
			'<strong> -',
			'</strong>'
		);
	}

	if( $file_info['where'] == 'plugin' ){
		$location = sprintf(
			esc_html__( '%1$s Plugin: Simpods MVC  %2$s', 'simpods-mvc' ),
			'<strong> -',
			'</strong>'
		);
	}	
}

$simpods_admin_ctrl_info = $file;
// child theme first
if ( $wp_filesystem->exists( $file ) && $controller_slug != '' && !$wp_filesystem->is_dir( $file ) ) {
	include_once $file;
	if ( class_exists( 'Ctrl' ) ) {
		$ctrl             = new Ctrl();
		$simpods_admin_ctrl_info = $file;
	} else {
		$simpods_admin_ctrl_info = sprintf(
			esc_html__( '%1$s %2$s Not a controller class %3$s', 'simpods-mvc' ),
			$file,
			'<strong>',
			'</strong>'
		);
	}
	//$simpods_admin_ctrl_info .= $location;
} else {
	$not_found = true;
	$simpods_admin_ctrl_info = sprintf(
		esc_html__( '%1$s %2$s Not found %3$s', 'simpods-mvc' ),
		$file,
		'<strong>',
		'</strong>'
	);	

	//$simpods_admin_ctrl_info .= $location;		
}

if ( is_array( $component_plugins ) ) {
	require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	foreach ( $component_plugins as $plugin_name => $v_arr ) {
		if( is_plugin_active( $plugin_name . '/' . $plugin_name . '.php' ) ){ 
			$main_controller = '';
			if ( isset( $_GET['page'] ) ) { 
				if( $plugin_name == $_GET['page'] ){ //auto-load plugin page specific controller, this one is the main one initialised with $ctrl					
					$full_file = ABSPATH . 'wp-content/plugins/' . $plugin_name . '/mvc/admin/control/ctrl-mvc-admin-' . $plugin_name . '.class.php';
					$file      = ABSPATH . 'wp-content/plugins/' . $plugin_name . '/mvc/admin/control/' . $plugin_name . '.php';
					if ( ( $wp_filesystem->exists( $full_file ) && !$wp_filesystem->is_dir( $full_file ) ) && ( !$wp_filesystem->exists( $file ) || $wp_filesystem->is_dir( $file ) ) ) { // if the file with the short name not there but the full name one exists, use the full name one						
						$file = $full_file;
					}
					if ( $wp_filesystem->exists( $file ) && $controller_slug != '' && !$wp_filesystem->is_dir( $file ) ) {
						$main_controller = $file;
						include_once $file;
						$ctrl           = new Ctrl();
						$simpods_admin_ctrl_info = $file;
						$not_found          = false;
						$location           = sprintf(
							esc_html__( '%1$s Plugin %2$s', 'simpods-mvc' ),
							'<strong> -',
							'</strong>'
						);
					}
					if ( $not_found ) {
						$simpods_admin_ctrl_info = sprintf(
							esc_html__( '%1$s %2$s Not found %3$s', 'simpods-mvc' ),
							$file,
							'<strong>',
							'</strong>'
						);
					}
					$simpods_admin_ctrl_info .= $location;			
				} 
				//break;
			} 
			
			// Load the same page controllers from plugins, namespace required
			$full_file = ABSPATH . 'wp-content/plugins/' . $plugin_name . '/mvc/admin/control/' . $controller_slug;
			$file      = ABSPATH . 'wp-content/plugins/' . $plugin_name . '/mvc/admin/control/' . $controller_name . '.php';
			if ( ( $wp_filesystem->exists( $full_file ) && !$wp_filesystem->is_dir( $full_file ) ) && ( !$wp_filesystem->exists( $file ) || $wp_filesystem->is_dir( $file ) ) ) { // if the file with the short name not there but the full name one exists, use the full name one			
				$file 		= $full_file;
			}		
			if ( $main_controller != $file && $wp_filesystem->exists( $file ) && $controller_slug != '' && !$wp_filesystem->is_dir( $file ) ) {

				include_once $file;
				$namespace 	= str_replace( '-', '_', $plugin_name ); // use plugin_name as namespace. Namespace doesn't take dash
				$ref 		= $namespace . '\Ctrl';		
				if ( class_exists( $ref ) ) { 	
					$location   = sprintf(
						esc_html__( '%1$s Plugin: %2$s %3$s', 'simpods-mvc' ),
						'<strong> -',
						$plugin_name,
						'</strong>'
					);					
					//	plugin_name_current_controller_name. Note it is underscore	
					$ref_name	=	$namespace . '_' . str_replace( '-', '_', $controller_name );
					$reflection  = new ReflectionClass( $ref );
					$class_valid = !$reflection->isAbstract() && !$reflection->isInterface() && $reflection->isInstantiable();
					if ( $class_valid ) {
						$GLOBALS[ $ref_name ] = new $ref();
					}						
					
					$simpods_admin_ctrl_info .= '<br/><strong>' . esc_html__( 'Simpods - Current controller path: ' ) . '</strong> ' . sprintf(
						esc_html__( '%1$s %2$s %3$s', 'simpods-mvc' ),
						$file,
						'<strong>',
						'</strong>'
					);	
				} 
				$simpods_admin_ctrl_info .= $location;
			}	
			
		}	
	}	
}
/**
 * Allow controllers with the same name, especially for third parties 
 * for which different components may load a controler with the same name. 
 * Namespace is recommended, if not please use prefix to the class name 
 * e.g. prefix_Ctrl to avoid same class name clash. In your interface function, 
 * access it by $your_class = new namespace\Ctrl;
 * @param array $same_name_controllers array( array('slug' => 'new path to the controller' ), ... )
 * @param string $controller_name the current controller name e.g. page, simpods-mvc
 */ 
$same_name_controllers  = array();
$same_name_controllers  = apply_filters( 'simpods_admin_multiple_controllers', $same_name_controllers, $controller_name );	
if( is_array( $same_name_controllers ) && count( $same_name_controllers ) > 0 ){
	$location   = sprintf(
				esc_html__( '%1$s Multiple Controllers filter %2$s', 'simpods-mvc' ),
				'<strong> -',
				'</strong>'
			);		
	foreach ( $same_name_controllers as $k => $controller ) {
		if( is_array( $controller ) && isset( $controller['slug'] ) ){
			$file_info      = $funs->get_final_path( 'mvc/admin/control', $controller['slug'], 0, 0, 0, 1 );	
			$file           = $file_info['path'];
			
			if ( $wp_filesystem->exists( $file ) ) { 
				include_once $file;
				$simpods_admin_ctrl_info .= '<br/><strong>' . esc_html__( 'Simpods - Multiple controllers path: ' ) . '</strong> ' . sprintf(
					esc_html__( '%1$s %2$s %3$s', 'simpods-mvc' ),
					$file,
					'<strong>',
					'</strong>'
				);					
			} else {
				$simpods_admin_ctrl_info .= '<br/><strong>' . esc_html__( 'Simpods - Multiple controllers path: ' ) . '</strong> ' . sprintf(
					esc_html__( '%1$s %2$s Not found %3$s', 'simpods-mvc' ),
					$file,
					'<strong>',
					'</strong>'
				);					
			}
			$simpods_admin_ctrl_info .= $location;
		}
	}
}
if ( get_option( 'spcc_disable' ) != 1 && get_option( 'spcc_admin_show_ctrl' ) ) {
	switch ( get_option( 'spcc_admin_show_ctrl' ) ) {
	case 1:
		$cross_admin->init_message( $simpods_admin_ctrl_info );
		break;
	case 2:
		if ( current_user_can( 'simpods_edit_custom_controllers' ) ) {
			$cross_admin->init_message( $simpods_admin_ctrl_info );
		}
		break;
	default:
		break;
	}
}