<?php
/** 
 * @package: Simpods MVC
 * @author: Dongjie Xu
 * @since: 20/05/2015
 */
$files_loaded = true;
// global variables to use
global $funs, $cross_site;

$file = SIMPODS_MVC_DIR . '/models/mvc_front_parent_factory.class.php';

if( $wp_filesystem->exists( $file ) ){ 
	include_once $file;
} 
// $front_factory = array(
// 	'mvc_front_factory' => SIMPODS_MVC_URL . '/models/mvc_front_factory.class.php',
// );
// $funs->include( $front_factory, true, array(), true );
if ( $files_loaded ) {
	if( get_parent_class( 'MVC_Front_Factory' ) != 'MVC_Front_Parent_Factory' ){
		esc_html_e( 'MVC_Front_Factory should extend MVC_Front_Parent_Factory', 'simpods-mvc');
		die();
	}
	// create the instance of the corse site class
	$cross_site = MVC_Front_Factory::build( 'MVC_Front_Cross_Site' );
	$cross_site->init();
	// load controllers, no overwrite allowed
	$controllers = array(
		'mvc_front_controller_ctrl'      	=> SIMPODS_MVC_DIR . '/control/ctrl-mvc-front-controller.php',
		'mvc_front_simpods_controller_ctrl' => SIMPODS_MVC_DIR . '/control/ctrl-mvc-front-simpods-cross-site.php',
	);
	//$files_included = $funs->include( $controllers, false, array(), true );
	foreach( $controllers as $key => $file ){	
		if( $wp_filesystem->exists( $file ) ){ 
			include_once $file;
		}	
	}	
	if ( !defined( 'DOING_AJAX' ) ) {
		$GLOBALS['simpods_cross_ctrl'] = new Ctrl_Simpods_Cross_Sites();
	}	
	// load controllers
	$files = array(
		'mvc_front_cross_site_ctrl' => '/mvc/control/ctrl-mvc-front-cross-site.php',
	);
	$files_included = $funs->include( $files, true, array(), true );	
	if ( !defined( 'DOING_AJAX' ) ) {
		$GLOBALS['cross_ctrl'] = new Ctrl_Cross_Sites();
	}
	
	if ( count( $files_included['php'] ) >= 2 ) {
		if ( !in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) && !( defined( 'DOING_AJAX' ) && DOING_AJAX ) ) {

			$plugin_load = array(
				'where' => 'front',
				'type'  => 'ctrl'
			);
			$funs->load_simpods_plugin_files( $plugin_load ); // registered only.
		}
		/**
		 * load_control_fn: load controller of a template
		 *
		 */
		global $page_info;
		$page_info = array(
			'slug'       => '',
			'controller' => '',
			'css'        => '',
			'js'         => '',
		);
		// Do the filter as early as possible, in case it is integrated with a third party theme and the template got altered
		add_filter( 'template_include', 'simpods_custom_controller', 1 );
	}
}
/**
 * Include the current page's relevant controller
 *
 * @param string $template The current page's template path
 * @return string The current page's template path
 */
function simpods_custom_controller( $template ) {

	global $page_info, $funs, $ctrl, $blog_ctrl, $cross_site, $wp_filesystem;
	$current_label = '<strong>' . esc_html__( 'Simpods - Current controller path: ' ) . '</strong> ';
	$messages  = array(
		'original_label' => esc_html__( 'Simpods - Original controller path: ', 'simpods-mvc' ),
		'current_label'  => '',
		'original_ctrl'  => '',
		'current_ctrl'   => '',
	);
	$location  = '';
	$is_custom = false;
	// overwrite by custom controllers
	$custom_ctrl = new Simpods_Controllers( false );
	$ctrl_lookup = $custom_ctrl->look_up();
	if ( $ctrl_lookup ) {
		$is_custom = true;
		$page_info = array(
			'slug'       => $ctrl_lookup,
			'page'       => $ctrl_lookup,
			'controller' => '/mvc/control/' . $ctrl_lookup,
			'css'        => '/mvc/css/' . str_replace( '.php', '.css', $ctrl_lookup ),
			'js'         => '/mvc/js/' . str_replace( '.php', '.js', $ctrl_lookup ),
		);
		$location  = sprintf(
			esc_html__( '%1$s Custom %2$s', 'simpods-mvc' ),
			'<strong> -',
			'</strong>'
		);
	}
	$template_base = '';
	$plugin_files = array(
		'control' => '',
		'css' => '',
		'js' => '',
	);
	if ( !$is_custom ) {
		$template_base = str_replace( trailingslashit( get_stylesheet_directory() ), '', $template );
		$template_base = str_replace( trailingslashit( get_template_directory() ), '', $template_base );
		// Allow components to load single controllers
		$template_base = apply_filters( 'simpods_controller_include', $template_base );

		if ( stripos( $template_base, WP_PLUGIN_DIR ) === 0 ) { // this is a plugin template
			$file = $template_base;

			$plugin_uri = WP_PLUGIN_DIR . '/';
			$plugin_file = str_replace( $plugin_uri, '', $file );
			$file_parts = explode( '/', $plugin_file );
			$copy_parts = $file_parts;
			unset( $copy_parts[ 0 ] );
			$template_by_plugin = '/mvc/control/' . implode( '/', $copy_parts );
			//$controller = 
			$plugin_files = array(
				'control' => '',
				'css' => '',
				'js' => '',
			);
			foreach ( $plugin_files as $type => &$file_name ) {
				$parts = $file_parts;
				$parts[0] .= '/mvc/' . $type;
				$file_name = $plugin_uri . implode( '/', $parts );
			}
			
			// $page_info used as a global variable in page_specific_enqueue() in mvc_front_parent_cross_site.class.php
			$page_info = array(
				'slug'       => basename ( $template_base ),
				'plugin'	 => $file_parts[0],
				'page'       => basename ( $template_base ),
				'controller' => $plugin_files['control'],
				'css'        => ltrim( str_replace( WP_CONTENT_URL, WP_CONTENT_DIR,  str_replace( '.php', '.css', $plugin_files['css'] ) ), '/'),
				'js'         => ltrim( str_replace( WP_CONTENT_URL, WP_CONTENT_DIR,  str_replace( '.php', '.js', $plugin_files['js'] ) ), '/'),
			);		
		} else {
			$page_info = array(
				'slug'       => $template_base,
				'page'       => $template_base,
				'controller' => '/mvc/control/' . $template_base,
				'css'        => '/mvc/css/' . str_replace( '.php', '.css', $template_base ),
				'js'         => '/mvc/js/' . str_replace( '.php', '.js', $template_base ),
			);
			$template_by_plugin = $page_info['controller'];
		}
	}
	if ( !wp_doing_ajax() ) {
		$_GLOBALS['current_template'] = $page_info['slug'];
		if ( !headers_sent() ) {
			if ( session_status() == PHP_SESSION_NONE ) {
				@session_save_path('/tmp');
			    @session_start();
			}
			$_SESSION['current_template'] = $page_info['slug'];
			session_write_close();
		}
	}		
	// Component plugins are loaded here before the component so the plugins can influces the component's controller with filters and actions, as they need to be registered before applying in the component
	$component_plugins = SIMPODS_COMPONENT_PLUGINS; 

	if ( is_array( $component_plugins ) ) {
 
		foreach ( $component_plugins as $plugin_folder => $details ) {
			// Load the same page controllers from plugins, namespace required
			$plugin_file = ABSPATH . 'wp-content/plugins/' . $plugin_folder . $template_by_plugin; ;
			
			// if ( stripos( $page_info['controller'], WP_PLUGIN_DIR ) === 0 ) { // The template is from a plugin, avoid the same plugin		
			// 	$controller_by_plugin = ABSPATH . 'wp-content/plugins/' . $plugin_folder . $template_by_plugin; 
				
			// 	if( $page_info['controller'] != $controller_by_plugin ){
			// 		$plugin_file = $controller_by_plugin;
			// 	}
			// } else { // The controller is theme based
			// 	$plugin_file      = ABSPATH . 'wp-content/plugins/' . $plugin_folder . $page_info['controller'];		
			// }
			
			if ( $plugin_file != '' && $wp_filesystem->exists( $plugin_file ) && !$wp_filesystem->is_dir( $plugin_file ) ) {
				include_once $plugin_file; 
				$namespace 	= str_replace( '-', '_', $plugin_folder ); // use plugin_name as namespace. Namespace doesn't take dash
				$ref 		= $namespace . '\Ctrl';		

				if ( class_exists( $ref ) ) { 	
					$location   = sprintf(
						esc_html__( '%1$s Plugin: %2$s %3$s', 'simpods-mvc' ),
						'<strong> -',
						$plugin_folder,
						'</strong>'
					);					
					$name_with_folder = str_replace( array( '-', '/' ), '_', $page_info['slug'] );
					$name_with_folder = substr( $name_with_folder, 0, strpos( $page_info['slug'], '.' ) );
					//	plugin_name_current_controller_name. Note it is underscore.	
					$ref_name	=	'' . $namespace . '_' . $name_with_folder . '_ctrl';
					
					$GLOBALS[ $ref_name ] = new $ref();
					$messages['current_ctrl'] .= $current_label . sprintf(
						esc_html__( '%1$s %2$s %3$s', 'simpods-mvc' ),
						$plugin_file,
						'<strong>',
						'</strong>'
					);	
				} 
				$messages['current_ctrl'] .= $location . '<br/>';
			}		
		}	
	}
	// if ( stripos( $template_base, WP_PLUGIN_DIR ) === 0 ) { // this is a plugin file

	// 	$file = $plugin_files['control'];
	// 	if ( !is_dir( $template_base ) ) {
	// 		$location = sprintf(
	// 			esc_html__( '%1$s Plugin: %2$s %3$s', 'simpods-mvc' ),
	// 			'<strong> -',
	// 			$file_parts[0],
	// 			'</strong>'
	// 		);
	// 	}
	// } else {

	$file_info = $funs->get_final_path( '', $page_info['controller'], false, false, false, true ); 
	$file      = $file_info['path'];
	if ( !is_dir( $file_info['path'] ) && !$is_custom ) {
		if( $file_info['where'] == 'child' ){
			$location = sprintf(
				esc_html__( '%1$s Child theme %2$s', 'simpods-mvc' ),
				'<strong> -',
				'</strong>'
			) ;
		}
		if( $file_info['where'] == 'parent' ){
			$location = sprintf(
				esc_html__( '%1$s Parent theme %2$s', 'simpods-mvc' ),
				'<strong> -',
				'</strong>'
			);
		}

		if( $file_info['where'] == 'plugin-simpods' ){
			$location = sprintf(
				esc_html__( '%1$s Plugin: Simpods MVC  %2$s', 'simpods-mvc' ),
				'<strong> -',
				'</strong>'
			);
		}				
		// $location = $file_info['child'] ? sprintf(
		// 	esc_html__( '%1$s Child theme %2$s', 'simpods-mvc' ),
		// 	'<strong> -',
		// 	'</strong>'
		// ) : sprintf(
		// 	esc_html__( '%1$s Parent theme %2$s', 'simpods-mvc' ),
		// 	'<strong> -',
		// 	'</strong>'
		// );
	}
	//}

	// if the controller is not from plugin, namely, from parent/child theme or simpods-mvc plugin, display the info. The plugin ones are handled above.
	if( $file_info['where'] != 'plugin' ){ 
		$messages['current_ctrl'] .= $current_label;
		if ( $file_info['found'] && $wp_filesystem->exists( $file )  ) {
			if( strpos( $file, '/mvc/control/' ) !== false ){
				include_once $file;
				if ( class_exists( 'Ctrl' ) ) {
					$ctrl = new Ctrl();
					$messages['current_ctrl'] .= $file;
				} else {
					$messages['current_ctrl'] .= sprintf(
						esc_html__( '%1$s %2$s Not a controller class %3$s', 'simpods-mvc' ),
						$file,
						'<strong>',
						'</strong>'
					);
				}
			} else {
				$messages['current_ctrl'] .= sprintf(
					esc_html__( '%1$s %2$s Not in the controller folder %3$s', 'simpods-mvc' ),
					$file,
					'<strong>',
					'</strong>'
				);
			}
		} else {
			$file_in_plugin = $file . ' <strong>' . esc_html__( 'Not found in Simpods MVC plugin', 'simpods-mvc' ) . '</strong>';	
				
			$file_in_parent = get_template_directory() . $page_info['controller'] . ' <strong>' . esc_html__( 'Not found in the theme', 'simpods-mvc' ) . '</strong>';	
			$file_in_child  = '';
			if( is_child_theme() !== false ){
					
				$file_in_child 	= get_stylesheet_directory() . $page_info['controller'] . ' <strong>' . esc_html__( 'Not found in the child theme', 'simpods-mvc' ) . '</strong>';	
			}
			
			$messages['current_ctrl'] .= '<br/>' . $file_in_plugin . '<br/>' . $file_in_parent . '<br/>' . $file_in_child;
			// $messages['current_ctrl'] .= '<br/>' . $file_in_plugin . '<br/>' . $file_in_parent . '<br/>' . $file_in_child;			
			// $messages['current_ctrl'] .= sprintf(
			// 	esc_html__( '%1$s %2$s Not found %3$s', 'simpods-mvc' ),
			// 	$file,
			// 	'<strong>',
			// 	'</strong>'
			// );
		}

		$messages['current_ctrl'] .= $location;
	}
	if ( !( defined( 'DOING_AJAX' ) && DOING_AJAX ) ) {
		// run cross blog ctrl first
		$cross_blog_path = dirname( $file ) . '/cross_blog.php';
		if ( $wp_filesystem->exists( $cross_blog_path ) ) {
			include_once $cross_blog_path;
			if ( class_exists( 'Cross_Blog_Ctrl' ) ) {
				$blog_ctrl = new Cross_Blog_Ctrl();
			}
		}
	}
	if ( get_option( 'spcc_disable' ) != 1 && get_option( 'spcc_frontend_show_ctrl' ) ) {
		
		switch ( get_option( 'spcc_frontend_show_ctrl' ) ) {
			case 1:
				$cross_site->init_message( $messages );
				break;
			case 2:
				if ( current_user_can( 'simpods_edit_custom_controllers' ) ) {
					$cross_site->init_message( $messages );
				}
				break;
			default:
				break;
		}
	}
	return $template;
}
function controller( $template ) {
	// _simpods_deprecated_message();
	return simpods_custom_controller( $template );
}
// TODO: Change naming for 3.0.0
global $site_slug, $blog_slug;
$site_slug = '';
$blog_slug = '';
if ( is_multisite() ) {
	$site_info = get_current_site();
	$site_slug = $site_info->path;
}
