<?php
/**
 * Plugin Name: Simpods MVC
 * Plugin URI:  
 * Description: Simpods MVC is a modern, flexible theme which brings the benefits of an MVC to the WordPress Content Management System. With Simpods MVC, you will be able to build any small to big projects, organising your code in WordPress is never so easy. Meanwhile, Simpods MVC comes with a lot of ready-built functionalities to facilitate your coding. 
 * Version:     3.0.0
 * Author:      Dr Dongjie Xu and the Simpods Team
 * Author URI:  
 * Text Domain: simpods-mvc
 */
 class Simpods_MVC{
    const SLUG          = 'simpods-mvc'; // with dash, for folder, file names and text domain
    const NAME          = 'simpods_mvc'; // with underscore, for variables
    const ClASS_NAME    = 'simpods_mvc'; // with underscore and capitals for classes
    const TITLE         = 'Simpods MVC'; // for titles and labels
    const VERSION       = '3.0.0';    
  
    public function __construct() {     
        $this->actions();
        $this->filters();
    }
    /**
     * Initializes
     *
     */
    public static function init() {
        $instance     = new simpods_mvc();    
        return  $instance;
    }
    public function actions(){
        add_action( 'admin_notices', array( $this, 'admin_notice_error_install_theme' ) );     
    }
    public function filters(){
        // page templates
        // add_filter ('theme_page_templates', array( $this, 'register_page_template' ) );
        // add_filter ('page_template', array( $this, 'redirect_page_template' ) );  
    }
    static function activation() {
         
    }
    static function deactivation(){
    }
    // Display an error if Simpods MVC is not installed.
 
    public function admin_notice_error_install_theme(){
    }
    // Run database check function when plugin is upated https://stackoverflow.com/questions/24187990/plugin-update-hook
    // register templates
    public function register_page_template ( $templates_arr ) {
    }
   
    public function redirect_page_template ( $template_str ) {
    }
}
/**
 * Initialize class, 
 * @since 1.0.0
 */
if( is_admin() ){ 
    add_action( 'admin_init', 'simpods_mvc_plugin_init' );
} else {
    add_action( 'init', 'simpods_mvc_plugin_init' );
}
function simpods_mvc_plugin_init() {

    $GLOBALS[ Simpods_MVC::NAME . '_plugin' ] = Simpods_MVC::init();       

}
register_activation_hook( __FILE__, array( 'simpods_mvc', 'activation' ) );
//Deactivate the plugin
register_deactivation_hook( __FILE__,  array( 'simpods_mvc', 'deactivation' ) );        
//after_setup_theme Generally used to initialize theme settings/options. This is the first action hook available to themes, triggered immediately after the active theme's functions.php file is loaded. add_theme_support() should be called here, since the init action hook is too late to add some features. At this stage, the current user is not yet authenticated. The Simpods theme version is loaded in functions.php
 add_action( 'after_setup_theme', 'load_simpods_mvc' );
 function load_simpods_mvc(){    
    global $simpods_setup;
    include_once 'mvc/simpods-load-mvc.php';  
    $simpods_setup->theme_support();
 }